Package: PRONE
Type: Package
Title: The PROteomics Normalization Evaluator
Version: 1.7.0
Authors@R: c(person("Lis", "Arend", email = "lis.arend@tum.de", role = c("aut", "cre"), comment = c(ORCID = "0000-0001-7990-8385")))
Description: High-throughput omics data are often affected by systematic biases introduced throughout all the steps of a clinical study, from sample collection to quantification. 
  Normalization methods aim to adjust for these biases to make the actual biological signal more prominent. 
  However, selecting an appropriate normalization method is challenging due to the wide range of available approaches. 
  Therefore, a comparative evaluation of unnormalized and normalized data is essential in identifying an appropriate normalization strategy for a specific data set. 
  This R package provides different functions for preprocessing, normalizing, and evaluating different normalization approaches. 
  Furthermore, normalization methods can be evaluated on downstream steps, such as differential expression analysis and statistical enrichment analysis. 
  Spike-in data sets with known ground truth and real-world data sets of biological experiments acquired by either tandem mass tag (TMT) or label-free quantification (LFQ) can be analyzed.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 4.4.0), SummarizedExperiment
Imports: dplyr, magrittr, data.table, RColorBrewer, ggplot2, S4Vectors,
        ComplexHeatmap, stringr, NormalyzerDE, tibble, limma, MASS,
        edgeR, matrixStats, preprocessCore, stats, gtools, methods,
        ROTS, ComplexUpset, tidyr, purrr, circlize, gprofiler2,
        plotROC, MSnbase, UpSetR, dendsort, vsn, Biobase, reshape2,
        POMA, ggtext, scales, DEqMS, vegan
Suggests: testthat (>= 3.0.0), knitr, rmarkdown, BiocStyle, DT
BugReports: https://github.com/daisybio/PRONE/issues
URL: https://github.com/daisybio/PRONE
VignetteBuilder: knitr
Config/testthat/edition: 3
biocViews: Proteomics, Preprocessing, Normalization,
        DifferentialExpression, Visualization
git_url: https://git.bioconductor.org/packages/PRONE
git_branch: devel
git_last_commit: cee8ec3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-07-14
NeedsCompilation: no
Packaged: 2026-07-14 23:38:40 UTC; biocbuild
Author: Lis Arend [aut, cre] (ORCID: <https://orcid.org/0000-0001-7990-8385>)
Maintainer: Lis Arend <lis.arend@tum.de>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# PRONE - The PROteomics Normalization Evaluator <img src="man/figures/PRONE_package_logo.png" align="right" alt="" width="150" />

R Package for preprocessing, normalizing, and analyzing proteomics data

## Introduction

High-throughput omics data are often affected by systematic biases
introduced throughout all the steps of a clinical study, from sample
collection to quantification. Failure to account for these biases can
lead to erroneous results and misleading conclusions in downstream
analysis. Normalization methods aim to adjust for these biases to make
the actual biological signal more prominent. However, selecting an
appropriate normalization method is challenging due to the wide range of
available approaches. Therefore, a comparative evaluation of
unnormalized and normalized data is essential in identifying an
appropriate normalization strategy for a specific data set. This R
package provides different functions for preprocessing, normalizing, and
evaluating different normalization approaches. Furthermore,
normalization methods can be evaluated on downstream steps, such as
differential expression analysis and statistical enrichment analysis.
Spike-in data sets with known ground truth and real-world data sets of
biological experiments acquired by either tandem mass tag (TMT) or
label-free quantification (LFQ) can be analyzed.

## Installation

To install the package, run:

``` r
  # Official BioC installation instructions
  if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

  BiocManager::install("PRONE")
  
  # Load and attach PRONE 
  library("PRONE")
```

If you have troubles downloading PRONE from Bioconductor, you still have
the option to install PRONE from GitHub. However, the Bioconductor
download is recommended!

``` r
  # Install PRONE.R from github and build vignettes
  if (!requireNamespace("devtools", quietly = TRUE)){
    install.packages("devtools")
  } 
  devtools::install_github("daisybio/PRONE", build_vignettes = TRUE, 
                           dependencies = TRUE)
  
  # Load and attach PRONE 
  library("PRONE")
```

## Workflow

A six-step workflow was developed in R version 4.4 to evaluate the
effectiveness of the previously defined normalization methods on
proteomics data. The workflow incorporates a set of novel functions and
also integrates various methods adopted by state-of-the-art tools.

<img src="man/figures/Workflow_PRONE.png" width="700"/>

Following the upload of the proteomics data into a SummarizedExperiment
object, proteins with too many missing values can be removed, outlier
samples identified, and normalization carried out. Furthermore, an
exploratory analysis of the performance of normalization methods can be
conducted. Finally, differential expression analysis can be executed to
further evaluate the effectiveness of normalization methods. For data
sets with known ground truth, such as spike-in and simulated data sets,
performance metrics, such as true positives (TPs), false positives
(FPs), and area under the curve (AUC) values, can be computed. The
evaluation of DE results of real-world experiments is based on visual
quality inspection, for instance, using volcano plots, and an
intersection analysis of the DE proteins of different normalization
methods is available.

## Usage

To get familiar with the functionalities of the R package, check out the
article [Getting started with
PRONE](https://daisybio.github.io/PRONE/articles/PRONE.html).

## Bioconductor Development

The branches RELEASE_* in this repository are aligned with the corresponding Bioconductor release branches. The most recent Bioconductor development is maintained on the upstream devel branch, which, upon release, is merged into a newly created upstream RELEASE_* branch. For instance, when Bioconductor version 3.22 is released, this repository’s RELEASE_3_22 branch is synchronized with the upstream devel branch until the release date. After the release, RELEASE_3_22 tracks the corresponding upstream release branch, while the upstream devel branch continues to serve as the basis for the subsequent development cycle.

## Citation

Lis Arend, Klaudia Adamowicz, Johannes R Schmidt, Yuliya Burankova, Olga Zolotareva, Olga Tsoy, Josch K Pauling, Stefan Kalkhof, Jan Baumbach, Markus List, Tanja Laske, Systematic evaluation of normalization approaches in tandem mass tag and label-free protein quantification data using PRONE, Briefings in Bioinformatics, Volume 26, Issue 3, May 2025, bbaf201, [https://doi.org/10.1093/bib/bbaf201](https://doi.org/10.1093/bib/bbaf201).

## ----- Normalization Methods ----- ##

#' Total Intensity Normalization
#'
#' Intensities of each variable in a sample are divided with the sum of intensities
#' of all variables in the sample and multiplied with the median or mean of sum of intensities
#' of all variables in all samples. Raw data should be taken as input (on_raw = TRUE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param type String whether to use median or mean to calculate the scaling factor
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#' @importFrom SummarizedExperiment assay
#'
#' @return SummarizedExperiment containing the total intensity normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- globalIntNorm(tuberculosis_TMT_se, ain = "raw",
#'                                            aout = "GlobalMedian",
#'                                            type = "median",
#'                                            on_raw = TRUE)
#'
globalIntNorm <- function(se, ain = "raw", aout="GlobalMedian", type = "median", on_raw = TRUE){
  dt <- SummarizedExperiment::assays(se)[[ain]]
  dt <- as.data.frame(dt)
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  colSums <- colSums(dt, na.rm = TRUE)
  if(type == "median"){
    colSumsM <- stats::median(colSums)
  } else if (type == "mean"){
    colSumsM <- mean(colSums)
  }
  norm_dt <- matrix(nrow = nrow(dt), ncol = ncol(dt),
                    byrow = TRUE)
  normFunc <- function(colIndex) {
    (dt[rowIndex, colIndex]/colSums[colIndex]) *
      colSumsM
  }
  for (rowIndex in seq_len(nrow(dt))) {
    norm_dt[rowIndex, ] <- vapply(seq_len(ncol(dt)),
                                  normFunc, 0)
  }
  # transform data to log2-scale if necessary
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  colnames(norm_dt) <- colnames(dt)
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}

#' Total Intensity Normalization Using the Mean for the Calculation of Scaling Factors
#'
#' Intensities of each variable in a sample are divided with the sum of intensities
#' of all variables in the sample and multiplied with the mean of sum of intensities
#' of all variables in all samples. Raw data should be taken as input (on_raw = TRUE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the total intensity normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- globalMeanNorm(tuberculosis_TMT_se, ain = "raw",
#'                               aout = "GlobalMean", on_raw = TRUE)
#'
globalMeanNorm <- function(se, ain = "raw", aout = "GlobalMean", on_raw = TRUE){
  se <- globalIntNorm(se, ain, aout, type = "mean", on_raw = on_raw)
  return(se)
}

#' Total Intensity Normalization Using the Median for the Calculation of Scaling Factors
#'
#' Intensities of each variable in a sample are divided with the sum of intensities
#' of all variables in the sample and multiplied with the median of sum of intensities
#' of all variables in all samples. Raw data should be taken as input (on_raw = TRUE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the total intensity normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- globalMedianNorm(tuberculosis_TMT_se, ain = "raw",
#'                               aout = "GlobalMedian", on_raw = TRUE)
#'
globalMedianNorm <- function(se, ain = "raw", aout = "GlobalMedian", on_raw = TRUE){
  se <- globalIntNorm(se, ain, aout, type = "median")
  return(se)
}


#' Median Normalization
#'
#' The intensity of each protein group in a given sample is divided by the median of the
#' intensities of all protein groups in that sample and then multiplied by the mean of
#' median of sum of intensities of all protein groups in all samples.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the median normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- medianNorm(tuberculosis_TMT_se, ain = "raw",
#'                           aout = "Median", on_raw = TRUE)
#'
medianNorm <- function(se, ain = "raw", aout = "Median", on_raw = TRUE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  # find median of each sample
  sample_med <- apply(dt, 2, stats::median, na.rm=TRUE) # columns
  # find mean of medians
  mean_med <- mean(sample_med, na.rm=TRUE)
  # divide data by median
  norm_dt <- t(t(dt)/sample_med)
  # multiply data by mean of medians
  norm_dt <- norm_dt * mean_med
  norm_dt <- data.table::as.data.table(norm_dt)
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  # transform data to log2-scale if necessary
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- norm_dt
  return(se)
}

#' Mean Normalization
#'
#' The intensity of each protein group in a given sample is divided by the mean of the
#' intensities of all protein groups in that sample and then multiplied by the mean of
#' mean of sum of intensities of all protein groups in all samples.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean whether normalized should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the mean normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- meanNorm(tuberculosis_TMT_se, ain = "raw",
#'                           aout = "Mean", on_raw = TRUE)
#'
meanNorm <- function(se, ain = "raw", aout="Mean", on_raw = TRUE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  # find means of each sample
  sample_mean <- apply(dt, 2, mean, na.rm=TRUE)
  # find mean of means of each sample
  mean_mean <- mean(sample_mean, na.rm=TRUE)
  # divide data by mean
  norm_dt <- t(t(dt)/sample_mean)
  # multiply data by mean of means
  norm_dt <- norm_dt * mean_mean
  norm_dt <- data.table::as.data.table(norm_dt)
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  # transform data to log2-scale if necessary
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- norm_dt
  return(se)
}

#' Internal Reference Scaling Normalization
#'
#' IRS makes different measurements of the same thing all exactly the same and puts
#' all of the intensities on the same scale. Raw data should be taken as input (on_raw = TRUE)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the IRS normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- irsNorm(tuberculosis_TMT_se, ain = "raw",
#'                                 aout = "IRS", on_raw = TRUE)
irsNorm <- function(se, ain="raw", aout="IRS", on_raw = TRUE){
  # extract necessary info of SummarizedExperiment
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  batch <- S4Vectors::metadata(se)$batch
  refs <- S4Vectors::metadata(se)$refs
  md <- data.table::as.data.table(SummarizedExperiment::colData(se))

  # get md of reference samples
  refs_md <- md[md$Column %in% refs,]
  # separate data by batch
  dt_list <- lapply(unique(md[[batch]]), function(b){
    md_chunk <- md[md[[batch]] == b,]
    dt_chunk <- subset(dt, select = md_chunk$Column)
    return(dt_chunk)
  })
  names(dt_list) <- unique(md[[batch]])
  # check if ref_samples have been specified
  if (is.null(refs)){
    # create mock channel with rowsums from each frame
    irs <- lapply(dt_list, function(dt_chunk){
      return(rowSums(dt_chunk, na.rm=TRUE))
    })
    irs <- do.call(cbind, irs)
  } else {
    # take reference sample intensities
    irs <- subset(dt, select = refs_md$Column)
    colnames(irs) <- as.character(refs_md[refs_md$Column %in% refs,][[batch]])
  }
  # get the geometric average intensity for each protein
  irs <- tibble::as_tibble(irs)
  irs$average <- apply(irs, 1, function(x) exp(mean(log(x), na.rm=TRUE)))
  # normalize data
  dt_irs_list <- lapply(names(dt_list), function(b){
    # compute scaling factor vectors
    fac <- irs$average / irs[,b]
    # normalize
    dt_irs_chunk <- dt_list[[b]] * fac[,1]
    return(dt_irs_chunk)
  })
  # reconstruct data after irs normalization
  dt_irs <- do.call(cbind, dt_irs_list)
  dt_irs <- data.table::as.data.table(dt_irs)
  dt_irs <- subset(dt_irs, select = colnames(dt))
  # transform data to log2-scale if necessary
  if(on_raw){
    dt_irs <- log2(dt_irs)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- dt_irs
  return(se)
}


#' Quantile Normalization of preprocessCore package.
#'
#' Forces distributions of the samples to be the same on the basis of the quantiles of the samples by replacing
#' each protein of a sample with the mean of the corresponding quantile. Log2-scaled data should be taken as input (on_raw = FALSE)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the quantile normalized data as assay (on log2 scale)
#' @export
#' @seealso \code{\link[preprocessCore]{normalize.quantiles}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- quantileNorm(tuberculosis_TMT_se, ain = "log2",
#'                               aout = "Quantile", on_raw = FALSE)
#'
quantileNorm <- function(se, ain="log2", aout="Quantile", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  if(on_raw & ain != "raw"){
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  if(ain == "log2" & on_raw == TRUE){
    warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    dt <- 2^dt
  }
  norm_dt <- preprocessCore::normalize.quantiles(as.matrix(dt), copy=TRUE)
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  # transform data to log2-scale if necessary
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}

#' Variance Stabilization Normalization of limma package.
#'
#' Raw data should be taken as input (on_raw = TRUE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#' @param VSN_quantile Numeric of length 1. The quantile that is used for the resistant least trimmed sum of squares regression (see vsn2 lts.quantile)
#'
#' @return SummarizedExperiment containing the vsn normalized data as assay (on log2-scale)
#' @export
#' @seealso \code{\link[limma]{normalizeVSN}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- vsnNorm(tuberculosis_TMT_se, ain = "raw",
#'                             aout = "VSN", on_raw = TRUE, VSN_quantile = 0.9)
#'
vsnNorm <- function(se, ain="raw", aout="VSN", on_raw = TRUE, VSN_quantile = 0.9){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  norm_dt <- suppressMessages(limma::normalizeVSN(dt, lts.quantile = VSN_quantile))
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  # no log transformation because limma already returns log2 data
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}


#' Weighted Trimmed Mean of M Values (TMM) Normalization of edgeR package.
#'
#' Raw data should be taken as input (on_raw = TRUE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the TMM normalized data as assay (on log2 scale)
#' @export
#' @seealso \code{\link[edgeR]{calcNormFactors}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- tmmNorm(tuberculosis_TMT_se, ain = "raw",
#'                                   aout = "TMM", on_raw = TRUE)
#'
tmmNorm <- function(se, ain="raw", aout="TMM", on_raw = TRUE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  tmm <- edgeR::calcNormFactors(stats::na.omit(dt))
  dt_norm <- sweep(dt, 2, tmm, FUN="/")
  dt_norm <- data.table::as.data.table(dt_norm)
  if(on_raw){
    dt_norm <- log2(dt_norm)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- dt_norm
  return(se)
}

#' Robust Linear Regression Normalization of NormalyzerDE.
#'
#' Uses median values over all samples as reference
#' sample to which all the other samples in the data are normalized to. Log2 data should be taken as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the rlr normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- rlrNorm(tuberculosis_TMT_se, ain = "log2",
#'                                             aout = "Rlr", on_raw = FALSE)
#'
rlrNorm <- function(se, ain="log2", aout="Rlr", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  dt <- as.data.frame(dt)
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  sample_median <- matrixStats::rowMedians(as.matrix(dt), na.rm = TRUE, useNames = TRUE)
  for (i in seq_len(ncol(dt))){ # iterate over samples
    sampleA <- dt[,i] # sample to normalize
    lrFit <- MASS::rlm(as.matrix(sampleA) ~
                         sample_median, na.action = stats::na.exclude)
    coeffs <- lrFit$coefficients
    coefIntercept <- coeffs[1]
    coefSlope <- coeffs[2]
    globalFittedRLRCol <- (sampleA - coefIntercept)/coefSlope
    dt[,i] <- globalFittedRLRCol
  }
  colnames(dt) <- colnames(dt)
  rownames(dt) <- rownames(dt)
  if(on_raw){
    dt <- log2(dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(dt)
  return(se)
}

#' Linear Regression Normalization on MA Transformed Data
#'
#' Similar to Rlr, but data are MA transformed before normalization,
#' (A = median sample, M = difference of that sample to A). Log2 data should be taken as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the RlrMA normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- rlrMANorm(tuberculosis_TMT_se, ain = "log2",
#'                                   aout = "RlrMA", on_raw = FALSE)
#'
rlrMANorm <- function(se, ain="log2",aout="RlrMA", on_raw = FALSE){
  # extract intensities
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  dt_matrix <- as.matrix(dt)
  # MA transformation
  ref_a <- apply(dt_matrix, 1, stats::median, na.rm = TRUE)
  for (i in seq_len(ncol(dt))){ # iterate over samples
    comp_sample <- dt_matrix[, i] # sample to normalize
    m <- comp_sample - ref_a  # M = sample to normalize
    # rlm fit
    fit <- MASS::rlm(m ~ ref_a, na.action = stats::na.exclude)
    fit_values <- stats::predict(fit)
    dt_matrix[, i] <- comp_sample - fit_values
  }
  norm_dt <- data.table::as.data.table(dt_matrix)
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- norm_dt
  return(se)
}

#' Cyclic Linear Regression Normalization on MA Transformed Data
#'
#' No reference, but MA transformation and normalization
#' of samples is done pairwise between two samples with A = average of two samples and M = difference. The process is iterated through all samples pairs.
#' Log2 data should be taken as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#' @param iterations Number of cyclic iterations to be performed
#'
#' @return SummarizedExperiment containing the RlrMACyc normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- rlrMACycNorm(tuberculosis_TMT_se, ain = "log2",
#'                             aout = "RlrMACyc", on_raw = FALSE, iterations=3)
#'
rlrMACycNorm <- function(se, ain="log2", aout="RlrMACyc", on_raw = FALSE, iterations=3){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  dt_matrix <- as.matrix(dt)
  n <- ncol(dt)
  # iteration over all pairs
  for (k in seq_len(iterations)){
    for (j in seq_len(n)){
      for (i in seq(2,5)){
        # MA transformation
        ref_sample <- dt_matrix[, j]
        comp_sample <- dt_matrix[, i]
        m <- comp_sample - ref_sample
        a <- (ref_sample + comp_sample)/2
        # rlm fit
        fit <- MASS::rlm(m ~ a, na.action = stats::na.exclude)
        fit_values <- stats::predict(fit)
        # reorder values
        comp_norm <- comp_sample - fit_values/2
        ref_norm <- ref_sample + fit_values/2
        dt_matrix[, j] <- ref_norm
        dt_matrix[, i] <- comp_norm
      }
    }
  }
  norm_dt <- data.table::as.data.table(dt_matrix)
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- norm_dt
  return(se)
}

#' Cyclic Loess Normalization of limma
#'
#' Two samples of the data are MA transformed and normalized at a time, and all pairs of samples are iterated through. Log2-scaled data should be taken as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the loessCyc normalized data as assay (on log2 scale)
#' @export
#' @seealso \code{\link[limma]{normalizeCyclicLoess}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- loessCycNorm(tuberculosis_TMT_se, ain = "log2",
#'                                       aout = "LoessCyc", on_raw = FALSE)
#'
loessCycNorm <- function(se, ain="log2", aout="LoessCyc", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  norm_dt <- limma::normalizeCyclicLoess(as.matrix(dt), method="pairs")
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}

#' Fast Loess Normalization of limma
#'
#' Using mean intensities over all the samples as its reference A sample. Log2-scaled data should be used as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the LoessF normalized data as assay (on log2 scale)
#' @export
#' @seealso \code{\link[limma]{normalizeCyclicLoess}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- loessFNorm(tuberculosis_TMT_se, ain = "log2",
#'                                     aout = "LoessCyc", on_raw = FALSE)
#'
loessFNorm <- function(se, ain="log2", aout="LoessF", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  norm_dt <- limma::normalizeCyclicLoess(as.matrix(dt), method="fast")
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}

#' EigenMS Normalization
#'
#' EigenMS fits an analysis of variance model to estimate the effects of the experimental factors on the data using the
#' knowledge about the experimental design, and then applies singular value decomposition to identify systematic trends 
#' contributing to significant variation not explained by the experimental factors Log2-scaled data should be used as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the EigenMS normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- eigenMSNorm(tuberculosis_TMT_se, ain = "log2",
#'                                     aout = "EigenMS", on_raw = FALSE)
#'
eigenMSNorm <- function(se, ain="log2", aout="EigenMS", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  prot.info <- cbind(data.frame(SummarizedExperiment::rowData(se)$Protein.IDs), data.frame(SummarizedExperiment::rowData(se)$Protein.IDs))
  colnames(prot.info) <- c("pepIDs", "prID")
  condition <- S4Vectors::metadata(se)$condition
  grps <- factor(data.table::as.data.table(SummarizedExperiment::colData(se))[[condition]], levels = unique(data.table::as.data.table(SummarizedExperiment::colData(se))[[condition]]))
  ints_eig1 <- eig_norm1(m=dt, treatment=grps, prot.info = prot.info)
  ints_norm <- eig_norm2(rv=ints_eig1)
  # present
  prot_present <- ints_eig1$present$pepIDs
  # missing
  prot_missing <- prot.info[!prot.info$pepIDs %in% prot_present,]
  prot_missing$prID <- NULL
  # complete norm_dt
  norm_dt <- data.table::as.data.table(ints_norm$normalized)
  norm_dt$prID <- NULL
  if(nrow(prot_missing)>0){
    # add these proteins with complete NAs
    for(col in names(norm_dt)){ # -1 because of pepIDs columns
      if (col!="pepIDs") prot_missing[,col] <- NA
    }
    norm_dt <- rbind(norm_dt, prot_missing)
    # take ordering of rowData
    ordering <- SummarizedExperiment::rowData(se)$Protein.IDs
    norm_dt <- norm_dt %>% dplyr::arrange(factor(pepIDs, levels = ordering))
    norm_dt$pepIDs <- NULL
  } else {
    norm_dt$pepIDs <- NULL

  }
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}

#' Median Absolute Deviation Normalization
#'
#' Substracts the median and divides the data by the median absolute deviation (MAD). Log2-scaled data should be used as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scale data
#'
#' @return SummarizedExperiment containing the MAD normalized data as assay (on log2 scale)
#' @export
#' @seealso \code{\link[NormalyzerDE]{performSMADNormalization}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- medianAbsDevNorm(tuberculosis_TMT_se, ain = "log2",
#'                                               aout = "MAD", on_raw = FALSE)
#'
medianAbsDevNorm <- function(se, ain="log2", aout="MAD", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  dt <- as.matrix(dt)
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  norm_dt <- NormalyzerDE::performSMADNormalization(dt, noLogTransform = TRUE)
  norm_dt <- data.table::as.data.table(norm_dt)
  colnames(norm_dt) <- colnames(dt)
  rownames(norm_dt) <- rownames(dt)
  if(on_raw){
    norm_dt <- log2(norm_dt)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
  return(se)
}

#' RobNorm Normalization
#'
#' Log2-scaled data should be used as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#' @param gamma.0 Numeric representing the exponent of the weighted density. When the sample size
#'                is small, the fitted population of some proteins could be locally trapped such
#'                that the variance of those proteins was very small under a large gamma. To avoid
#'                this, a small gamma is recommended. When sample size smaller than 40, then set
#'                gamma to 0.5 or 0.1.
#'
#' @return SummarizedExperiment containing the RobNorm normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- robnormNorm(tuberculosis_TMT_se, ain = "log2",
#'                             aout = "RobNorm", on_raw = FALSE, gamma.0 = 0.1)
#'
robnormNorm <- function(se, ain="log2", aout="RobNorm", on_raw = FALSE, gamma.0 = 0.1){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  X.0 <- as.matrix(dt)
  rownames(X.0) <- rownames(dt)
  tryCatch(
    {
      robnorm_res <- RobNorm(X.0, gamma.0=gamma.0, tol=10^(-4), step=200) # default parameter
      norm_dt <- data.table::as.data.table(robnorm_res$norm.data)
      colnames(norm_dt) <- colnames(dt)
      rownames(norm_dt) <- rownames(dt)
      if(on_raw){
        norm_dt <- log2(norm_dt)
      }
      SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(norm_dt)
    },
    error = function(e){
      message(paste0("RobNorm: ", e$message))
    }
  )
  return(se)
}

#' limma::removeBatchEffects (limBE)
#'
#' Log2-scaled data should be used as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#'
#' @return SummarizedExperiment containing the limBE normalized data as assay (on log2 scale)
#' @export
#' @seealso \code{\link[limma]{removeBatchEffect}()}
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- limmaNorm(tuberculosis_TMT_se, ain = "log2",
#'                                       aout = "limBE", on_raw = FALSE)
#'
limmaNorm <- function(se, ain = "log2", aout = "limBE", on_raw = FALSE){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  batch <- S4Vectors::metadata(se)$batch
  batch_vector <- coldata[[batch]]
  dt_batch <- limma::removeBatchEffect(dt, batch = batch_vector)
  if(on_raw){
    dt_batch <- log2(dt_batch)
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- data.table::as.data.table(dt_batch)
  return(se)
}

#' Normics Normalization (Normics using VSN or using Median)
#'
#' Log2-scaled data should be used as input (on_raw = FALSE).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomic dataset
#' @param ain String which assay should be used as input
#' @param aout String which assay should be used to save normalized data
#' @param method String specifying the method to use (NORMICS or NORMICSmedian)
#' @param on_raw Boolean specifying whether normalization should be performed on raw or log2-scaled data
#' @param reduce_correlation_by If the data is too big for the computation of the params, increase this parameter by 2,3,4.... The whole data will still be normalized, but the params are calculated on every second row etc.
#' @param NormicsVSN_quantile The quantile that is used for the resistant least trimmed sum of squares regression. A value of 0.8 means focusing on the central 80\% of the data, reducing the influence of outliers.
#' @param TMT_ratio Indicates if the data involves Tandem Mass Tag (TMT) ratio-based measurements (common in proteomics). If TRUE, the method may handle the data differently.
#' @param top_x Number of reference proteins extracted for the calculation of parameters
#'
#' @return SummarizedExperiment containing the NormicsVSN/NormicsMedian normalized data as assay (on log2 scale)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- normicsNorm(tuberculosis_TMT_se, ain = "raw",
#'                                 aout = "NormicsVSN", method = "NormicsVSN",
#'                                 on_raw = TRUE)
#'
#'
normicsNorm <- function(se, ain = "raw", aout = "NormicsVSN", method = "NormicsVSN", on_raw = TRUE, reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, TMT_ratio = FALSE, top_x = 50){
  # check method
  stopifnot(method %in% c("NormicsVSN", "NormicsMedian"))
  stopifnot(is.numeric(top_x))
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  # check if top_x is not bigger than the number of proteins
  stopifnot(top_x <= nrow(dt))
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  # check if ain is not raw but normalization should be performed on raw data
  if(on_raw & ain != "raw"){
    if(ain == "log2"){
      warning("Log2 data specified as ain but on_raw is set to TRUE. On_raw=TRUE forces data to be transformed to raw-scale.")
    }
    dt <- 2^dt
  }
  if(ain == "raw" & on_raw == FALSE){
    warning("Raw data specified as ain but on_raw is set to FALSE. On_raw=FALSE forces data to be transformed to log2-scale.")
    dt <- log2(dt)
  }
  dt_reduced <- dt[seq(1, nrow(dt), by = reduce_correlation_by), ]
  rowdata_reduced <- rowdata[seq(1, nrow(rowdata), by = reduce_correlation_by), ]
  # create longlist
  cols <- c("Protein_ID", "Rank_sum_RS", "Mean_correlation_MC", "Coefficient_of_variation_CV", "Variance_correlation_VC")
  # use matrices for faster computation
  dt_matrix <- as.matrix(dt_reduced)
  # precompute means and variances to avoid recalculating them
  means <- apply(dt_matrix, 1, mean, na.rm = TRUE)
  variances <- apply(dt_matrix, 1, stats::var, na.rm = TRUE)
  # initialize empty dataframe for longlist
  longlist <- data.frame(matrix(ncol = length(cols), nrow = 0))
  colnames(longlist) <- cols
  # compute pairwise correlations
  cor_matrix <- stats::cor(t(dt_matrix), method = "spearman", use = "pairwise.complete.obs")
  cor_df <- as.data.frame(cor_matrix)
  # populate longlist
  for (i in seq_len(nrow(cor_df))){
    # exclude self-correlation by removing the i-th column from the matrix
    temp <- as.numeric(cor_df[i, -i])
    CV <- ifelse(!TMT_ratio, sqrt(variances[i]) / means[i], sqrt(variances[i]))
    # add row to longlist
    longlist <- rbind(longlist,
                      data.frame( Protein_ID = rowdata_reduced$Protein.IDs[i],
                                  Rank_sum_RS = NA,
                                  Mean_correlation_MC = mean(temp, na.rm = TRUE),
                                  Coefficient_of_variation_CV = CV,
                                  Variance_correlation_VC = stats::var(temp, na.rm = TRUE)))
  }

  # sort and determine rank sum
  longlist <- longlist[order(longlist[[cols[4]]]), ]
  longlist$Rank_sum_RS <- seq_len(nrow(longlist)) - 1
  longlist <- longlist[order(-longlist[[cols[3]]]), ]
  longlist$Rank_sum_RS <- longlist$Rank_sum_RS + seq_len(nrow(longlist)) - 1
  longlist <- longlist[order(longlist[[cols[2]]]), ]

  # extract top
  shortlist <- longlist[seq_len(top_x), ]

  if(method == "NormicsVSN"){
    # NORMICS VSN normalization
    # generate subset of counts including just the top proteins
    dt_ids <- cbind(dt, rowdata[,"Protein.IDs"])
    colnames(dt_ids)[length(dt)+1] <- "Protein.IDs"
    dt_shortlist <- dt_ids[dt_ids$Protein.IDs %in% shortlist$Protein_ID,]
    dt_shortlist$Protein.IDs <- NULL
    # get parameters
    dt_to_norm <- Biobase::ExpressionSet(assayData = as.matrix(dt_shortlist))
    fit <- vsn::vsn2(dt_to_norm, lts.quantile = NormicsVSN_quantile)
    #params <- coef(fit)[1,,]
    # normalize on complete proteins data
    dt_to_norm <- Biobase::ExpressionSet(assayData = as.matrix(dt))
    norm_data <- vsn::predict(fit, dt_to_norm, log2scale = TRUE)
    norm_dt <- express_to_DT(expr_data = norm_data,
                                 column_names = colnames(dt),
                                 row_names = rownames(dt))
  } else {
    # NORMICSmedian normalization
    # calculate median ratios for shortlist proteins per column
    dt_ids <- cbind(dt, rowdata[["Protein.IDs"]])
    colnames(dt_ids)[length(dt)+1] <- "Protein.IDs"
    dt_shortlist <- dt_ids[dt_ids$Protein.IDs %in% shortlist$Protein_ID,]
    dt_shortlist$Protein.IDs <- NULL
    ratios <- as.data.frame(lapply(dt_shortlist, stats::median, na.rm = TRUE), col.names = colnames(dt_shortlist))
    # normalize on complete proteins data
    dt <- as.data.frame(dt)
    norm_dt <- dt
    # iterate over the columns and perform calculations
    for (j in seq_along(dt)) {
      ri <- ratios[1, j]
      norm_dt[, j] <- dt[, j] / ri * mean(as.numeric(ratios[1, ]), na.rm = TRUE)
    }
    # apply log2 transformation
    if(on_raw){
      norm_dt <- log2(norm_dt)
    }
    norm_dt <- tib_to_DF(norm_dt, colnames(norm_dt), rownames(norm_dt))
  }
  SummarizedExperiment::assay(se, aout, FALSE) <- norm_dt
  return(se)
}


## ----- Main Normalization Method Functions ----- ##

#' Function to return available normalization methods' identifier names
#'
#' @return Vector of normalization methods
#' @export
#'
#' @examples
#' get_normalization_methods()
#'   
#'
get_normalization_methods <- function(){
  norm_names <- c("GlobalMean","GlobalMedian", "Median", "Mean", "IRS", "Quantile", "VSN",
                  "LoessF", "LoessCyc", "RLR", "RlrMA", "RlrMACyc", "EigenMS", "MAD", "RobNorm", "TMM", "limBE", "NormicsVSN", "NormicsMedian")
  return(norm_names)
}

#' Normalize SummarizedExperiment object using different normalization methods
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param methods Vector of normalization methods to apply for normalizing the proteomics data of the SummarizedExperiment object (identifier of normalization methods can be retrieved using get_normalization_methods())
#' @param on_raw Logical indicating if the normalization should be performed on the raw data or on log2-transformed data. If on_raw = NULL(default), the normalization is performed on the default method specific on_raw setting (suggestion based on publications).
#' @param gamma.0 Numeric representing the exponent of the weighted density of RobNorm normalization. When the sample size is small, the fitted population of some proteins could be locally trapped such that the variance of those proteins was very small under a large gamma. To avoid this, a small gamma is recommended. When sample size smaller than 40, then set gamma to 0.5 or 0.1.
#' @param reduce_correlation_by If the data is too big for the computation of the params, increase this parameter by 2,3,4.... The whole data will still be normalized, but the params are calculated on every second row etc.
#' @param NormicsVSN_quantile The quantile that is used for the resistant least trimmed sum of squares regression. A value of 0.8 means focusing on the central 80\% of the data, reducing the influence of outliers.
#' @param top_x Number of reference proteins extracted for the calculation of parameters
#' @param VSN_quantile Numeric of length 1. The quantile that is used for the resistant least trimmed sum of squares regression. (see vsn2 lts.quantile)
#'
#' @return SummarizedExperiment object with normalized data saved as assays
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- normalize_se_single(tuberculosis_TMT_se,
#'           methods = c("RobNorm", "Median", "NormicsVSN","VSN"),
#'           on_raw = NULL, gamma.0 = 0.1, reduce_correlation_by = 1,
#'           NormicsVSN_quantile = 0.8, top_x = 50, VSN_quantile = 0.9)
#'
normalize_se_single <- function(se, methods = NULL, on_raw = NULL, gamma.0 = 0.1, reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, top_x = 50, VSN_quantile = 0.9){
  # vector with available normalization methods
  norm_functions <- norm_functions <- list(globalMeanNorm, globalMedianNorm, medianNorm, meanNorm, irsNorm,
                                           quantileNorm, vsnNorm, loessFNorm, loessCycNorm, rlrNorm,
                                           rlrMANorm, rlrMACycNorm, eigenMSNorm, medianAbsDevNorm, robnormNorm, tmmNorm, limmaNorm, normicsNorm, normicsNorm)
  norm_names <- c("GlobalMean","GlobalMedian", "Median", "Mean", "IRS", "Quantile", "VSN",
                  "LoessF", "LoessCyc", "RLR", "RlrMA", "RlrMACyc", "EigenMS", "MAD", "RobNorm", "TMM", "limBE", "NormicsVSN", "NormicsMedian")
  names(norm_functions) <- norm_names

  # retrieve normalization methods & check if all methods available
  if(!is.null(methods)){
    not_available_methods <- methods[!methods %in% norm_names]
    if(length(not_available_methods) > 0){
      warning(paste0(paste0(not_available_methods, collapse = ", "), " normalization methods not available!"))
    }
  } else {
    message("All available normalization methods will be performed.")
    methods <- norm_names
  }

  # check if IRS or limBE can be executed
  batch <-S4Vectors::metadata(se)$batch
  if(sum(c("limBE", "IRS") %in% methods) > 0){
    if(is.null(batch)){
      stop("No batch specified! Batch need to be specified for limBE, IRS in the SummarizedExperiment under metadata(se)$batch!")
    }
  }
  refs <- S4Vectors::metadata(se)$refs
  if("IRS" %in% methods){
    if(is.null(refs)){
      stop("No reference samples specified! Reference samples need to be specified for IRS in the SummarizedExperiment under metadata(se)$refs!")
    }
  }

  # normalization
  for(method in methods){
    func <- norm_functions[[method]]
    if(is.null(on_raw)){
      if(method == "RobNorm"){
        se <- func(se, aout = method, gamma.0 = gamma.0)
      } else if(method %in% c("NormicsVSN", "NormicsMedian")){
        se <- func(se, aout = method, method = method, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x)
      } else if(method == "VSN"){
        se <- func(se, aout = method, VSN_quantile = VSN_quantile)
      } else {
        se <- func(se, aout = method)
      }
    } else {
      if(method == "RobNorm"){
        se <- func(se, aout = method, on_raw = on_raw, gamma.0 = gamma.0)
      } else if(method %in% c("NormicsVSN", "NormicsMedian")){
        se <- func(se, aout = method, on_raw = on_raw, method = method, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x)
      } else if(method == "VSN"){
        se <- func(se, aout = method, on_raw = on_raw, VSN_quantile = VSN_quantile)
      } else {
        se <- func(se, aout = method, on_raw = on_raw)
      }
    }


    # TODO: error handling
    message(paste0(method, " completed."))
  }
  return(se)
}


#' Normalize SummarizedExperiment object using combinations of normalization methods
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param methods Vector of normalization methods to apply for normalizing the proteomics data of the SummarizedExperiment object (identifier of normalization methods can be retrieved using get_normalization_methods())
#' @param ains Vector of assays of SummarizedExperiment object to apply the normalization methods (e.g. if you want to perform Median normalization on IRS-normalized data)
#' @param on_raw Logical indicating if the normalization should be performed on the raw data or on log2-transformed data. If on_raw = NULL(default), the normalization is performed on the default method specific on_raw setting (suggestion based on publications).
#' @param combination_pattern String to give name to combination of methods (e.g. IRS_on_Median --> "_on_")
#' @param gamma.0 Numeric representing the exponent of the weighted density of RobNorm normalization. When the sample size is small, the fitted population of some proteins could be locally trapped such that the variance of those proteins was very small under a large gamma. To avoid this, a small gamma is recommended. When sample size smaller than 40, then set gamma to 0.5 or 0.1.
#' @param reduce_correlation_by If the data is too big for the computation of the params, increase this parameter by 2,3,4.... The whole data will still be normalized, but the params are calculated on every second row etc.
#' @param NormicsVSN_quantile The quantile that is used for the resistant least trimmed sum of squares regression. A value of 0.8 means focusing on the central 80\% of the data, reducing the influence of outliers.
#' @param top_x Number of reference proteins extracted for the calculation of parameters
#' @param VSN_quantile Numeric of length 1. The quantile that is used for the resistant least trimmed sum of squares regression. (see vsn2 lts.quantile)
#'
#' @return SummarizedExperiment object with normalized data saved as assays
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- normalize_se_combination(tuberculosis_TMT_se,
#'           methods = c("Median","NormicsVSN"), ains = c("IRS"), on_raw = NULL,
#'           combination_pattern = "_on_", gamma.0 = 0.1,
#'           reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, top_x = 50,
#'           VSN_quantile = 0.9)
#'
normalize_se_combination <- function(se, methods, ains, on_raw = NULL, combination_pattern = "_on_", gamma.0 = 0.1, reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, top_x = 50, VSN_quantile = 0.9){

  # vector with available normalization methods
  norm_functions <- norm_functions <- list(globalMeanNorm, globalMedianNorm, medianNorm, meanNorm, irsNorm,
                                           quantileNorm, vsnNorm, loessFNorm, loessCycNorm, rlrNorm,
                                           rlrMANorm, rlrMACycNorm, eigenMSNorm, medianAbsDevNorm, robnormNorm, tmmNorm, normicsNorm, normicsNorm, limmaNorm)
  norm_names <- c("GlobalMean","GlobalMedian", "Median", "Mean", "IRS", "Quantile", "VSN",
                  "LoessF", "LoessCyc", "RLR", "RlrMA", "RlrMACyc", "EigenMS", "MAD", "RobNorm", "TMM", "NormicsVSN", "NormicsMedian", "limBE")
  names(norm_functions) <- norm_names

  # retrieve normalization methods & check if all methods available
  if(!is.null(methods)){
    # check if all methods available
    not_available_methods <- methods[!methods %in% norm_names]
    if(length(not_available_methods) > 0){
      warning(paste0(paste0(not_available_methods, collapse = ", "), " normalization methods not available!"))
    }
  } else {
    message("All available normalization methods will be performed.")
    methods <- norm_names
  }

  # perform combination of normalization
  for(ain in ains){
    # check if ain already in se --> if not: perform now
    if(! ain %in% names(SummarizedExperiment::assays(se))){
      message(paste0(ain, " normalization not yet performed. Single ", ain, " normalization performed now."))
      se <- normalize_se_single(se, methods = c(ain), on_raw = on_raw, gamma.0 = gamma.0, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x)
    }

    for(method in methods){
      aout <- paste0(method, combination_pattern, ain)
      func <- norm_functions[[method]]
      if(is.null(on_raw)){
        if(method == "RobNorm"){
          se <- func(se, ain = ain, aout = aout, gamma.0 = gamma.0)
        } else if(method %in% c("NormicsVSN", "NormicsMedian")){
          se <- func(se, ain = ain, aout = aout, method = method, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x)
        } else if(method == "VSN"){
          se <- func(se, ain = ain,aout = aout, VSN_quantile = VSN_quantile)
        } else {
          se <- func(se, ain = ain, aout = aout)
        }
      } else {
        if(method == "RobNorm"){
          se <- func(se, ain = ain, aout = aout, on_raw = on_raw, gamma.0 = gamma.0)
        } else if(method %in% c("NormicsVSN", "NormicsMedian")){
          se <- func(se, ain = ain, aout = aout, on_raw = on_raw, method = method, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x)
        } else if(method == "VSN"){
          se <- func(se, ain = ain,aout = aout, on_raw = on_raw, VSN_quantile = VSN_quantile)
        } else {
          se <- func(se, ain = ain, aout = aout, on_raw = on_raw)
        }
      }

      message(paste0(method, " normalization performed on ", ain, "-normalized data completed."))
    }
  }
  return(se)
}


#' Normalize SummarizedExperiment object using single normalization methods or specified combinations of normalization methods
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param methods Vector of normalization methods to apply for normalizing the proteomics data of the SummarizedExperiment object (identifier of normalization methods can be retrieved using get_normalization_methods())
#' @param combination_pattern String specifying how normalization methods are combined. For instance, methods = c("IRS", "Median_on_IRS"), combination_pattern = "_on_".
#' @param on_raw Logical indicating if the normalization should be performed on the raw data or on log2-transformed data. If on_raw = NULL(default), the normalization is performed on the default method specific on_raw setting (suggestion based on publications).
#' @param gamma.0 Numeric representing the exponent of the weighted density of RobNorm normalization. When the sample size is small, the fitted population of some proteins could be locally trapped such that the variance of those proteins was very small under a large gamma. To avoid this, a small gamma is recommended. When sample size smaller than 40, then set gamma to 0.5 or 0.1.
#' @param reduce_correlation_by If the data is too big for the computation of the params, increase this parameter by 2,3,4.... The whole data will still be normalized, but the params are calculated on every second row etc.
#' @param NormicsVSN_quantile The quantile that is used for the resistant least trimmed sum of squares regression. A value of 0.8 means focusing on the central 80\% of the data, reducing the influence of outliers.
#' @param top_x Number of reference proteins extracted for the calculation of parameters
#' @param VSN_quantile Numeric of length 1. The quantile that is used for the resistant least trimmed sum of squares regression (see vsn2 lts.quantile)
#'
#' @return SummarizedExperiment object with normalized data saved as assays
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- normalize_se(tuberculosis_TMT_se,
#'            methods = c("IRS_on_GlobalMedian", "IRS_on_Median",
#'            "limBE_on_NormicsVSN"), on_raw = NULL,
#'            combination_pattern = "_on_", gamma.0 = 0.1,
#'            reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, top_x = 50,
#'            VSN_quantile = 0.9)
#'
normalize_se <- function(se, methods, combination_pattern = "_on_", on_raw = NULL, gamma.0 = 0.1, reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, top_x = 50, VSN_quantile = 0.9){
  # extract combination of methods
  if(!is.null(combination_pattern)){
    comb_methods <- methods[stringr::str_detect(methods, combination_pattern)] #  combined methods
    sing_methods <- methods[!methods %in% comb_methods] # single methods
  } else {
    sing_methods <- methods
  }

  # single normalization
  if(length(sing_methods) > 0){
    se <- normalize_se_single(se, sing_methods, on_raw = on_raw, gamma.0 = gamma.0, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x, VSN_quantile = VSN_quantile)
  }
  # combined normalization
  if(!is.null(combination_pattern)){
    if(length(comb_methods) > 0){
      for(m in comb_methods){
        methods_split <- strsplit(m, combination_pattern)[[1]]

        # Initialize method and ain with the last two elements
        length_split <- length(methods_split)
        ain <- methods_split[length_split]
        method <- methods_split[length_split - 1]
        se <- normalize_se_combination(se, c(method), c(ain), on_raw = on_raw, combination_pattern, gamma.0 = gamma.0, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x, VSN_quantile = VSN_quantile)

        # If there are more than two methods in the combination, process the rest
        if (length(methods_split) > 2) {
          for (i in (length_split - 2):1) {
            ain <- paste(method, ain, sep = combination_pattern)
            method <- methods_split[i]

            # Apply the subsequent combination
            se <- normalize_se_combination(se, c(method), c(ain), on_raw = on_raw, combination_pattern, gamma.0 = gamma.0, reduce_correlation_by = reduce_correlation_by, NormicsVSN_quantile = NormicsVSN_quantile, top_x = top_x, VSN_quantile = VSN_quantile)
          }
        }
      }
    }
  }
  return(se)
}

#' Export the SummarizedExperiment object, the meta data, and the normalized data.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param out_dir Path of output directory
#' @param ain Vector of strings which assay should be downloaded (default NULL).
#'            If NULL then all assays of the se object are saved.
#'
#' @return Nothing
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' \dontrun{export_data(tuberculosis_TMT_se, out_dir = "data/",
#'             ain = c("IRS_on_RobNorm", "IRS_on_Median"))}
#'
export_data <- function(se, out_dir, ain = NULL) {
  ain <- check_input_assays(se, ain)

  # Write column data
  message(".. saving meta_data.csv")
  utils::write.csv(data.frame(SummarizedExperiment::colData(se), check.names=FALSE), file.path(out_dir, "meta_data.csv"), row.names = FALSE)

  # Extract Assay Data: The assay data is the core data matrix (or matrices) in a SummarizedExperiment object.
  message(".. saving assays as .csv")
  row_data <- data.frame(SummarizedExperiment::rowData(se), check.names=FALSE)
  assays <- SummarizedExperiment::assays(se)
  for (assay in ain) {
    cols <- names(SummarizedExperiment::assays(se)[[assay]])
    assay_data <- data.frame(SummarizedExperiment::assays(se)[[assay]])
    colnames(assay_data) <- cols
    combined_data <- cbind(row_data, assay_data)
    combined_data$IDs <- NULL
    utils::write.csv(combined_data, file.path(out_dir, paste0(assay, "_normalized_data.csv")), row.names = FALSE)
  }
  message(".. saving SummarizedExperiment as RDS file")
  # Save the SummarizedExperiment object as an RDS file
  saveRDS(se, file.path(out_dir, "se.rds"))
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)

## ----setup, message = FALSE---------------------------------------------------
library(PRONE)

## -----------------------------------------------------------------------------
data_path <- readPRONE_example("Ecoli_human_MaxLFQ_protein_intensities.csv")
md_path <- readPRONE_example("Ecoli_human_MaxLFQ_metadata.csv")

data <- read.csv(data_path)
md <- read.csv(md_path)

## -----------------------------------------------------------------------------
# Check if some protein groups are mixed
mixed <- grepl("Homo sapiens.*Escherichia|Escherichia.*Homo sapiens",data$Fasta.headers) 
data <- data[!mixed,]

table(mixed) 

## -----------------------------------------------------------------------------
data$Spiked <- rep("HUMAN", nrow(data))
data$Spiked[grepl("ECOLI", data$Fasta.headers)] <- "ECOLI"

## -----------------------------------------------------------------------------
se <- load_spike_data(data, 
                      md, 
                      spike_column = "Spiked", 
                      spike_value = "ECOLI", 
                      spike_concentration = "Concentration",
                      protein_column = "Protein.IDs", 
                      gene_column = "Gene.names", 
                      ref_samples = NULL, 
                      batch_column = NULL, 
                      condition_column = "Condition", 
                      label_column = "Label")

## ----fig.cap = "Overview of the number of identified spike-in proteins per sample, colored by condition. In this data set, the conditions were labeled with H and L. H indicates the sample group with high concentrations of spike-in proteins added to the background proteome, while L represents the sample group with low concentrations."----
plot_identified_spiked_proteins(se)

## ----fig.cap = "Histogram of the protein intensities of the spike-in proteins (ECOLI) and the background proteins (HUMAN) in the different conditions. This plot helps to compare the distributions of spike-in (red) and background proteins (grey) for the different spike-in levels."----
plot_histogram_spiked(se, condition = NULL)

## ----fig.cap = "Profiles of the spike-in proteins (ECOLI) and the background proteins (HUMAN) in the different conditions. This plot helps to analyze whether the intensities of the background proteins are constant across the different spike-in concentrations. Spike-in proteins (red) should increase in intensity with increasing spike-in concentrations, while background proteins (grey) should remain constant."----
plot_profiles_spiked(se, xlab = "Concentration")

## -----------------------------------------------------------------------------
se_norm <- normalize_se(se, c("Median", "Mean", "MAD", "LoessF"), 
                        combination_pattern = NULL)

## -----------------------------------------------------------------------------
comparisons <- specify_comparisons(se_norm, condition = "Condition", 
                                   sep = NULL, control = NULL)

## -----------------------------------------------------------------------------
de_res <- run_DE(se = se_norm, 
                     comparisons = comparisons,
                     ain = NULL, 
                     condition = NULL, 
                     DE_method = "limma", 
                     covariate = NULL, 
                     logFC = TRUE, 
                     logFC_up = 1, 
                     logFC_down = -1, 
                     p_adj = TRUE, 
                     alpha = 0.05, 
                     B = 100, 
                     K = 500)

## -----------------------------------------------------------------------------
stats <- get_spiked_stats_DE(se_norm, de_res)

# Show tp, fp, fn, tn, with F1 score
knitr::kable(stats[,c("Assay", "Comparison", "TP", "FP", "FN", "TN", "F1Score")], caption = "Performance metrics for the different normalization methods and pairwise comparisons.", digits = 2)

## ----fig.cap = "Barplot showing the number of false positives (FP) and true positives (TP) for each normalization method and is facetted by pairwise comparison. This plot shows the impact of normalization on DE results."----
plot_TP_FP_spiked_bar(stats, ain = c("Median", "Mean", "MAD", "LoessF"), 
                      comparisons = NULL)

## ----fig.cap = "Boxplot showing the distribution of true positives (TP) and false positives (FP) for each normalization method across all pairwise comparisons. This plot helps to visualize the distribution of TP and FP for each normalization method. Since in this dataset, only two conditions are available, hence a single pairwise comparison, this plot is not very informative."----
plot_TP_FP_spiked_box(stats, ain = c("Median", "Mean", "MAD", "LoessF"), 
                      comparisons = NULL)

## ----fig.cap = "Scatter plot showing the median true positives (TP) and false positives (FP) for each normalization method across all pairwise comparisons."----
plot_TP_FP_spiked_scatter(stats, ain = NULL, comparisons = NULL)

## ----fig.cap = "Heatmap showing a selection of performance metrics for the different normalization methods and pairwise comparisons."----
plot_stats_spiked_heatmap(stats, ain = c("Median", "Mean", "MAD"), 
                          metrics = c("Precision", "F1Score"))

## ----fig.cap = "ROC curves and AUC barplots and boxplots for the different normalization methods and pairwise comparisons. AUC barplots are shown for each pairwise comparison, while the boxplot shows the distribution of AUC values across all comparisons."----
plot_ROC_AUC_spiked(se_norm, de_res, ain = c("Median", "Mean", "LoessF"), 
                    comparisons = NULL)

## ----fig.cap = "Boxplot showing the distribution of log fold changes for the different normalization methods and pairwise comparisons. The dotted blue line is at y = 0 because logFC values of the background proteins should be centered around 0, while the dotted red line shows the expected logFC value based on the spike-in concentrations of both sample groups."----
plot_fold_changes_spiked(se_norm, de_res, condition = "Condition", 
                         ain = c("Median", "Mean", "MAD"), comparisons = NULL)

## ----fig.cap = "Boxplot showing the distribution of p-values for the different normalization methods and pairwise comparisons."----
plot_pvalues_spiked(se_norm, de_res, ain = c("Median", "Mean", "MAD"), 
                    comparisons = NULL)

## -----------------------------------------------------------------------------
plots <- plot_logFC_thresholds_spiked(se_norm, de_res, condition = NULL, 
                                      ain = c("Median", "Mean", "MAD"), 
                                      nrow = 1, alpha = 0.05)

## ----fig.cap = "Barplot showing the number of true positives for each normalization method and pairwise comparison for different log fold change thresholds. This plot helps to analyze the impact of different log fold change thresholds on the number of true positives. The dotted line in the plot shows the expected logFC value based on the spike-in concentrations of both sample groups."----
plots[[1]]

## ----fig.cap = "Barplot showing the number of false positives for each normalization method and pairwise comparison for different log fold change thresholds. This plot helps to analyze the impact of different log fold change thresholds on the number of false positives. The dotted line in the plot shows the expected logFC value based on the spike-in concentrations of both sample groups."----
plots[[2]]

## -----------------------------------------------------------------------------
utils::sessionInfo()

################# ----------- Filter Proteins Functions ----------- ###################

#' Remove proteins with NAs in all samples
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberulosis_TMT_se <- filter_out_complete_NA_proteins(tuberculosis_TMT_se)
#'
filter_out_complete_NA_proteins <- function(se){
  # find proteins that only have NAs
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[["raw"]])
  row_idx_no_NA <- rowSums(is.na(dt)) != ncol(dt)
  # subset SummarizedExperiment
  se_subset <- se[row_idx_no_NA,]
  if(nrow(se_subset) == 0){
    stop("All proteins would be removed. Aborted!")
  } else if(nrow(se_subset) == nrow(se)){
    message("No proteins were removed.")
  } else{
    rm <- nrow(se) - nrow(se_subset)
    message(paste0(rm, " proteins were removed."))
  }
  return(se_subset)
}


#' Remove proteins by value in specific column
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param column_name name of column of which proteins with a specific value should be removed
#' @param values value of the column defining the proteins that should be removed
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- filter_out_proteins_by_value(tuberculosis_TMT_se,
#'                                  column_name = "Reverse", values = c("+"))
#'
filter_out_proteins_by_value <- function(se, column_name = "Reverse", values = c("+")){
  rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  if(column_name %in% colnames(rd)){
    rd_subset <- rd[! rd[, column_name] %in% c(values),]
    se_subset <- se[rd_subset$ID, ]
    if(nrow(se_subset) == 0){
      stop("All proteins would be removed. Aborted!")
    } else if(nrow(se_subset) == nrow(se)){
      message("No proteins were removed.")
    } else{
      rm <- nrow(se) - nrow(se_subset)
      message(paste0(rm, " proteins were removed."))
    }
  } else {
    warning(paste0("Column ", column_name, " not in SummarizedExperiment object!"))
    se_subset <- se
  }
  return(se_subset)
}

#' Get proteins by value in specific column
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param column_name name of column of which proteins with a specific value should be identified
#' @param values value of the column defining the proteins that should be identified
#'
#' @return vector of protein IDs
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' proteins <- get_proteins_by_value(tuberculosis_TMT_se,
#'                       column_name = "Potential.contaminant", values = c("+"))
#'
get_proteins_by_value <- function(se, column_name = "Reverse", values = c("+")){
  rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  if(column_name %in% colnames(rd)){
    rd_subset <- rd[rd[[column_name]] %in% c(values),]
    if(nrow(rd_subset) == nrow(rd)){
      message("All proteins were identified.")
    } else if(nrow(rd_subset) == 0){
      message("No proteins were identified.")
    } else{
      message(paste0(nrow(rd_subset), " proteins were identified."))
    }
    return(rd_subset$Protein.IDs)
  } else {
    warning(paste0("Column ", column_name, " not in SummarizedExperiment object!"))
    return(c())
  }
}

#' Remove proteins by their ID
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param protein_ids Vector of protein IDs that should be kept
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- filter_out_proteins_by_ID(tuberculosis_TMT_se,
#'                                 protein_ids = c("P0A8V2", "P0A8V2"))
#'
filter_out_proteins_by_ID <- function(se, protein_ids){
  rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  rd_subset <- rd[!rd$Protein.IDs %in% protein_ids,]
  se_subset <- se[rd_subset$ID, ]
  if(nrow(se_subset) == 0){
    stop("No proteins would be remaining. Aborted!")
  } else if(nrow(se_subset) == nrow(se)){
    message("No proteins were removed.")
  } else{
    rm <- nrow(se) - nrow(se_subset)
    message(paste0(rm, " proteins were removed."))
  }
  return(se_subset)
}

#' Filter proteins based on their NA pattern using a specific threshold
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param thr Threshold for the minimum fraction of valid values allowed for any protein
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- filter_out_NA_proteins_by_threshold(tuberculosis_TMT_se,
#'                                                        thr = 0.8)
#'
filter_out_NA_proteins_by_threshold <- function(se, thr = 0.8){
  # prepare data
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[["raw"]])
  dt$ID <- SummarizedExperiment::rowData(se)$Protein.IDs
  melted_dt <- data.table::melt(dt, variable.name = "Column", value.name = "Intensity", id.vars = "ID")
  melted_dt <- merge(melted_dt, data.table::as.data.table(SummarizedExperiment::colData(se)),by="Column")

  # make values binary (1 = valid value, 0 = missing value)
  bin_dt <- melted_dt
  bin_dt$Intensity[is.na(bin_dt$Intensity)] <- 0
  bin_dt$Intensity[bin_dt$Intensity != 0] <- 1

  # filter data
  nr_samples <- dim(se)[2]
  keep <- bin_dt %>% dplyr::group_by(ID) %>% dplyr::summarise(miss_val = dplyr::n() - sum(Intensity), valid_val = sum(Intensity)) %>% dplyr::filter(valid_val >= thr * nr_samples)

  # get indices of keep proteins
  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  rowdata <- rowdata[rowdata$Protein.IDs %in% keep$ID, ]

  se_subset <- se[rowdata$IDs,]
  rm <- nrow(se) - nrow(se_subset)
  if(nrow(se_subset) == 0){
    stop("All proteins would be removed. Aborted!")
  } else if (rm == 0){
    message("No proteins were removed.")
  } else{
    message(paste0(rm, " proteins were removed."))
  }
  return(se_subset)
}


################# ----------- Plotting Functions ----------- ###################

#' Plot heatmap of the NA pattern
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#' @param cluster_samples Boolean. TRUE if samples should be clustered, else FALSE.
#' @param cluster_proteins Boolean. TRUE if proteins should be clustered, else FALSE.
#' @param show_row_dend Boolean. TRUE if row dendrogram should be shown.
#' @param show_column_dend Boolean. TRUE if column dendrogram should be shown.
#' @param col_vector Vector of colors for the color bar. If NULL, default colors are used.
#' @importFrom magrittr %>%
#'
#' @return ComplexHeatmap plot (only showing proteins with at least one missing value)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_NA_heatmap(tuberculosis_TMT_se, color_by = NULL,
#'                 label_by = NULL, cluster_samples = TRUE,
#'                 cluster_proteins = TRUE, show_row_dend = TRUE,
#'                 show_column_dend = FALSE,
#'                 col_vector = NULL)
#'
plot_NA_heatmap <- function(se, color_by = NULL, label_by = NULL, cluster_samples = TRUE, cluster_proteins = TRUE, show_row_dend = TRUE, show_column_dend = FALSE, col_vector = NULL){
  # get color and label values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]
  
  # prepare data --> make values binary (1 = valid value, 0 = missing value)
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[["raw"]])
  dt[is.na(dt)] <- 0
  dt[dt != 0] <- 1

  # only take those proteins with at least one missing value
  dt <- dt[apply(dt, 1, function(x) any(x==0)),]

  # preserve order
  dt <- dt[, SummarizedExperiment::colData(se)$Column, with=FALSE]
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  colnames(dt) <- coldata$Column

  if(show_sample_names){
    colnames(dt) <- as.character(coldata[, label_by])
  } else {
    colnames(dt) <- coldata$Column
  }

  # color vector
  if(!is.null(color_by)){
    # prepare data for color bar
    annotation_col <- data.table::data.table(color_by = coldata[, color_by])
    colnames(annotation_col) <- c(color_by)

    if(show_sample_names){
      rownames(annotation_col) <- coldata[, label_by]
    } else {
      rownames(annotation_col) <- coldata$Column
    }

    if(is.null(col_vector)){
      qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
      col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
      col_vector <- rev(col_vector)
      
    }
    condition_colors <- col_vector[seq_len(length(unique(annotation_col[, color_by])))]    
    names(condition_colors) <- unique(annotation_col[, color_by])
    annotation_colors <- list(color_by = condition_colors)
    ha <- ComplexHeatmap::HeatmapAnnotation(color_by = annotation_col[, color_by], col = annotation_colors, annotation_label = c(color_by))
    # Plot Heatmap
    p <- ComplexHeatmap::Heatmap(as.matrix(dt),
                                 name = "Value Type",
                                 cluster_rows = cluster_proteins,
                                 cluster_columns = cluster_samples,
                                 col = c("black", "grey90"),
                                 show_row_dend = show_row_dend,
                                 show_column_dend = show_column_dend,
                                 show_column_names = show_sample_names,
                                 top_annotation = ha,
                                 heatmap_legend_param = list(at = c(0,1),labels = c("Missing", "Valid"))
    )
  } else {
    # no color bar
    p <- ComplexHeatmap::Heatmap(as.matrix(dt),
                                 name = "Value Type",
                                 cluster_rows = cluster_proteins,
                                 cluster_columns = cluster_samples,
                                 col = c("black", "grey90"),
                                 show_row_dend = show_row_dend,
                                 show_column_dend = show_column_dend,
                                 show_column_names = show_sample_names,
                                 heatmap_legend_param = list(at = c(0,1),labels = c("Missing", "Valid"))
    )
  }
  return(p)
}


#' Plot the intensity distribution of proteins with and without NAs
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_NA_density(tuberculosis_TMT_se)
#'
plot_NA_density <- function(se){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[["log2"]])
  dt$ID <- SummarizedExperiment::rowData(se)$Protein.IDs
  melted_dt <- data.table::melt(dt, variable.name = "Column", value.name = "Intensity", id.vars = "ID")
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  melted_dt <- merge(melted_dt, coldata ,by="Column")
  stat <- melted_dt %>% dplyr::group_by(get("ID")) %>% dplyr::summarize(mean = mean(get("Intensity"), na.rm = TRUE), Type = any(is.na(get("Intensity"))))
  stat$Type[stat$Type == TRUE] <- "Missing Value"
  stat$Type[stat$Type == FALSE] <- "Valid Value"
  p <- ggplot2::ggplot(stat, ggplot2::aes(mean, col=get("Type"))) +
    ggplot2::geom_density(na.rm=TRUE) +
    ggplot2::labs(x = "Log2 Intensity", y="Density") +
    ggplot2::scale_colour_manual(name="Value Type", values = c("#A92C23", "#345995"))
  return(p)
}

#' Plot protein identification overlap (x = identified in number of Samples, y=number of proteins)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_NA_frequency(tuberculosis_TMT_se)
#'
plot_NA_frequency <- function(se){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[["raw"]])
  dt$ID <- SummarizedExperiment::rowData(se)$Protein.IDs
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  melted_dt <- data.table::melt(dt, variable.name = "Column", value.name = "Intensity", id.vars = "ID")
  melted_dt <- merge(melted_dt, coldata,by="Column")

  nr_samples <- nrow(coldata)
  stat <- melted_dt %>% dplyr::mutate(bin = ifelse(is.na(get("Intensity")),0,1)) %>% dplyr::group_by(get("ID")) %>% dplyr::summarize(sum = sum(get("bin")))
  table <- table(stat$sum) %>% data.table::as.data.table()
  table <- table %>% dplyr::mutate(V1 = factor(table$V1, levels=seq(0,nr_samples)))
  p <- ggplot2::ggplot(table, ggplot2::aes(x=get("V1"), y=get("N"))) +
    ggplot2::geom_col() +
    ggplot2::labs(title="", x = "Identified in Number of Samples", y="Number of Proteins")
  return(p)
}

#' Remove normalization assays from a SummarizedExperiment object
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param assays_to_remove Character vector of assay names to remove from the SummarizedExperiment object
#'
#' @return SummarizedExperiment object with the normalization assays removed
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- remove_assays_from_SE(tuberculosis_TMT_se,
#'                                  assays_to_remove = c("IRS_on_RobNorm"))
#'
remove_assays_from_SE <- function(se, assays_to_remove){
  for(ain in assays_to_remove){
    # check if ain in se
    if(ain %in% names(SummarizedExperiment::assays(se))){
      # remove ain from se
      SummarizedExperiment::assays(se)[[ain]] <- NULL
    } else {
      warning("Assay ", ain, " not found in se!")
    }
  }
  return(se)
}

#' Subset SummarizedExperiment object by normalization assays
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Character vector of assay names to keep in the SummarizedExperiment object
#'
#' @return SummarizedExperiment object with only the selected normalization assays
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- subset_SE_by_norm(tuberculosis_TMT_se,
#'                           ain = c("raw", "log2", "IRS_on_RobNorm"))
#'
subset_SE_by_norm <- function(se, ain){
  not_available_ains <- ain[!ain %in% names(SummarizedExperiment::assays(se))]
  if(length(not_available_ains) > 0){
    warning("Assay(s) ", paste(not_available_ains, collapse = ", "), " not found in se!")
  }
  assays_to_remove <- names(SummarizedExperiment::assays(se))[!names(SummarizedExperiment::assays(se)) %in% ain]
  se <- remove_assays_from_SE(se, assays_to_remove)
  return(se)
}

#' Function returning some values on the numbers of NA in the data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which data type should be used (default raw)
#'
#' @return list with total amount of values in the data, amount of NA values, and the percentage of NAs
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' get_NA_overview(tuberculosis_TMT_se, ain="log2")
get_NA_overview <- function(se, ain="log2"){
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  na_nr <- sum(is.na(dt))
  tot_nr <- dim(dt)[1] * dim(dt)[2]
  na_perc <- na_nr/tot_nr * 100
  return(data.table::data.table("Total.Values"=c(tot_nr), "NA.Values" = c(na_nr), "NA.Percentage"= c(na_perc)))
}


#' Barplot showing the number of samples per condition
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_condition_overview(tuberculosis_TMT_se, condition = NULL)
plot_condition_overview <- function(se, condition = NULL){
  # get condition
  condition <- get_condition_value(se, condition)

  # prepare data
  md <- data.table::as.data.table(SummarizedExperiment::colData(se))
  dt <- md %>% dplyr::count(get(condition))
  colnames(dt) <- c(condition, "n")

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == "qual",]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  p <- ggplot2::ggplot(dt, ggplot2::aes(x=get(condition), y=get("n"), fill=get(condition))) +
    ggplot2::geom_col() +
    ggplot2::labs(x=condition, y="Number of Samples") +
    ggplot2::scale_fill_manual(name=condition, values=col_vector) +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle=45, hjust=0.5, vjust=0.5))
  return(p)
}


#' Boxplots of intensities of specific markers
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param markers Vector of the IDs of the markers to plot
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param id_column String specifying the column of the rowData of the SummarizedExperiment object which includes the IDs of the markers
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param shape_by String specifying the column to shape the samples (If NULL or "No", no shaping of samples is done.)
#' @param facet_norm Boolean indicating whether to facet by normalization method (TRUE) or not (FALSE)
#' @param facet_marker Boolean indicating whether to facet by comparison (TRUE) or not (FALSE). Only valid if facet_norm = FALSE.
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_markers_boxplots(tuberculosis_TMT_se, markers = c("Q7Z7F0", "Q13790"),
#'                      ain = c("log2"), id_column = "Protein.IDs",
#'                      color_by = NULL,
#'                      shape_by = "Pool",
#'                      facet_norm = FALSE,
#'                      facet_marker = TRUE)
#'
plot_markers_boxplots <- function(se, markers, ain = NULL, id_column = "Protein.IDs", color_by = NULL, shape_by = NULL, facet_norm = TRUE, facet_marker = FALSE){
  # check input parameters
  color_by <- get_color_value(se, color_by)
  shape_by <- get_shape_value(se, shape_by)
  ain <- check_input_assays(se, ain)

  # check id_column
  rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  if(!id_column %in% colnames(rd)){
    # if id_column not in rowData
    stop(paste0(id_column, " not in rowData of the SummarizedExperiment object!"))
  }

  # prepare data
  overall_dt <- NULL
  for(assay in c(ain)){
    dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[assay]])
    rd <- subset(data.table::as.data.table(SummarizedExperiment::rowData(se)), select = id_column)
    dt <- cbind(rd, dt)
    melted_dt <- data.table::melt(dt, variable.name = "Column", value.name = "Intensity", id.vars = id_column)
    melted_dt$Method <- assay
    if(is.null(overall_dt)){
      overall_dt <- melted_dt
    } else {
      overall_dt <- rbind(overall_dt, melted_dt)
    }
  }

  # merge colData
  cd <- data.table::as.data.table(SummarizedExperiment::colData(se))
  overall_dt <- merge(overall_dt, cd, by = "Column")
  # subset intensities by markers
  found_markers <- stringr::str_detect(overall_dt[[id_column]], paste(markers, collapse = "|") )
  overall_dt <- overall_dt[found_markers,]

  # color vector
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # facet by normalization method
  plots <- list()
  if(facet_norm){
    for(marker in markers){
      found_markers <- stringr::str_detect(overall_dt[[id_column]], marker )
      tmp <- overall_dt[found_markers,]
      p <- ggplot2::ggplot(tmp, ggplot2::aes(x = get(color_by), y = get("Intensity"), fill = get(color_by))) +
        ggplot2::geom_boxplot() +
        ggplot2::labs(x = color_by, fill = color_by, shape = shape_by, y = "Intensity") +
        ggplot2::scale_fill_manual(values = col_vector) +
        ggplot2::facet_wrap(~Method)
      if(is.null(shape_by)){
        p <- p + ggplot2::geom_point(alpha =0.8, size = 3, position = ggplot2::position_jitterdodge(jitter.width = 0.2, jitter.height = 0))
      } else {
        p <- p + ggplot2::geom_point(ggplot2::aes(shape = get(shape_by)),alpha =0.8, size = 3, position = ggplot2::position_jitterdodge(jitter.width = 0.2, jitter.height = 0))
      }
      plots[[marker]] <- p
    }
  # facet by marker
  } else if(facet_marker){
    for(method in ain){
      tmp <- overall_dt[overall_dt$Method == method,]
      p <- ggplot2::ggplot(tmp, ggplot2::aes(x = get(color_by), y = get("Intensity"), color = get(color_by))) +
        ggplot2::geom_boxplot() +
        ggplot2::labs(x = color_by, color = color_by, shape = shape_by, y = "Intensity") +
        ggplot2::scale_color_manual(values = col_vector) +
        ggplot2::facet_wrap(~Protein.IDs)
      if(is.null(shape_by)){
        p <- p + ggplot2::geom_point(alpha =0.8, size = 3, position = ggplot2::position_jitterdodge(jitter.width = 0.2, jitter.height = 0))
      } else {
        p <- p + ggplot2::geom_point(ggplot2::aes(shape = get(shape_by)),alpha =0.8, size = 3, position = ggplot2::position_jitterdodge(jitter.width = 0.2, jitter.height = 0))
      }
      plots[[method]] <- p
    }
  # do not facet by anything
  } else {
    for(method in ain){
      for(marker in markers){
        tmp <- overall_dt[overall_dt$Method == method,]
        found_markers <- stringr::str_detect(tmp[[id_column]], marker )
        tmp <- tmp[found_markers,]
        p <- ggplot2::ggplot(tmp, ggplot2::aes(x = get(color_by), y = get("Intensity"), color = get(color_by))) +
          ggplot2::geom_boxplot() +
          ggplot2::labs(x = color_by, color = color_by, shape = shape_by, y = "Intensity") +
          ggplot2::scale_color_manual(values = col_vector)
        if(is.null(shape_by)){
          p <- p + ggplot2::geom_point(alpha =0.8, size = 1.5, position = ggplot2::position_jitterdodge(jitter.width = 0.2, jitter.height = 0))
        } else {
          p <- p + ggplot2::geom_point(ggplot2::aes(shape = get(shape_by)),alpha =0.8, size = 1.5, position = ggplot2::position_jitterdodge(jitter.width = 0.2, jitter.height = 0))
        }
        plots[[paste0(method, "_", marker)]] <- p
      }
    }
  }
  return(plots)
}

#' Create an UpSet Plot from SummarizedExperiment Data
#'
#' This function generates an UpSet plot from a given SummarizedExperiment object.
#' It allows for the visualization of overlaps between sets defined by a specific
#' column in the metadata. The function supports subsetting to reference samples
#' and customizable color mapping.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used.)
#' @param label_by String specifying the column in the metadata used to label the samples for the UpSet plot
#' @param mb.ratio A numeric vector of length 2, specifying the barplot and matrix area ratios
#' @param only_refs Logical, if TRUE, only reference samples (ComRef) are included in the plot
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_upset(tuberculosis_TMT_se, color_by = NULL, label_by = NULL,
#'            mb.ratio = c(0.7, 0.3), only_refs = FALSE)
#'
plot_upset <- function(se, color_by = NULL, label_by = NULL, mb.ratio = c(0.7,0.3), only_refs = FALSE){

  # get color and label values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  if(!show_sample_names){
    warning("This type of plot requires a labeling. Hence, the sample names are used!")
    label_by <- "Column"
  }

  # Extract metadata as a DataFrame
  md <- data.table::as.data.table(SummarizedExperiment::colData(se))

  # Create color map and assign colors to md$Color
  md$Color <- stats::setNames(RColorBrewer::brewer.pal(n = length(unique(md[[color_by]])), name = "Set3"),
                       unique(md[[color_by]]))[md[[color_by]]]


  # Extract data from the SummarizedExperiment object
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[["raw"]])
  dt[!is.na(dt)] <- 1
  dt[is.na(dt)] <- 0
  # order md according to dt and color_by (safe)
  md <- md[order(md[[color_by]]),]
  dt <- dt[, md$Column, with = FALSE]
  colnames(dt) <- md[[label_by]]

  # If 'only_refs' is TRUE, subset 'md' to include only reference samples
  if (only_refs) {
    refs <- S4Vectors::metadata(se)$refs
    if(is.null(refs)){
      stop("No reference samples in SummarizedExperiment!")
    } else {
      md <- md[md$Column %in% refs,]
    }
  }

  p <- UpSetR::upset(dt, sets = md[[label_by]], mb.ratio = mb.ratio, keep.order = TRUE,
                     order.by = "degree", sets.bar.color = md$Color,
                     main.bar.color = "#a4bccc", matrix.color = "black",
                     shade.color = "wheat4")
  return(p)
}

#' Plot a heatmap of the sample intensities with optional column annotations for a selection of normalization methods
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param color_by Vector of strings specifying the columns to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bars added.)
#' @param label_by String specifying the column in the metadata used to label the samples for the UpSet plot
#' @param only_refs Logical, if TRUE, only reference samples (ComRef) are included in the plot
#'
#' @return list of ggplot objects
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_heatmap(tuberculosis_TMT_se, ain = c("log2"), color_by = NULL,
#'              label_by = NULL, only_refs = FALSE)
#'
plot_heatmap <- function(se, ain = NULL, color_by = c("Group", "Pool"), label_by = NULL, only_refs = FALSE){
  plots <- list()

    # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }
  # get color_by and label_by values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  # If 'only_refs' is TRUE, subset 'md' to include only reference samples
  if (only_refs) {
    refs <- S4Vectors::metadata(se)$refs
    if(is.null(refs)){
      stop("No reference samples in SummarizedExperiment!")
    } else {
      coldata <- coldata[coldata$Column %in% refs, ]
    }
  }

  # build heatmap annotation
  df_anno <- subset(coldata, select = c(color_by))
  # color vector
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  if(!is.null(color_by)){
    # color generation for annotation
    i <- 1
    color_list <- list()
    for(col in c(color_by)){
      vals <- unique(df_anno[[col]])
      vals <- vals[!is.na(vals)]
      colors <- col_vector[i:(i+length(vals)-1)]
      names(colors) <- vals
      i <- i+length(vals)
      color_list[[col]] <- colors
    }

    # heatmap annotations
    top_anno <- ComplexHeatmap::HeatmapAnnotation(
      df = df_anno,
      col = color_list,
      gp = grid::gpar(col = "black")
    )
  } else {
    top_anno <- NULL
  }



  for(method in ain){
    data <- data.table::as.data.table(SummarizedExperiment::assays(se)[[method]])
    if(only_refs){
      data <- data[,c(refs)]
    }
    # order clustering
    data <- as.matrix(data)
    clustering_cols <- dendsort::dendsort(stats::hclust(stats::dist(t(data))))
    data[is.na(data)] <- -900
    clustering_rows <- dendsort::dendsort(stats::hclust(stats::dist(data)))
    data[data == -900] <- NA
    p <- ComplexHeatmap::Heatmap(data,
                                 name = "Intensity",
                                 column_labels = coldata[[label_by]],
                                 show_column_names = show_sample_names,
                                 top_annotation = top_anno,
                                 show_row_names = FALSE,
                                 cluster_rows = clustering_rows,
                                 cluster_columns = clustering_cols,
                                 use_raster = FALSE)
    plots[[ain]] <- p
  }
  return(plots)
}

#' Upset plots of DE results of the different normalization methods
#'
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#' @param min_degree Minimal degree of an intersection for it to be included
#' @param plot_type String indicating whether to plot a single plot per comparison ("single") or stack the number of DE per comparison ("stacked)
#'
#' @return list of plots and intersection tables (split by comparison if plot_type == "single)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' plot_upset_DE(tuberculosis_TMT_de_res,
#'               ain = c("IRS_on_RobNorm", "IRS_on_Median"),
#'               comparisons = NULL, min_degree = 2,
#'               plot_type = "stacked")
#'
plot_upset_DE <- function(de_res, ain = NULL, comparisons = NULL, min_degree = 2, plot_type = "single") {
  if (packageVersion("ggplot2") >= "4.0.0" &&
      packageVersion("ComplexUpset") <= "1.3.6"){
    message(
      "NOTE: The installed version of ComplexUpset package is not yet",
      "compatible with ggplot2 >= v4.0.0.",
      "Please downgrade to ggplot2 v3 to use this feature.",
      "EpiCompare will proceed without generating upset plot. \n "
    )
    return(NULL)
  } else {
      
    # check parameters
    tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
    de_res <- tmp[[1]]
    ain <- tmp[[2]]
    comparisons <- tmp[[3]]
    stopifnot(plot_type %in% c("single", "stacked"))
    de_res <- de_res[de_res$Assay %in% ain, ]
    de_res <- de_res[de_res$Comparison %in% comparisons,]
    p <- list()
  
    # prepare data for upset
    dt <- de_res[de_res$Change %in% c("Up Regulated", "Down Regulated", "Significant Change"), ]
    dt <- dt[, c("Assay", "Comparison", "Protein.IDs"), with = FALSE]
    dt <- data.table::dcast(dt, Protein.IDs + Comparison ~ Assay, fun.aggregate = length) %>% as.data.frame()
  
    # prepare table of intersections
    available_ains <- colnames(dt[,!colnames(dt) %in% c("Protein.IDs", "Comparison")])
    nr_methods <- data.frame("Protein.IDs" = dt$Protein.IDs, "Comparison" = dt$Comparison, "Nr" = rowSums(dt[,available_ains]))
    dt <- dt %>%
      dplyr::mutate(dplyr::across(dplyr::where(is.factor), as.character))
    t <- purrr::map2_df(dt, names(dt), ~  replace(.x, .x==TRUE, .y))
    t[t == 0] <- NA
    t <- as.data.frame(t)
    res <- t %>% tidyr::unite(., available_ains, col = "Assays", na.rm=TRUE, sep = ",")
    res <- merge(res, nr_methods, by = c("Protein.IDs", "Comparison"))
    res <- res[order(-res$Nr),]
    res <- res[, c("Protein.IDs", "Nr", "Assays", "Comparison")]
    colnames(res) <- c("Protein.IDs", "Number of Intersected Assays", "Assays", "Comparison")
  
    if(plot_type == "stacked"){
      upset <- ComplexUpset::upset(dt, intersect = available_ains, min_degree = min_degree,
                                   base_annotations = list("Intersection Size" = ComplexUpset::intersection_size(counts = TRUE,
                                                                                                                 bar_number_threshold = 1,
                                                                                                                 mapping = ggplot2::aes(fill = Comparison)) + ggplot2::scale_fill_brewer(palette = "Set2", name = "Comparison")))
      p <- list("upset" = upset, "table" = res)
    } else {
  
      for (comp in comparisons) {
        comp_dt <- dt[dt$Comparison == comp, ]
        comp_res <- res[res$Comparison == comp,]
        if (nrow(dt) == 0) {
          warning(paste0("No significant changes for comparison ", comp, ": nothing to plot."))
        } else {
          # plot
          upset <- ComplexUpset::upset(
            comp_dt,
            available_ains,
            name = "",
            set_sizes = ComplexUpset::upset_set_size(position = "right") + ggplot2::ylab("Set Size"),
            sort_sets = FALSE,
            keep_empty_groups = FALSE,
            sort_intersections = "descending",
            min_degree = min_degree,
            base_annotations = list("Intersection Size" =
                                      ComplexUpset::intersection_size(text = list(size = 3))),
            themes = ComplexUpset::upset_default_themes(text = ggplot2::element_text(size = 12))
          )
  
          p[[comp]] <- list("upset" = upset, "table" = comp_res)
        }
      }
    }
    return(p)
  }
}



#' Jaccard similarity heatmap of DE proteins of the different normalization methods
#'
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#' @param plot_type String indicating whether to plot a single plot per comparison ("single"), facet by comparison ("facet_comp"), or include all comparisons in a single plot ("all")
#'
#' @return ggplot object (list of objects if plot_type == "single)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' plot_jaccard_heatmap(tuberculosis_TMT_de_res, ain = NULL,
#'                     comparisons = NULL, plot_type = "all")
#'
plot_jaccard_heatmap <- function(de_res, ain = NULL, comparisons = NULL, plot_type = "single"){
  # check parameters
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  de_res <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]
  stopifnot(plot_type %in% c("single", "facet_comp", "all"))
  de_res <- de_res[de_res$Assay %in% ain, ]
  p <- list()

  # prepare data for upset
  dt <- de_res[de_res$Change != "No Change",]
  dt <- dt[dt$Comparison %in% comparisons,]
  if(plot_type == "all"){
    # take all comparisons
    dt_cast <- data.table::dcast(dt, Assay ~ Protein.IDs, fun.aggregate = length)
    assays <- dt_cast$Assay
    intersections <- as.data.frame(lapply(dt_cast[, -1], function(x) as.integer(x > 0)))
    intersections_m <- as.matrix(intersections)
    intersections_m <- t(intersections_m)
    intersections_dt <- as.data.frame(intersections_m)
    colnames(intersections_dt) <- assays

    jaccard <- function(x, y){
      M.11 <- sum(x == 1 & y == 1)
      M.10 <- sum(x == 1 & y == 0)
      M.01 <- sum(x == 0 & y == 1)
      return(M.11 / (M.11 + M.10 + M.01))
    }

    m <- matrix(data = NA, nrow = ncol(intersections_dt), ncol = ncol(intersections_dt))
    for(i in seq_len(ncol(intersections_dt))){
      for(j in seq_len(ncol(intersections_dt))){
        col1 <- colnames(intersections_dt)[i]
        col2 <- colnames(intersections_dt)[j]
        if(col1 == col2){
          m[i, j] <- 1
        } else if(i > j){
          m[i, j] <- jaccard(intersections_dt[, col1], intersections_dt[, col2])
        }
      }
    }
    colnames(m) <- colnames(intersections_dt)
    rownames(m) <- colnames(intersections_dt)
    melted_m <- reshape2::melt(m, measure.vars = colnames(m), na.rm = TRUE)

    p <- ggplot2::ggplot(melted_m, ggplot2::aes(x = Var1, y = Var2, fill = value)) +
      ggplot2::geom_tile(color = "black") +
      ggplot2::geom_text(ggplot2::aes(label = round(value,digits = 2), color = value > 0.5)) +
      ggplot2::scale_fill_gradient(low = "white", high = "#0072B2") +
      ggplot2::scale_color_manual(values = c("TRUE" = "white", "FALSE" = "black"), guide = "none") +
      ggplot2::labs(x = "Normalization Method", y = "Normalization Method", fill = "Jaccard Similarity") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
  } else{
    # facet by comparison -> need to include all comparisons
    complete_m <- NULL
    for(comp in comparisons){
      dt_comp <- dt[dt$Comparison == comp,]
      # take all comparisons
      dt_cast <- data.table::dcast(dt_comp, Assay ~ Protein.IDs, fun.aggregate = length)
      assays <- dt_cast$Assay
      intersections <- as.data.frame(lapply(dt_cast[, -1], function(x) as.integer(x > 0)))
      intersections_m <- as.matrix(intersections)
      intersections_m <- t(intersections_m)
      intersections_dt <- as.data.frame(intersections_m)
      colnames(intersections_dt) <- assays

      jaccard <- function(x, y){
        M.11 <- sum(x == 1 & y == 1)
        M.10 <- sum(x == 1 & y == 0)
        M.01 <- sum(x == 0 & y == 1)
        return(M.11 / (M.11 + M.10 + M.01))
      }

      m <- matrix(data = NA, nrow = ncol(intersections_dt), ncol = ncol(intersections_dt))
      for(i in seq_len(ncol(intersections_dt))){
        for(j in seq_len(ncol(intersections_dt))){
          col1 <- colnames(intersections_dt)[i]
          col2 <- colnames(intersections_dt)[j]
          if(col1 == col2){
            m[i, j] <- 1
          } else if(i > j){
            m[i, j] <- jaccard(intersections_dt[, col1], intersections_dt[, col2])
          }
        }
      }
      colnames(m) <- colnames(intersections_dt)
      rownames(m) <- colnames(intersections_dt)
      melted_m <- reshape2::melt(m, measure.vars = colnames(m), na.rm = TRUE)
      melted_m$Comparison <- comp
      if(nrow(melted_m) > 1){
        if(is.null(complete_m)){
          complete_m <- melted_m
        } else {
          complete_m <- rbind(complete_m, melted_m)
        }
      } else {
        warning(paste0("Comparison ", comp, " not included in visualization because only 1 normalization approach found DEPs!"))
      }
    }
    if(plot_type == "facet_comp"){
      p <- ggplot2::ggplot(complete_m, ggplot2::aes(x = Var1, y = Var2, fill = value)) +
        ggplot2::geom_tile(color = "black") +
        ggplot2::geom_text(ggplot2::aes(label = round(value,digits = 2), color = value > 0.5)) +
        ggplot2::facet_wrap(~ Comparison, scales = "free") +
        ggplot2::scale_fill_gradient(low = "white", high = "#0072B2") +
        ggplot2::scale_color_manual(values = c("TRUE" = "white", "FALSE" = "black"), guide = "none") +
        ggplot2::labs(x = "Normalization Method", y = "Normalization Method", fill = "Jaccard Similarity") +
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
    } else {
      p <- list()
      for(comp in comparisons){
        tmp <- complete_m[complete_m$Comparison == comp,]
        if(nrow(tmp) > 1){
          p_comp <- ggplot2::ggplot(tmp, ggplot2::aes(x = Var1, y = Var2, fill = value)) +
            ggplot2::geom_tile(color = "black") +
            ggplot2::geom_text(ggplot2::aes(label = round(value,digits = 2), color = value > 0.5)) +
            ggplot2::scale_fill_gradient(low = "white", high = "#0072B2") +
            ggplot2::scale_color_manual(values = c("TRUE" = "white", "FALSE" = "black"), guide = "none") +
            ggplot2::labs(x = "Normalization Method", y = "Normalization Method", fill = "Jaccard Similarity") +
            ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
          p[[comp]] <- p_comp
        }
      }
    }
  }
  return(p)
}


#' Extract consensus DE candidates
#'
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#' @param norm_thr Threshold for the number of normalization methods that must agree on a DE candidate
#' @param per_comparison Logical indicating if the consensus should be calculated per comparison
#'
#' @return data table with consensus DE candidates
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' extract_consensus_DE_candidates(tuberculosis_TMT_de_res, ain = NULL,
#'                   comparisons = NULL, norm_thr = 0.8, per_comparison = TRUE)
#'
extract_consensus_DE_candidates <- function(de_res, ain = NULL, comparisons = NULL, norm_thr = 0.8, per_comparison = FALSE){
  # extract only significant changes
  dt <- de_res[de_res$Change != "No Change",]
  if(!is.null(ain)){
    dt <- dt[dt$Assay %in% ain,]
  } else {
    ain <- unique(dt$Assay)
  }
  # check comparisons
  if(!is.null(comparisons)){
    dt <- dt[dt$Comparison %in% comparisons,]
  }
  if(per_comparison){
    dt <- dt[, c("Protein.IDs", "Assay", "Comparison")]
    count_dt <- dt %>% dplyr::group_by(Protein.IDs, Comparison) %>% dplyr::summarise("Intersections" = dplyr::n())
    count_dt$Percentage <- count_dt$Intersections / length(ain)
    consensus_de <- count_dt[count_dt$Percentage >= norm_thr,]
  } else {
    dt <- dt[, c("Protein.IDs", "Assay")]
    count_dt <- dt %>% dplyr::group_by(Protein.IDs) %>% dplyr::summarise("Intersections" = dplyr::n())
    count_dt$Percentage <- count_dt$Intersections / length(ain)
    consensus_de <- count_dt[count_dt$Percentage >= norm_thr,]
  }
  consensus_de$Percentage <- consensus_de$Percentage * 100
  return(consensus_de)
}

#' Original RobNorm Function
#'
#' To robustly normalize expression data (Author: Meng Wang, https://github.com/mwgrassgreen/RobNorm).
#'
#' @param X.0 The expression matrix in log scale.
#' @param gamma.0 The density exponent parameter gamma, in practice, taking gamma.0 = 0.5 or 1.
#' @param tol The tolerance for interations (default: 10^(-4)).
#' @param step The step limit (default: 50).
#'
#' @return Normalized expression data
#' 
#' @keywords internal
#'
RobNorm <- function (X.0, gamma.0=0.5, tol=10^(-4), step=200) {

  # to select the rows that are nonmissing in at least half of the samples
  id.norm <- rownames(X.0)[rowSums(!is.na(X.0)) >= (ncol(X.0)/2)]
  X.1 <- X.0[id.norm,]

  # to construct the standard samples from row medians
  x.stand <-  apply(X.1, 1, stats::median)
  names(x.stand) <- rownames(X.1)

  X <- cbind(x.stand, X.1)
  I <- nrow(X)
  J <- ncol(X)

  # to initialize parameters
  Nu.0 <- apply(X, 2, function(x) stats::median(x - x.stand, na.rm=TRUE))
  Mu.0 <- apply(X-outer(rep(1, I), Nu.0), 1, mean, na.rm=TRUE)
  sigma2.0 <- apply( (X-outer(rep(1, I), Nu.0)-outer(Mu.0, rep(1, J)))^2, 1, mean, na.rm=TRUE)

  mean.0.mx <- Mu.0 %*% t(rep(1, J)) + rep(1, I) %*% t(Nu.0)
  var.0.mx <- sigma2.0 %*% t(rep(1, J))
  den.0 <- stats::dnorm(X, mean.0.mx, sqrt(var.0.mx))
  dum <- den.0^gamma.0
  dum[is.na(den.0)] <- NA
  w.mx <- dum/(rowSums(dum, na.rm=TRUE) %*% t(rep(1,J)))
  w.size <- rowSums(dum, na.rm=TRUE)

  # to obtain the initial divergence
  divergence.0 <- sum( w.size * ((gamma.0+1) * rowSums(w.mx * (X - Mu.0 %*% t(rep(1, J)) - rep(1, I) %*% t(Nu.0))^2, na.rm=TRUE)  /sigma2.0 + log(2*pi*sigma2.0/(gamma.0+1))  ) )

  # iterations
  para.diff.int <- c()
  divergence.int <- divergence.0
  int <- 0
  flag <- FALSE
  while ( flag == FALSE ) {

    # to update mu and sigma-squared
    Mu.new <- rowSums((X - rep(1,I) %*% t(Nu.0)) * w.mx, na.rm=TRUE)
    sigma2.new <- (rowSums((X - rep(1,I) %*% t(Nu.0) - Mu.new %*% t(rep(1, J)))^2 * w.mx, na.rm=TRUE))*(1+gamma.0)

    # to break the iterations if some sigma-squared is too small (locally trapped)
    if(min(sigma2.new, na.rm=TRUE) < 10^(-10)) {
      Mu.0 <- NULL
      Nu.0 <- NULL
      sigma2.0 <-NULL
      divergence.int <- NULL
      para.diff.int <- NULL
      stop("the pre-chosen gamma is large, to choose a smaller nonnegative gamma")
    }

    # to udpate nu
    weight.nu <- w.mx * ((w.size /(sigma2.new/(1+gamma.0))) %*% t(rep(1, J)))
    Nu.new <- colSums(weight.nu * (X - Mu.new %*% t(rep(1,J))), na.rm=TRUE)/colSums(weight.nu, na.rm=TRUE)
    Mu.new <- Mu.new + Nu.new[1]
    Nu.new <- Nu.new - Nu.new[1]

    para.diff.new <- sum(abs(Mu.new - Mu.0), na.rm=TRUE) + sum(abs(Nu.new - Nu.0), na.rm=TRUE) + sum(abs(sigma2.new - sigma2.0), na.rm=TRUE)
    para.diff.int <- c(para.diff.int, para.diff.new)

    # to update the divergence
    divergence.new <- sum( w.size * ( (gamma.0+1) * rowSums(w.mx * (X - Mu.new %*% t(rep(1, J)) - rep(1, I) %*% t(Nu.new))^2, na.rm=TRUE)  /sigma2.new + log(2*pi*sigma2.new/(gamma.0+1))  ) , na.rm=TRUE)
    divergence.int <- c(divergence.int, divergence.new)

    int <- int + 1
    flag <- (para.diff.new < tol) | (int >= step)

    if (flag == TRUE) break;

    Mu.0 <- Mu.new
    Nu.0 <- Nu.new
    sigma2.0 <- sigma2.new
    mean.0.mx <- Mu.0 %*% t(rep(1, J)) + rep(1, I) %*% t(Nu.0)
    var.0.mx <- sigma2.0 %*% t(rep(1, J))
    den.0 <- stats::dnorm(X, mean.0.mx, sqrt(var.0.mx))

    dum <- den.0^gamma.0
    dum[is.na(den.0)]  <- NA
    w.mx <- dum/ (rowSums(dum, na.rm=TRUE) %*% t(rep(1,J)))
    w.size <- rowSums(dum, na.rm=TRUE)

  }

  nu.rob.est <- Nu.0[-1]
  X.0.rob <- X.0 - outer(rep(1, nrow(X.0)), nu.rob.est)

  return(list(norm.data=X.0.rob, id.norm=id.norm, stand.s=x.stand, nu.est=nu.rob.est, mu.est=Mu.0, sigma2.est=sigma2.0, w.mx=w.mx, divergence=divergence.int, para.diff=para.diff.int))
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)

## ----setup, message = FALSE---------------------------------------------------
library(PRONE)

## ----load_real_tmt------------------------------------------------------------
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se

## -----------------------------------------------------------------------------
se_norm <- normalize_se(se, c("IRS_on_RobNorm", "IRS_on_Median", 
                              "IRS_on_LoessF", "IRS_on_Quantile"), 
                        combination_pattern = "_on_")

## -----------------------------------------------------------------------------
se_norm <- remove_reference_samples(se_norm)

## -----------------------------------------------------------------------------
comparisons <- specify_comparisons(se_norm, condition = "Group", 
                                   sep = NULL, control = NULL)

comparisons <- c("PTB-HC", "TBL-HC", "TBL-PTB", "Rx-PTB")

## -----------------------------------------------------------------------------
de_res <- run_DE(se = se_norm, 
                     comparisons = comparisons,
                     ain = NULL, 
                     condition = NULL, 
                     DE_method = "limma", 
                     logFC = TRUE, 
                     logFC_up = 1, 
                     logFC_down = -1, 
                     p_adj = TRUE, 
                     alpha = 0.05,
                     covariate = NULL, 
                     trend = TRUE,
                     robust = TRUE,
                     B = 100,
                     K = 500
                 ) 

## -----------------------------------------------------------------------------
new_de_res <- apply_thresholds(de_res = de_res, logFC = FALSE, p_adj = TRUE, 
                               alpha = 0.05)

## -----------------------------------------------------------------------------
new_de_res <- apply_thresholds(de_res = de_res, logFC = TRUE, 
                               logFC_up = 0, logFC_down = 0, 
                               p_adj = TRUE, alpha = 0.05)

## ----fig.cap = "Barplot showing the number of DE proteins per normalization method colored by comparison and facetted by up- and down-regulation."----
plot_overview_DE_bar(de_res, ain = NULL, comparisons = comparisons, 
                     plot_type = "facet_regulation")

## ----fig.cap = "Barplot showing the number of DE proteins per normalization method faceted by comparison."----
plot_overview_DE_bar(de_res, ain = NULL, comparisons = comparisons[seq_len(2)], 
                     plot_type = "facet_comp")

## ----fig.cap = "Heatmap showing the number of DE proteins per comparison and per normalization method."----
plot_overview_DE_tile(de_res)

## ----fig.cap = "Volcano plots per normalization method for a single comparison."----
plot_volcano_DE(de_res, ain = NULL, comparisons = comparisons[1], 
                facet_norm = TRUE)

## ----fig.cap = "Individual heatmap of the DE results for a specific comparison and a selection of normalization methods. The adjusted p-values are added as row annotation, while the condition of each sample is shown as column annotation."----
plot_heatmap_DE(se_norm, de_res, ain = c("RobNorm", "IRS_on_RobNorm"), 
                comparison = "PTB-HC", condition = NULL, label_by = NULL, 
                pvalue_column = "adj.P.Val")

## ----fig.cap = "Upset plot showing the overlapping DE proteins of different normalization methods colored by comparison.", fig.height = 12----
intersections <- plot_upset_DE(de_res, ain = NULL, 
                               comparisons = comparisons[seq_len(3)], 
                               min_degree = 6, plot_type = "stacked")
if(!is.null(intersections)){
  # put legend on top due to very long comparisons
intersections$upset[[2]] <- intersections$upset[[2]] + 
  ggplot2::theme(legend.position = "top", legend.direction = "vertical")
intersections$upset
}

## ----fig.cap = "Heatmap showing the Jaccard similarity indices of the DE results between different normalization methods for all comparisons."----
plot_jaccard_heatmap(de_res, ain = NULL, comparisons = comparisons, 
                     plot_type = "all")

## -----------------------------------------------------------------------------
DT::datatable(extract_consensus_DE_candidates(de_res, ain = NULL, 
                                              comparisons = comparisons, 
                                              norm_thr = 0.8, 
                                              per_comparison = TRUE), 
              options = list(scrollX = TRUE))

## -----------------------------------------------------------------------------
enrich_results <- plot_intersection_enrichment(se, de_res, comparison = "PTB-HC", 
                             ain = c("IRS_on_Median", "IRS_on_RobNorm", "RobNorm"), 
                             id_column = "Gene.Names", organism = "hsapiens", 
                             source = "KEGG", signif_thr = 0.05)

## ----fig.cap = "Heatmap showing enriched terms of the DE sets between different normalization methods for a specific comparison."----
enrich_results$enrichment_term_plot


## ----fig.cap = "Heatmap showing the Jaccard similarity indices of the enriched terms between different normalization methods for a specific comparison."----
enrich_results$jaccard_intersection_plot

## -----------------------------------------------------------------------------
utils::sessionInfo()

## ----- Helper Functions ----- ##

#' Function to get a long data table of all intensities of all kind of normalization
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which assay should be used as input (default NULL)
#'            If NULL then all normalization of the SummarizedExperiment object are plotted next to each other (except raw).
#'
#' @return data table
#'
get_complete_dt <- function(se, ain=NULL){
  complete_dt <- NULL
  if(is.null(ain)){
    assays <- names(SummarizedExperiment::assays(se))
  } else {
    assays <- ain
  }
  for(ain in assays){
    if (ain != "raw"){
      dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
      dt$ID <- data.table::as.data.table(SummarizedExperiment::rowData(se))$Protein.IDs
      melted_dt <- data.table::melt(dt, variable.name = "Column", value.name = "Intensity", id.vars = "ID")
      melted_dt <- merge(melted_dt, data.table::as.data.table(SummarizedExperiment::colData(se)),by="Column")
      melted_dt$Assay <- rep(ain,nrow(melted_dt))
      if (is.null(complete_dt)){
        complete_dt <- melted_dt
      } else {
        complete_dt <- rbind(complete_dt, melted_dt)
      }
    }
  }
  return(complete_dt)
}

#' Function to get a long data table of all PCA1 and PCA2 values of all kind of normalization
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which assay should be used as input (default NULL)
#'            If NULL then all normalization of the SummarizedExperiment object are plotted next to each other (except raw).
#'
#' @return data table
#'
get_complete_pca_dt <- function(se, ain=NULL){
  complete_pca_dt <- NULL
  if(is.null(ain)){
    assays <- names(SummarizedExperiment::assays(se))
  } else {
    assays <- c(ain)
  }
  for(ain in assays){
    if (ain != "raw"){
      dt <- SummarizedExperiment::assays(se)[[ain]]
      dt <- dt[!apply(is.na(dt), 1, any),]
      # check if protein group is constant
      rm <- which(apply(t(dt), 2, stats::var)== 0)
      if (!identical(rm, integer(0))){
        dt <- dt[-rm,]
      }
      pca <- stats::prcomp(t(dt), scale.=TRUE)
      pc1 <- round(summary(pca)$importance["Proportion of Variance","PC1"] * 100, 2)
      pc2 <- round(summary(pca)$importance["Proportion of Variance","PC2"] * 100, 2)
      pca_dt <- data.table::data.table(PC1 = pca$x[, "PC1"],
                                       PC2 = pca$x[, "PC2"],
                                       Column = row.names(pca$x))
      pca_dt$Assay <- ain
      pca_dt$PC1_Perc <- pc1
      pca_dt$PC2_Perc <- pc2
      if (is.null(complete_pca_dt)){
        complete_pca_dt <- pca_dt
      } else {
        complete_pca_dt <- rbind(complete_pca_dt, pca_dt)
      }
    }
  }
  return(complete_pca_dt)
}

## ----- Qualitative Evaluation Functions ----- ##

#' Plot the distributions of the normalized data as boxplots
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#' @param facet_norm Boolean specifying whether to facet by normalization methods (default TRUE). If FALSE, list of plots of the different normalized data is returned.
#' @param ncol Number of columns in plot (for faceting)
#'
#'
#' @return if facet_norm = TRUE, ggplot object, else list of ggplot objects
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_boxplots(tuberculosis_TMT_se, ain = NULL, color_by = NULL, label_by = NULL,
#'               facet_norm = TRUE, ncol = 3)
#' plot_boxplots(tuberculosis_TMT_se, ain = c("log2", "IRS_on_RobNorm"), color_by = "Pool",
#'               label_by = "Label", facet_norm = FALSE)
#'
plot_boxplots <- function(se, ain = NULL, color_by = NULL, label_by = NULL, facet_norm = TRUE, ncol = 3){
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }

  # get color and label values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  # get data for plot
  melted_dt <- get_complete_dt(se, ain=ain)
  melted_dt <- melted_dt[order(melted_dt[,color_by]),]

  if(show_sample_names){
    melted_dt$Label <- factor(melted_dt[,label_by], levels = unique(melted_dt[,label_by]))
  } else {
    melted_dt$Label <- factor(melted_dt$Column, levels = unique(melted_dt$Column))
  }

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  if(facet_norm){
    if(is.null(color_by)){
      p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x=get("Intensity"), y=get(label_by))) +
        ggplot2::geom_boxplot() +
        ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
        ggplot2::labs(x="Intensity", y="Samples") +
        ggplot2::facet_wrap(~Assay, scales="free_x", ncol=ncol)
    } else {
      p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x=get("Intensity"), y=get(label_by), fill=get(color_by))) +
        ggplot2::geom_boxplot() +
        ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
        ggplot2::scale_fill_manual(name = color_by, values = col_vector) +
        ggplot2::labs(x="Intensity", y="Samples") +
        ggplot2::facet_wrap(~Assay, scales="free_x", ncol=ncol)
    }
    if(!show_sample_names){
      p <- p + ggplot2::theme(axis.text.y = ggplot2::element_blank())
    }
  } else {
    p <- list()
    for(method in c(ain)){
      dt <- melted_dt[melted_dt$Assay == method,]
      if(is.null(color_by)){
        tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("Intensity"), y=get(label_by))) +
          ggplot2::geom_boxplot() +
          ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
          ggplot2::labs(x="Intensity", y="Samples")
      } else {
        tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("Intensity"), y=get(label_by), fill=get(color_by))) +
          ggplot2::geom_boxplot() +
          ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
          ggplot2::scale_fill_manual(name = color_by, values = col_vector) +
          ggplot2::labs(x="Intensity", y="Samples")
      }
      if(!show_sample_names){
        tmp <- tmp + ggplot2::theme(axis.text.y = ggplot2::element_blank())
      }
      p[[method]] <- tmp
    }
  }
  return(p)
}

#' Plot the densities of the normalized data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param facet_norm Boolean specifying whether to facet by normalization methods (default TRUE). If FALSE, list of plots of the different normalized data is returned.
#' @param ncol Number of columns in plot (for faceting)
#'
#'
#' @return if facet_norm = TRUE, ggplot object, else list of ggplot objects
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_densities(tuberculosis_TMT_se, ain = NULL, color_by = NULL,
#'                           facet_norm = TRUE, ncol = 3)
#' plot_densities(tuberculosis_TMT_se, ain = c("log2", "IRS_on_RobNorm"),
#'                           color_by = "Label",
#'               facet_norm = FALSE)
#'
plot_densities <- function(se, ain = NULL, color_by = NULL, facet_norm = TRUE, ncol = 3){
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }

  # get color and label values
  color_by <- get_color_value(se, color_by)
 
  # get data for plot
  melted_dt <- get_complete_dt(se, ain=ain)

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  if(facet_norm){
    if(is.null(color_by)){
      p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x=get("Intensity"))) +
        ggplot2::geom_density(na.rm=TRUE) +
        ggplot2::labs(x="Intensity", y="Density") +
        ggplot2::facet_wrap(~Assay, scales="free", ncol = ncol)
    } else {
      p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x=get("Intensity"), color=get(color_by))) +
        ggplot2::geom_density(na.rm=TRUE) +
        ggplot2::labs(x="Intensity", y="Density") +
        ggplot2::facet_wrap(~Assay, scales="free", ncol = ncol) +
        ggplot2::scale_color_manual(name = color_by, values = col_vector)
    }
  } else {
    p <- list()
    for(method in c(ain)){
      dt <- melted_dt[melted_dt$Assay == method,]
      if(is.null(color_by)){
        tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("Intensity"))) +
          ggplot2::geom_density(na.rm=TRUE) +
          ggplot2::labs(x="Intensity", y="Density")
      } else {
        tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("Intensity"), color=get(color_by))) +
          ggplot2::geom_density(na.rm=TRUE) +
          ggplot2::labs(x="Intensity", y="Density") +
          ggplot2::scale_color_manual(name = color_by, values = col_vector)
      }
      p[[method]] <- tmp
    }
  }
  return(p)
}


#' PCA plot of the normalized data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#' @param shape_by String specifying the column to shape the samples (If NULL or "No", no shaping of samples is done.)
#' @param facet_norm Boolean specifying whether to facet by normalization methods (default TRUE). If FALSE, list of plots of the different normalized data is returned. However, then you can also facet by any column of the metadata.
#' @param facet_by String specifying the column to facet the samples (If facet = FALSE, the plot will not be faceted by the normalization methods, but instead a list of plots of each normalization method is returned. Then, the PCA plot
#'                 can be faceted by any column of the metadata, for instance by "Batch". If facet_by is NULL or "No", no faceting is performed.)
#' @param ellipse Boolean to indicate if ellipses should be drawn
#' @param ncol Number of columns in plot (for faceting)
#'
#' @return if facet_norm = TRUE, ggplot object, else list of ggplot objects
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_PCA(tuberculosis_TMT_se, ain = NULL, color_by = NULL, label_by = NULL,
#'          shape_by = "Pool",
#'          facet_norm = TRUE, ncol = 3)
#' plot_PCA(tuberculosis_TMT_se, ain = c("IRS_on_RobNorm"), color_by = "Group",
#'               label_by = "Label", facet_norm = FALSE, facet_by = "Pool")
#'
plot_PCA <- function(se, ain=NULL, color_by = NULL, label_by = NULL, shape_by = NULL, facet_norm = TRUE, facet_by = NULL, ellipse = FALSE, ncol = 3){
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }

  # get color and label values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  # get shape value
  shape_by <- get_shape_value(se, shape_by)

  # get facet by value
  if(!facet_norm){
    facet_by <- get_facet_value(se, facet_by)
  }

  # get data for plot
  pca_dt <- get_complete_pca_dt(se, ain=ain)
  pca_dt <- merge(pca_dt, data.table::as.data.table(SummarizedExperiment::colData(se)), by="Column")

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  if(facet_norm){
    # facet by normalization method
    pca_dt$AssayTitle <- paste0(pca_dt$Assay, " (PC1: ", pca_dt$PC1_Perc, "% & PC2: ", pca_dt$PC2_Perc, "%)")
    if(!show_sample_names){
      # no label
      if(is.null(color_by)){
        # no coloring
        if(is.null(shape_by)){
          # no shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol)
        } else {
          # shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), shape = get(shape_by))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol) +
            ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
        }
      } else {
        # coloring
        if(is.null(shape_by)){
          # no shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::scale_color_manual(name = color_by, values = col_vector) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol)
        } else {
          # shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by), shape = get(shape_by))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::scale_color_manual(name = color_by, values = col_vector) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol) +
            ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
        }
      }
    } else {
      # label
      if(is.null(color_by)){
        # no coloring
        if(is.null(shape_by)){
          # no shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), label = get(label_by))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::geom_text(hjust = 0.5, vjust = 1) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol)
        } else {
          # shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), label = get(label_by)), shape = get(shape_by)) +
            ggplot2::geom_point(size = 3) +
            ggplot2::geom_text(hjust = 0.5, vjust = 1) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol) +
            ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
        }
      } else {
        # coloring
        if(is.null(shape_by)){
          # no shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by), label = get(label_by))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::scale_color_manual(name = color_by, values = col_vector) +
            ggplot2::geom_text(hjust = 0.5, vjust = 1) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol)
        } else {
          # shaping
          p <- ggplot2::ggplot(pca_dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by), label = get(label_by), shape = get(shape_by))) +
            ggplot2::geom_point(size = 3) +
            ggplot2::scale_color_manual(name = color_by, values = col_vector) +
            ggplot2::geom_text(hjust = 0.5, vjust = 1) +
            ggplot2::xlab("PC1") +
            ggplot2::ylab("PC2") +
            ggplot2::facet_wrap(~AssayTitle, scales = "free", ncol = ncol) +
            ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
        }
      }
    }

    if(ellipse){
      p <- p + ggplot2::stat_ellipse()
    }
  } else {
    # no facet by normalization method --> individual plots for each normalization method --> but facet_by maybe any other column
    p <- list()
    for(method in c(ain)){
      dt <- pca_dt[pca_dt$Assay == method,]
      if(!show_sample_names){
        # no label
        if(is.null(color_by)){
          # no coloring
          if(is.null(shape_by)){
            # no shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)"))
          } else {
            # shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), shape = get(shape_by))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)")) +
              ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
          }
        } else {
          # coloring
          if(is.null(shape_by)){
            # no shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::scale_color_manual(name = color_by, values = col_vector) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)"))
          } else {
            # shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by), shape = get(shape_by))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::scale_color_manual(name = color_by, values = col_vector) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)")) +
              ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
          }
        }
      } else {
        # label
        if(is.null(color_by)){
          # no coloring
          if(is.null(shape_by)){
            # no shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), label = get(label_by))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::geom_text(hjust = 0.5, vjust = 1) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)"))
          } else {
            # shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), label = get(label_by)), shape = get(shape_by)) +
              ggplot2::geom_point(size = 3) +
              ggplot2::geom_text(hjust = 0.5, vjust = 1) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)")) +
              ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
          }
        } else {
          # coloring
          if(is.null(shape_by)){
            # no shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by), label = get(label_by))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::scale_color_manual(name = color_by, values = col_vector) +
              ggplot2::geom_text(hjust = 0.5, vjust = 1) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)"))
          } else {
            # shaping
            tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("PC1"), y = get("PC2"), color = get(color_by), label = get(label_by), shape = get(shape_by))) +
              ggplot2::geom_point(size = 3) +
              ggplot2::scale_color_manual(name = color_by, values = col_vector) +
              ggplot2::geom_text(hjust = 0.5, vjust = 1) +
              ggplot2::xlab(paste0("PC1 (", unique(dt$PC1_Perc), " %)")) +
              ggplot2::ylab(paste0("PC2 (", unique(dt$PC2_Perc), " %)")) +
              ggplot2::guides(shape=ggplot2::guide_legend(shape_by))
          }
        }
      }
      if(!is.null(facet_by)){
        tmp <- tmp + ggplot2::facet_wrap(~get(facet_by), ncol = ncol)
      }
      if(ellipse){
        tmp <- tmp + ggplot2::stat_ellipse()
      }
      p[[method]] <- tmp
    }
  }
  return(p)
}

## ----- Quantitative Evaluation Functions ----- ##

#' Plot intragroup correlation of the normalized data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param method String specifying the method for correlation calculation (pearson, spearman or kendall)
#'
#' @return ggplot object (boxplot)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_intragroup_correlation(tuberculosis_TMT_se, ain = NULL,
#'                             condition = NULL, method = "pearson")
#'
plot_intragroup_correlation <- function(se, ain = NULL, condition = NULL, method = "pearson"){
  # check method
  stopifnot(method %in% c("pearson", "spearman", "kendall"))

  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }
  assays <- SummarizedExperiment::assays(se)
  exclude <- names(assays)[!names(assays) %in% ain]
  for(e in exclude){
    assays[e] <- NULL
  }

  # get condition
  condition <- get_condition_value(se, condition)

  # condition vector
  condition_vector <- data.table::as.data.table(SummarizedExperiment::colData(se)[, condition])

  # prepare data
  sampleGroupsWithReplicates <- names(table(condition_vector)[table(condition_vector) > 1])
  repCor <- NormalyzerDE:::calculateSummarizedCorrelationVector(
    assays,
    condition_vector,
    sampleGroupsWithReplicates,
    method
  )
  cor_intra <- data.table::as.data.table(repCor)
  cor_intra <- data.table::melt(cor_intra, measure.vars = colnames(cor_intra), variable.name = "Normalization", value.name = "Correlation")
  cor_intra$Normalization <- factor(cor_intra$Normalization, levels = sort(as.character(unique(cor_intra$Normalization))))

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  p <- ggplot2::ggplot(cor_intra, ggplot2::aes(x=get("Normalization"), y=get("Correlation"), fill=get("Normalization"))) +
    ggplot2::geom_boxplot() +
    ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5)) +
    ggplot2::ylab("Pearson Correlation") +
    ggplot2::xlab("Normalization Method") +
    ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector)
  return(p)
}

#' Plot intragroup pooled coefficient of variation (PCV) of the normalized data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition Column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param diff Boolean indicating whether to visualize the reduction of intragroup variation (PCV) compared to "log" (TRUE) or a normal boxplot of intragroup variation (PCV) for each normalization method (FALSE).
#'
#' @return ggplot object (boxplot)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_intragroup_PCV(tuberculosis_TMT_se, ain = NULL,
#'                             condition = NULL, diff = FALSE)
#'
plot_intragroup_PCV <- function(se, ain = NULL, condition = NULL, diff = FALSE){
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }
  assays <- SummarizedExperiment::assays(se)
  exclude <- names(assays)[!names(assays) %in% ain]
  for(e in exclude){
    assays[e] <- NULL
  }

  assays["raw"] <- NULL

  # get condition
  condition <- get_condition_value(se, condition)

  # prepare data
  avgCVPerNormAndReplicates <- NormalyzerDE:::calculateReplicateCV(assays, data.table::as.data.table(SummarizedExperiment::colData(se))[[condition]])
  PCV_intra <- data.table::as.data.table(avgCVPerNormAndReplicates)
  PCV_intra <- data.table::melt(PCV_intra, measure.vars = colnames(PCV_intra), variable.name = "Normalization", value.name = "PCV")
  PCV_intra$Normalization <- factor(PCV_intra$Normalization, levels = sort(as.character(unique(PCV_intra$Normalization))))

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  if(diff){
    # check if log in assays
    if(!"log2" %in% names(assays)){
      stop("Log2 data not in SummarizedExperiment! Difference not applicable.")
    }
    avgcvmempdiff <- NormalyzerDE:::calculatePercentageAvgDiffInMat(avgCVPerNormAndReplicates)
    PCV_diff <- data.table::data.table(Normalization = names(assays), PCV = avgcvmempdiff)
    PCV_diff$Normalization <- factor(PCV_diff$Normalization, levels=sort(as.character(unique(PCV_diff$Normalization))))
    p <- ggplot2::ggplot(PCV_diff, ggplot2::aes(x=get("Normalization"), y=get("PCV"),fill=get("Normalization"))) +
      ggplot2::geom_col() +
      ggplot2::ylab("") +
      ggplot2::xlab("Normalization Method") +
      ggplot2::geom_label(ggplot2::aes(label=round(get("PCV"), digits = 0)), fill="white", show.legend = FALSE, color="black") +
      ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
  } else {
    p <- ggplot2::ggplot(PCV_intra, ggplot2::aes(x=get("Normalization"), y=get("PCV"), fill=get("Normalization"))) +
      ggplot2::geom_boxplot() +
      ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5)) +
      ggplot2::ylab("PCV") +
      ggplot2::xlab("Normalization Method") +
      ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector)
  }
  return(p)
}

#' Plot intragroup pooled median absolute deviation (PMAD) of the normalized data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param diff Boolean indicating whether to visualize the reduction of intragroup variation (PMAD) compared to "log" (TRUE) or a normal boxplot of intragroup variation (PMAD) for each normalization method (FALSE).
#'
#' @return ggplot object (boxplot)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_intragroup_PMAD(tuberculosis_TMT_se, ain = NULL,
#'                             condition = NULL, diff = FALSE)
#'
plot_intragroup_PMAD <- function(se, ain=NULL, condition = NULL, diff = FALSE){
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }
  assays <- SummarizedExperiment::assays(se)
  exclude <- names(assays)[!names(assays) %in% ain]
  for(e in exclude){
    assays[e] <- NULL
  }

  assays["raw"] <- NULL

  # transform assays to matrix
  for(a in names(assays)){
    assays[[a]] <- as.matrix(assays[[a]])
  }

  # get condition
  condition <- get_condition_value(se, condition)

  # prepare data
  avgmadmem <- NormalyzerDE:::calculateAvgMadMem(assays, data.table::as.data.table(SummarizedExperiment::colData(se))[,condition])
  PMAD_intra <- data.table::as.data.table(avgmadmem)
  PMAD_intra <- data.table::melt(PMAD_intra, measure.vars = colnames(PMAD_intra), variable.name = "Normalization", value.name = "PMAD")
  PMAD_intra$Normalization <- factor(PMAD_intra$Normalization, levels = sort(as.character(unique(PMAD_intra$Normalization))))

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  if(diff){
    # check if log in assays
    if(!"log2" %in% names(assays)){
      stop("Log2 data not in SummarizedExperiment! Difference not applicable.")
    }
    avgmadmempdiff<- NormalyzerDE:::calculatePercentageAvgDiffInMat(avgmadmem)
    PMAD_diff <- data.table::data.table(Normalization = names(assays), PMAD = avgmadmempdiff)
    sort_methods <- sort(as.character(unique(PMAD_diff$Normalization)))
    PMAD_diff$Normalization <- factor(PMAD_diff$Normalization, levels=sort_methods)
    p <- ggplot2::ggplot(PMAD_diff, ggplot2::aes(x=get("Normalization"), y=get("PMAD"),fill=get("Normalization"))) +
      ggplot2::geom_col() +
      ggplot2::ylab("") +
      ggplot2::xlab("Normalization Method") +
      ggplot2::geom_label(ggplot2::aes(label=round(get("PMAD"), digits = 0)), fill="white", show.legend = FALSE, color="black") +
      ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
  } else {
    p <- ggplot2::ggplot(PMAD_intra, ggplot2::aes(x=get("Normalization"), y=get("PMAD"), fill=get("Normalization"))) +
      ggplot2::geom_boxplot() +
      ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5)) +
      ggplot2::ylab("PMAD") +
      ggplot2::xlab("Normalization Method") +
      ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector)
  }
  return(p)
}


#' Plot intragroup pooled estimate of variance (PEV) of the normalized data
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param diff Boolean indicating whether to visualize the reduction of intragroup variation (PEV) compared to "log" (TRUE) or a normal boxplot of intragroup variation (PEV) for each normalization method (FALSE).
#'
#' @return ggplot object (boxplot)
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_intragroup_PEV(tuberculosis_TMT_se, ain = NULL,
#'                             condition = NULL, diff = FALSE)
#'
plot_intragroup_PEV <- function(se, ain=NULL, condition = NULL, diff = FALSE){
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }
  assays <- SummarizedExperiment::assays(se)
  exclude <- names(assays)[!names(assays) %in% ain]
  for(e in exclude){
    assays[e] <- NULL
  }
  assays["raw"] <- NULL

  # transform assays to matrix
  for(a in names(assays)){
    assays[[a]] <- as.matrix(assays[[a]])
  }

  # get condition
  condition <- get_condition_value(se, condition)

  # prepare data
  avgVarianceMat <- NormalyzerDE:::calculateAvgReplicateVariation(assays, data.table::as.data.table(SummarizedExperiment::colData(se))[[condition]])
  PEV_intra <- data.table::as.data.table(avgVarianceMat)
  PEV_intra <- data.table::melt(PEV_intra, measure.vars = colnames(PEV_intra), variable.name = "Normalization", value.name = "PEV")
  PEV_intra$Normalization <- factor(PEV_intra$Normalization, levels = sort(as.character(unique(PEV_intra$Normalization))))

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  if(diff){
    # check if log in assays
    if(!"log2" %in% names(assays)){
      stop("Log2 data not in SummarizedExperiment! Difference not applicable.")
    }
    avgvarmempdiff <- NormalyzerDE:::calculatePercentageAvgDiffInMat(avgVarianceMat)
    PEV_diff <- data.table::data.table(Normalization = names(assays), PEV = avgvarmempdiff)
    sort_methods <- sort(as.character(unique(PEV_diff$Normalization)))
    PEV_diff$Normalization <- factor(PEV_diff$Normalization, levels=sort_methods)
    p <- ggplot2::ggplot(PEV_diff, ggplot2::aes(x=get("Normalization"), y=get("PEV"),fill=get("Normalization"))) +
      ggplot2::geom_col() +
      ggplot2::ylab("") +
      ggplot2::xlab("Normalization Method") +
      ggplot2::geom_label(ggplot2::aes(label=round(get("PEV"), digits = 0)), fill="white", show.legend = FALSE, color="black") +
      ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
  } else {
    p <- ggplot2::ggplot(PEV_intra, ggplot2::aes(x=get("Normalization"), y=get("PEV"), fill=get("Normalization"))) +
      ggplot2::geom_boxplot() +
      ggplot2::stat_boxplot(geom ='errorbar', width = 0.4) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5)) +
      ggplot2::ylab("PEV") +
      ggplot2::xlab("Normalization Method") +
      ggplot2::scale_fill_manual(name = "Normalization Method", values = col_vector)
  }
  return(p)
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)

## ----loading, eval = FALSE----------------------------------------------------
# # Official BioC installation instructions
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("PRONE")

## ----message = FALSE----------------------------------------------------------
# Load and attach PRONE
library(PRONE)

## ----echo=FALSE, fig.cap="Six-step workflow of PRONE.", out.width="700px"-----
knitr::include_graphics("../man/figures/Workflow_PRONE.png")

## ----load_real_tmt------------------------------------------------------------
data_path <- readPRONE_example("tuberculosis_protein_intensities.csv")
md_path <- readPRONE_example("tuberculosis_metadata.csv")

data <- read.csv(data_path)
md <- read.csv(md_path)

md$Column <- stringr::str_replace_all(md$Column, " ", ".")

ref_samples <- md[md$Group == "ref",]$Column

se <- load_data(data, md, protein_column = "Protein.IDs", 
                gene_column = "Gene.names", ref_samples = ref_samples, 
                batch_column = "Pool", condition_column = "Group", 
                label_column = "Label")


## ----load_real_lfq------------------------------------------------------------
data_path <- readPRONE_example("mouse_liver_cytochrome_P450_protein_intensities.csv")
md_path <- readPRONE_example("mouse_liver_cytochrome_P450_metadata.csv")

data <- read.csv(data_path, check.names = FALSE)
md <- read.csv(md_path)

se <- load_data(data, md, protein_column = "Accession", 
                gene_column = "Gene names", ref_samples = NULL, 
                batch_column = NULL, condition_column = "Condition", 
                label_column = NULL)

## -----------------------------------------------------------------------------
se

## -----------------------------------------------------------------------------
assays(se)

## -----------------------------------------------------------------------------
se <- normalize_se(se, c("Median", "LoessF"))

## -----------------------------------------------------------------------------
assays(se)

## ----eval = FALSE-------------------------------------------------------------
# if(!dir.exists("output/")) dir.create("output/")
# 
# export_data(se, out_dir = "output/", ain = c("log2", "Median", "LoessF"))

## -----------------------------------------------------------------------------
utils::sessionInfo()

## This file contains code for recreating the data files in the extdata folder. Details about the sources of the individual data files are provided in R/data.R and vignettes.

# Tuberculosis TMT data 
# @source Biadglegne et al. Mycobacterium tuberculosis Affects Protein and Lipid Content of Circulating Exosomes in Infected Patients Depending on Tuberculosis Disease State. Biomedicines 10.4 (Mar. 2022), p. 783. doi: 10.3390/ biomedicines10040783.

data_path <- readPRONE_example("tuberculosis_protein_intensities.csv")
md_path <- readPRONE_example("tuberculosis_metadata.csv")

data <- read.csv(data_path)
md <- read.csv(md_path)
md$Group <- plyr::mapvalues(md$Group, from=c("Common.reference","Healthy.control", "Pulmonary.tuberculosis", "Tuberculous.lymphadenitis", "Treated.pulmonary.tuberculosis"), to = c("ref", "HC", "PTB", "TBL", "Rx"))
md$Column <- stringr::str_replace_all(md$Column, " ", ".")

ref_samples <- md[md$Group == "ref",]$Column

tuberculosis_TMT_se <- load_data(data, md, protein_column = "Protein.IDs", gene_column = "Gene.names", ref_samples = ref_samples, batch_column = "Batch", condition_column = "Condition", label_column = "Label")

# Spike-in Data (Only relevant columns included and subsampled to 1000 proteins due to size restriction)
# @source Jürgen Cox, Marco Y. Hein, Christian A. Luber, Igor Paron, Nagarjuna Nagaraj, and Matthias Mann.Accurate Proteome-wide Label-free Quantification by Delayed Normalization and Maximal Peptide Ratio Extraction, Termed MaxLFQ. Molecular & Cellular Proteomics 13.9 (Sept. 2014), pp. 2513–2526. <https://doi.org/10.1074/mcp.M113.031591>.

data_path <- readPRONE_example("Ecoli_human_MaxLFQ_protein_intensities.csv")
md_path <- readPRONE_example("Ecoli_human_MaxLFQ_metadata.csv")

data <- read.csv(data_path)
md <- read.csv(md_path)

# Check if some protein groups are mixed
mixed <- grepl("Homo sapiens.*Escherichia|Escherichia.*Homo sapiens", data$Fasta.headers)
data <- data[!mixed,]

data$Spiked <- rep("HUMAN", nrow(data))
data$Spiked[grepl("ECOLI", data$Fasta.headers)] <- "ECOLI"

spike_in_se <- load_spike_data(data, md, spike_column = "Spiked", spike_value = "ECOLI", spike_concentration = "Concentration",protein_column = "Protein.IDs", gene_column = "Gene.names", ref_samples = NULL, batch_column = NULL, condition_column = "Condition", label_column = "Label")

# Normalized Data
tuberculosis_TMT_se <- normalize_se(tuberculosis_TMT_se, methods = c("IRS_on_RobNorm", "IRS_on_Median"))
spike_in_se <- normalize_se(spike_in_se, methods = c("RobNorm", "Median", "LoessF", "VSN"))

# Differential Expression Results
se <- remove_reference_samples(tuberculosis_TMT_se)
comparisons <- specify_comparisons(se, condition = "Group", sep = "_", control = NULL)
tuberculosis_TMT_de_res <- run_DE(se = se,
                 comparisons = comparisons,
                 ain = NULL,
                 condition = NULL,
                 DE_method = "limma",
                 covariate = NULL,
                 logFC = TRUE,
                 logFC_up = 1,
                 logFC_down = -1,
                 p_adj = TRUE,
                 alpha = 0.05,
                 B = 100,
                 K = 500)

comparisons <- specify_comparisons(spike_in_se, condition = "Condition", sep = "_", control = NULL)
spike_in_de_res <- run_DE(se = spike_in_se,
                                  comparisons = comparisons,
                                  ain = NULL,
                                  condition = NULL,
                                  DE_method = "limma",
                                  covariate = NULL,
                                  logFC = TRUE,
                                  logFC_up = 1,
                                  logFC_down = -1,
                                  p_adj = TRUE,
                                  alpha = 0.05,
                                  B = 100,
                                  K = 500)


usethis::use_data(tuberculosis_TMT_se, overwrite = TRUE, compress = "xz")
usethis::use_data(tuberculosis_TMT_de_res, overwrite = TRUE, compress = "xz")
usethis::use_data(spike_in_se, overwrite = TRUE, compress = "xz")
usethis::use_data(spike_in_de_res, overwrite = TRUE, compress = "xz")

#' Functional enrichment analysis for analyzing the DE results of different normalization methods and biologically interpreting the results
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param de_res data table resulting of run_DE
#' @param comparison String of comparison (must be a valid comparison saved in de_res)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param id_column String specifying the column of the rowData of the SummarizedExperiment object which includes the gene names
#' @param organism Organism name (gprofiler parameter)
#' @param source Data source to use (gprofiler parameter, example: KEGG)
#' @param signif_thr Significance threshold
#'
#' @return list of ggplot objects
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' data(tuberculosis_TMT_de_res)
#' plot_intersection_enrichment(tuberculosis_TMT_se, tuberculosis_TMT_de_res,
#'                 ain = c("IRS_on_Median", "IRS_on_RobNorm", "RobNorm"),
#'                 comparison = "Rx-TBL", id_column = "Gene.Names",
#'                 organism = "hsapiens", source = "GO:BP", signif_thr = 0.05)
#'
plot_intersection_enrichment <- function(se, de_res, comparison, ain = NULL, id_column = "Gene.Names", organism = "hsapiens", source = "KEGG", signif_thr = 0.05){
  # Check parameters
  tmp <- check_plot_DE_parameters(de_res, ain, c(comparison))
  de_res <- tmp[[1]]
  ain <- tmp[[2]]
  comparison <- tmp[[3]]
  
  # Check id_column
  if(!id_column %in% colnames(de_res)){
    # if id_column not in rowData
    stop(paste0(id_column, " not in DE results!"))
  }
  
  # Prepare DE results
  de_res <- de_res[de_res$Change != "No Change",]
  de_res <- de_res[de_res$Assay %in% ain,]
  de_res <- de_res[de_res$Comparison %in% c(comparison),]
  dt <- de_res
  
  assay_ordering <- levels(de_res$Assay)
  if(is.null(assay_ordering)){
    assay_ordering <- unique(de_res$Assay)
  }
  
  # Prepare queries for gProfiler
  queries <- lapply(ain, function(method) {
    dt <- dt[dt$Assay == method, ]
    query <- dt[[id_column]]
    query <- unique(query[query != ""])
    # split by ;
    query <- unlist(strsplit(query, ";"))
    query
  })
  names(queries) <- ain
  
  # Run gProfiler
  gres <- gprofiler2::gost(queries, organism = organism, 
                           sources = c(source), user_threshold = signif_thr)
  gres <- gres$result
  gres <- gres[, c("query", "term_name", "source")]
  gres$present <- 1
  dt <- data.table::dcast(data.table::as.data.table(gres), 
                          ... ~ query, value.var = "present")
  dt[is.na(dt)] <- 0
  
  
  # Prepare results for clustering and Jaccard
  cluster_dt <- dt
  terms <- cluster_dt$term_name
  cluster_dt$term_name <- NULL
  cluster_dt$source <- NULL
  cluster_dt <- as.data.frame(cluster_dt)
  rownames(cluster_dt) <- terms

  # Clustering for heatmap
  tryCatch({
    dist.mat <- vegan::vegdist(cluster_dt, method = "jaccard")
    clust.res <- stats::hclust(dist.mat)
    ordering_terms <- rownames(cluster_dt)[clust.res$order]
    
    dist.mat <- vegan::vegdist(t(cluster_dt), method = "jaccard")
    clust.res <- stats::hclust(dist.mat)
    ordering_assays <- rownames(t(cluster_dt))[clust.res$order]
  }, error = function(e){
    message("Error in clustering: ", e)
    message("Rows and columns in enrichment heatmap not clustered!")
    ordering_terms <- rownames(cluster_dt)
    ordering_assays <- colnames(cluster_dt)
  })
  
  # Jaccard distance
  jaccard <- function(x, y){
    M.11 <- sum(x == 1 & y == 1)
    M.10 <- sum(x == 1 & y == 0)
    M.01 <- sum(x == 0 & y == 1)
    return(M.11 / (M.11 + M.10 + M.01))
  }
  
  assays_without_terms <- assay_ordering[!assay_ordering %in% colnames(dt)]
  # add tables with 0 for assays without terms
  for(assay in assays_without_terms){
    cluster_dt[, assay] <- 0
  }
  
  cluster_dt <- cluster_dt[, assay_ordering]
  
  m <- matrix(data = NA, nrow = ncol(cluster_dt), ncol = ncol(cluster_dt))
  for(i in seq_len(ncol(cluster_dt))){
    for(j in seq_len(ncol(cluster_dt))){
      col1 <- colnames(cluster_dt)[i]
      col2 <- colnames(cluster_dt)[j]
      if(col1 == col2){
        m[i, j] <- 1
      } else if(i > j){
        m[i, j] <- jaccard(cluster_dt[, col1], cluster_dt[, col2])
      }
    }
  }
  colnames(m) <- colnames(cluster_dt)
  rownames(m) <- colnames(cluster_dt)
  
  melted_m <- reshape2::melt(m, measure.vars = colnames(m), na.rm = TRUE)
  
  # Jaccard heatmap
  melted_m$Var1 <- factor(melted_m$Var1, levels = assay_ordering)
  melted_m$Var2 <- factor(melted_m$Var2, levels = assay_ordering)
  
  jaccard_heatmap <- ggplot2::ggplot(melted_m, ggplot2::aes(x = Var1, y = Var2, fill = value)) +
    ggplot2::geom_tile(color = "black") +
    ggplot2::geom_text(ggplot2::aes(label = round(value,digits = 2), color = value > 0.5)) +
    ggplot2::scale_fill_gradient(low = "white", high = "#0072B2", limits = c(0,1)) +
    ggplot2::scale_color_manual(values = c("TRUE" = "white", "FALSE" = "black"), guide = "none") +
    ggplot2::labs(x = "Normalization Method", y = "Normalization Method", fill = "Jaccard Similarity") +
    ggplot2::theme_bw() +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust =0.5))
  
  # Prepare data for intersection heatmap
  dt[dt == 1] <- "Yes"
  dt[dt == 0] <- "No"
  melted_dt <- data.table::melt(data.table::as.data.table(dt), 
                                value.name = "Present", variable.name = "Assay", 
                                measure.vars = colnames(dt)[!colnames(dt) %in% 
                                                              c("term_name", "source")])
  
  melted_dt$term_name <- factor(melted_dt$term_name, levels = ordering_terms)
  melted_dt$Assay <- factor(melted_dt$Assay, levels = ordering_assays)
  enrich_heatmap <- ggplot2::ggplot(melted_dt, ggplot2::aes(x = get("Assay"), 
                                                            y = get("term_name"), fill = get("Present"))) + ggplot2::geom_tile(color = "white") + 
    ggplot2::scale_fill_manual(name = "Significant", 
                               values = c(No = "grey80", Yes = "#D55E00")) + 
    ggplot2::labs(x = "Normalization Method", y = "Terms") +  ggplot2::theme_bw() +
    
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, 
                                                       vjust = 0.5,
                                                       hjust=1))
  return(list("enrichment_term_plot" = enrich_heatmap, "jaccard_intersection_plot" = jaccard_heatmap))
}

#' Method to impute SummarizedExperiment. 
#' This method performs a mixed imputation on the proteins. It uses a k-nearest neighbor imputation for proteins with missing values at random (MAR) and imputes missing values by random draws from a left-shifted Gaussian distribution for proteins with missing values not at random (MNAR).
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics dataset
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition name of column of colData(se) representing the conditions of the data
#'
#' @return SummarizedExperiment with imputed intensities
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- remove_samples_manually(tuberculosis_TMT_se,
#'                           column = "Label", values = c("1.HC_Pool1"))
#' tuberculosis_TMT_se <- impute_se(tuberculosis_TMT_se, ain = NULL,
#'                           condition = NULL)
#'
#' @importFrom MSnbase MSnSet
impute_se <- function(se, ain = NULL, condition = NULL){
  se_imputed <- se
  # check input
  condition <- get_condition_value(se, condition)
  assays <- check_input_assays(se, ain)

  for(ain in assays){
    dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
    dt$ID <- rownames(dt)
    dt <- data.table::melt(dt, id.vars = "ID", variable.name = "Column", value.name = "Intensity")
    coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
    dt <- merge(dt, coldata, by = "Column")

    proteins_MNAR <- dt %>%
      dplyr::group_by(ID, get(condition)) %>%
      dplyr::summarize(NAs = all(is.na(Intensity))) %>%
      dplyr::filter(NAs) %>%
      dplyr::pull(ID) %>%
      unique()

    # Get a logical vector
    original_dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
    MNAR <- rownames(original_dt) %in% proteins_MNAR
    MAR <- !rownames(original_dt) %in% proteins_MNAR

    # Impute MAR
    # Perform knn imputation using the MSnBase impute method
    MAR_dt <- original_dt[MAR,,drop=FALSE] # use Msnbase impute method with fun="knn
    # Use MsnSet::impute function
    MSnSet_dt <- methods::new("MSnSet",exprs=as.matrix(MAR_dt))
    MsnSet_imputed <-  MSnbase::impute(MSnSet_dt,method="knn")
    MAR_dt <- MSnbase::exprs(MsnSet_imputed)

    # Impute MNAR
    # Rebuild DEP method (impute_manual)
    MNAR_dt <- original_dt[MNAR,,drop=FALSE]

    MNAR_prot_id <- row.names(MNAR_dt)
    MNAR_dt <- as.data.frame(MNAR_dt)
    MNAR_dt <- cbind(ID = MNAR_prot_id , MNAR_dt)

    scale <- 0.3
    shift <- 2.0

    # Get descriptive parameters of the current sample distributions
    stat <- MNAR_dt %>%
      tidyr::gather(Column, Intensity, -ID) %>%
      dplyr::filter(!is.na(Intensity)) %>%
      dplyr::group_by(Column) %>%
      dplyr::summarise(mean = mean(Intensity), median = stats::median(Intensity), sd = stats::sd(Intensity), n = dplyr::n(), infin = nrow(MNAR_dt) - n)

    names(stat) <- c("Column", "mean", "median", "sd", "n", "infin")
    # Impute missing values by random draws from a distribution
    # which is left-shifted by parameter 'shift' * sd and scaled by parameter 'scale' * sd.
    for (a in seq_len(nrow(stat))){
      MNAR_dt[is.na(MNAR_dt[, stat[, "Column"][[1]][a]]), stat[, "Column"][[1]][a]] <-
        stats::rnorm(stat$infin[a],
              mean = stat$median[a] - shift * stat$sd[a],
              sd = stat$sd[a] * scale)
    }
    # Remove ID
    MNAR_dt$ID <- NULL

    # Combine MNAR imputed counts and MAR imputed counts
    imputed_dt <- rbind(MAR_dt, MNAR_dt)
    SummarizedExperiment::assay(se_imputed, paste0(ain, "_imputed"), FALSE) <- data.table::as.data.table(imputed_dt)
  }
  return(se_imputed)
}

# This software is released unde The GNU General Public License:
# http://www.gnu.org/licenses/gpl.html

# EigenMS normalization
# Ref: "Normalization of peak intensities in bottom-up MS-based proteomics using
#       singular value decomposition" Karpievitch YV, Taverner T, Adkins JN,
#       Callister SJ, Anderson GA, Smith RD, Dabney AR. Bioinformatics 2009
# and
# Ref: "Metabolomics data normalization with EigenMS"
#       Karpievitch YK, Nikolic SB, Wilson R, Sharman JE, Edwards LM
#       Submitted to PLoS ONE
#
# Here we allow multiple facotrs to be preserved in ANOVA model before identifying bais.
# This requires a bit of thought on the side of the researchers, only few factors should be 'preserved'.
# For example 'treatment group' is important to preserve but 'age' may or may not be important to preserve.
# Here we do not utilize peptides with 1+ grp missing completely, this is a separate problem
# addressed by Wang et al, 2011
#
# Written by Yuliya Karpievitch, Tom Taverner, and Shelley Herbrich
# email: yuliya.k@gmail.com
#
# Version has been split into 2 main functions: eig_norm1 finds significant bias trends,
# then the user can decide if he/she wants to use that number.
# For Matabolomics data we suggest useing 20% of the number of samples examined
# as the number of bias trends to eliminated. By setting
# ints_eig1$h.c = ceil(.2 * num_samples)
# if the number of automatically identified bias trends are close to that number we suggest
# using the estimated number of bias trends.
#
# eig_norm2 function normalizes the data
# Note that rescaling has been abandoned in the latest version due to discussions abot the fact
# that systematic bias is what has been inadvertently added, thus we need to remove the bias
# but nto add any additional variation.
# Metabolomics in particular has a lot of variation that still remains that we concluded
# there is not need for rescaling.
#
# EigenMS estimates and preserves fixed effects.
# Contributions to using Random effects are welcome.

# HOWTO RUN:
# source('~/EigenMS/EigenMS.R')
# dd = # read in the data
# grps = # read in group information file
# logInts = # subset the dd matrix to only hte portion that contains intensities
#           # replace 0's with NAs, do a log-transformation to approximate Normality.
# prot.info = cbind(data.frame(rownames(dd)), data.frame(rownames(dd))) # peptideIDs, no PR IDs here, just duplicate column
#             # in case od protein IDs, those are not importnat for normalization and will be ignored.
# ints_eig1 = eig_norm1(m=logInts, treatment=grps, prot.info=prot.info)
# ints_norm = eig_norm2(rv=ints_eig1)
#
# eig_norm1 = function(m, treatment, prot.info, write_to_file='')
#       m - m x n matrix of log-transformed intensities, num peptides x num samples
#       treatment - either a single factor or a data.frame of factors (actual R factors, else code will fail)
#                   eg:  bl = gl(3,14,168) # 3 factors, repeat every 14 times, total of 168 samples
#                        it = gl(2,7,168)  # 2 factors, repeat every 7 samples, 168 total
#                        Pi = gl(2,42,168) # 2 factors, repeat twice: 42 of PI+, PI-, PI+, PI-
#                       grpFactors = data.frame(bl,it,Pi)# factors we would like to preserve in EigenMS
#       prot.info - 2 column data frame with peptide and protein IDs in that order.
#                   for metabolites both columns should contain metabolite IDs.
#       write_to_file -  if a string is passed in, 'complete' peptides will be written to that file name
#                       Some peptides could be eliminated due to too many missing values (if not able to do ANOVA)

# SUPPLEMENTARY FUNCTION USED BY EIGENMS
# plot top 3 eigentrends with a line at 0.
# in cse of a single treatment group u and v matrices are switched..
# plot.eigentrends = function(svdr, title1) {
#   v = svdr$v
#   d = svdr$d
#   ss = d ^ 2
#   Tk = signif(ss / sum(ss) * 100, 2)
#
#   titles = paste("Trend ", 1:3, " (", Tk[1:3], "%)", sep = "")
#   do.text = function(j)
#     mtext(titles[j],
#           cex = 0.7,
#           padj = -0.7,
#           adj = 1)
#   range.y = range(as.numeric(v[, 1:3]), na.rm = T)
#
#   toplot1_1 = as.numeric(v[, 1])
#   toplot1_2 = as.numeric(v[, 2])
#   toplot1_3 = as.numeric(v[, 3])
#
#   plot(
#     c(1:length(toplot1_1)),
#     toplot1_1,
#     type = 'b',
#     ann = F,
#     ylim = range.y
#   )
#   do.text(1)
#   abline(h = 0, lty = 3)
#   title(
#     title1,
#     cex.main = 1.2,
#     font.main = 1,
#     col.main = "purple",
#     ylab = NULL
#   )
#   plot(
#     c(1:length(toplot1_2)),
#     toplot1_2,
#     type = 'b',
#     ann = F,
#     ylim = range.y
#   )
#   do.text(2)
#   abline(h = 0, lty = 3)
#   plot(
#     c(1:length(toplot1_3)),
#     toplot1_3,
#     type = 'b',
#     ann = F,
#     ylim = range.y
#   )
#   do.text(3)
#   abline(h = 0, lty = 3)
#   return(Tk)
# }
#
# # plot any 3 eigentrends with a line at 0. Strting at the trend number passed in
# # pos1 parameter provide the starting index for teh 3 trends
# # in cse of a single treatment group u and v matrices are switched..
# plot.eigentrends.start = function(svdr, title1, pos1 = 1) {
#   # No check for valid range of pos1 is performed!!!
#   v = svdr$v
#   d = svdr$d
#   ss = d ^ 2
#   Tk = signif(ss / sum(ss) * 100, 2)
#   #  pe = signif(d/sum(d, na.rm=T)*100, 2)
#   titles = paste("Trend ", pos1:(pos1 + 3), " (", Tk[pos1:(pos1 + 3)], "%)", sep = "")
#   do.text = function(j)
#     mtext(titles[j],
#           cex = 0.7,
#           padj = -0.7,
#           adj = 1)
#   range.y = range(as.numeric(v[, pos1:(pos1 + 3)]), na.rm = T)
#
#   toplot1_1 = as.numeric(v[, pos1])
#   toplot1_2 = as.numeric(v[, (pos1 + 1)])
#   toplot1_3 = as.numeric(v[, (pos1 + 2)])
#
#   plot(
#     c(1:length(toplot1_1)),
#     toplot1_1,
#     type = 'b',
#     ann = F,
#     ylim = range.y
#   )
#   do.text(1)
#   abline(h = 0, lty = 3)
#   title(
#     title1,
#     cex.main = 1.2,
#     font.main = 1,
#     col.main = "purple",
#     ylab = NULL
#   )
#   plot(
#     c(1:length(toplot1_2)),
#     toplot1_2,
#     type = 'b',
#     ann = F,
#     ylim = range.y
#   )
#   do.text(2)
#   abline(h = 0, lty = 3)
#   plot(
#     c(1:length(toplot1_3)),
#     toplot1_3,
#     type = 'b',
#     ann = F,
#     ylim = range.y
#   )
#   do.text(3)
#   abline(h = 0, lty = 3)
#   return(Tk)
# }

# not used in EigenMS
make.formula.string <- function(factors, do.interactions=FALSE){
  fs <- "1"
  if(length(factors)){
    fs <- paste(factors, collapse=" + ")
    if(do.interactions && length(factors) > 1)
      fs <- paste(unlist(lapply(as.data.frame(t(gtools::combinations(length(factors), 2, factors)), stringsAsFactors=FALSE), paste, collapse="*")), collapse = " + ")
  }
  return(fs)
}


# make a string formula to use in 'lm' call when computing grp differences to preserve
makeLMFormula <- function(eff, var_name='') {
  # eff - effects used in contrasts
  # var_name - for singe factor use var-name that is passed in as variable names, otherwise it has no colnmae
  #           only used for a single factor
  if(is.factor(eff)){
    ndims <- 1
    cols1 <- var_name # ftemp in EigenMS
  }
  else
  {
    ndims <- dim(eff)[2]
    cols1 <- colnames(eff)
  }
  lhs <- cols1[1]
  lm.fm <- NULL
  # check if can have a list if only have 1 factor...

  params <- paste('contrasts=list(', cols1[1], '=contr.sum', sep=)

  if (ndims > 1) { # removed ndims[2] here, now ndims holds only 1 dimention...
    for (ii in 2:length(cols1))
    {
      lhs <- paste(lhs, "+", cols1[ii])  # bl="contr.sum",
	    params <- paste(params, ',', cols1[ii], '=contr.sum', sep='')
	  }
  }
  params <- paste(params,")")
  lm.formula <- stats::as.formula(paste('~', lhs))
  lm.fm$lm.formula <- lm.formula
  lm.fm$lm.params <- params
  return(lm.fm)
}


# First portion of EigenMS: identify bias trends
eig_norm1 <- function(m, treatment, prot.info, write_to_file=''){
# Identify significant eigentrends, allow the user to adjust the number (with causion! if desired)
# before normalizing with eig_norm2
#
# Input:
#   m: An m x n (peptides x samples) matrix of expression data, log-transformed!
#      peptide and protein identifiers come from the get.ProtInfo()
#   treatment:  either a single factor indicating the treatment group of each sample i.e. [1 1 1 1 2 2 2 2...]
#               or a frame of factors:  treatment= data.frame(cbind(data.frame(Group), data.frame(Time))
#   prot.info: 2+ colum data frame, pepID, prID columns IN THAT ORDER.
#              IMPORTANT: pepIDs must be unique identifiers and will be used as Row Names
#              If normalizing non-proteomics data, create a column such as: paste('ID_',seq(1:num_rows), sep='')
#              Same can be dome for ProtIDs, these are not used for normalization but are kept for future analyses
#   write_to_file='' - if a string is passed in, 'complete' peptides (peptides with NO missing observations)
#              will be written to that file name
#
# Output: list of:
#   m, treatment, prot.info, grp - initial parameters returned for futre reference
#   my.svd - matrices produced by SVD
#   pres - matrix of peptides that can be normalized, i.e. have enough observations for ANOVA,
#   n.treatment - number of factors passed in
#   n.u.treatment - number of unique treatment facotr combinations, eg:
#                   Factor A: a a a a c c c c
#                   Factor B: 1 1 2 2 1 1 2 2
#                   then:  n.treatment = 2; n.u.treatment = 4
#   h.c - bias trends
#   present - names/IDs of peptides on pres
#   complete - complete peptides, no missing values, these were used to compute SVD
#   toplot1 - trends automatically produced, if one wanted to plot at later time.
#   Tk - scores for each bias trend
#   ncompl - number of complete peptides with no missing observations
  print("Data dimentions: ")
  print(dim(m))
  # check if treatment is a 'factor' vs data.frame', i.e. single vs multiple factors
  if(methods::is(treatment, "factor")) { # TRUE if one factor
     n.treatment <- 1 # length(treatment)
     n.u.treatment <- length(unique(treatment))[1]
  } else { # data.frame
    n.treatment <- dim(treatment)[2]
    n.u.treatment <- dim(unique(treatment))[1] # all possible tretment combinations
  }
  # convert m to a matrix from data.frame
  m <- as.matrix(m) # no loss of information

  # filter out min.missing, here just counting missing values
  # if 1+ treatment completely missing, cannot do ANOVA, thus cannot preserve grp diff.
  # IMPORTANT: we create a composite grp = number of unique combinations of all groups, only for
  # 'nested' groups for single layer group is left as it is
  grpFactors <- treatment # temporary var, leftover from old times...

  nGrpFactors <- n.treatment # length(colnames(treatment)) # not good: dim(grpFactors)
  if(nGrpFactors > 1) { # got nested factors
    ugrps <- unique(grpFactors)
    udims <- dim(ugrps)
    grp <- NULL
    for(ii in seq_len(udims[1])) {
      pos <- grpFactors[,1] == ugrps[ii,1] # set to initial value
      for(jj in seq(2,udims[2])) {
	    pos <- pos & grpFactors[,jj] == ugrps[ii,jj]
      }
	  grp[pos] <- rep(ii, sum(pos))
    }
	grp <- as.factor(grp)
  } else {
    grp <- treatment
  }
  nobs <- array(NA, c(nrow(m), length(unique(grp)))) # noobs = number of observations

  print('Treatmenet groups:')
  print(grp)

  for(ii in seq_len(nrow(m))) {
    for(jj in seq_len(length(unique(grp)))) {
      nobs[ii,jj] <- sum(!is.na(m[ii, grp==unique(grp)[jj]])) # total number of groups num(g1) * num(g2) * ...
    }
  }
  # now 'remove' peptides with missing groups
  present.min <- apply(nobs, 1, min) # number present in each group
  ii <- present.min == 0   # 1+ obs present in ALL of the groups
  nmiss <- sum(present.min == 0) # not used, one value of how many peptides have 1+ grp missing completely
  pmiss <- rbind(m[ii,]) # these have 1+ grp missing !!!!
  # rownames must be UNIQUE, if have possible duplicates: use 'ii' ?
  rownames(pmiss) <- prot.info[ii,1]  # set rownames,

  # create matrix for peptides with enough observations for ANOVA
  # 'present' are names of the peptides (pepID) and 'pres' are abundances
  # NOTE: ! negates the proteins, so we get ones that have 1+ obs in each group
  present <- prot.info[which(!prot.info[,1] %in% rownames(pmiss)), ] # rownames OK
  # pres = m[which(!rownames(m) %in% rownames(pmiss)), ]
  pres <- m[which(!prot.info[,1] %in% rownames(pmiss)), ] # is this OK?
  rownames(pres) <- prot.info[which(!prot.info[,1] %in% rownames(pmiss)),1]

  print('Selecting complete peptides')
  # Should issue an error message if we have NO complete peptides.
  # select only 'complete' peptides, no missing values
  nobs <- array(NA, nrow(pres)) # reassign noobs to dims of 'present'
  numiter <- nrow(pres)
  for (ii in seq_len(numiter)) {
    # if(ii %% 100 == 0) { print(ii) }
    nobs[ii] <- sum(!is.na(pres[ii,]))
  }

  iii <- nobs == ncol(pres)
  complete <- rbind(pres[iii,])

  #  write out a file of complete peptides if file name is passed in
  if(write_to_file != '') {
    utils::write.table(complete, file = write_to_file, append = FALSE,
             quote = FALSE, sep = "\t",
             eol = "\n", na = "NaN", dec = ".", row.names = TRUE,
             col.names = TRUE, qmethod = c("escape", "double"))
  }

  # compute bias with 'complete' matrix and residuals from 'present'
  # calculate eigenpeptides for 'complete' data only
  # if have only 1 group, we do not need to preserve group differernces, everything is the same group, ex: QC samples
  # contrasts will fail if have only 1 group, thus have else
  if(n.u.treatment > 1) {
    print('Got 2+ treatment grps')
    # check to see if we have multiple factors
	  grpdim <- dim(treatment)

	  lm.fm <- makeLMFormula(treatment, 'TREAT') # using general function that can accomodate for 1+ number of factors
    TREAT <- treatment
    TREAT <- data.frame(treatment) # temp var to work if we got only 1 treatment vector.
    if(methods::is(treatment,"factor")) {
      colnames(TREAT) <- "TREAT"
     } else {
      colnames(TREAT) <- colnames(treatment)
    }
    attach(TREAT)

    mod.c <- stats::model.matrix(lm.fm$lm.formula, data=TREAT, eval(parse(text=lm.fm$lm.params)))
	  Y.c <- as.matrix(complete)
	  options(warn = -1)

    # use lm() to get residuals
    formula1 <- paste('t(Y.c)~', as.character(lm.fm$lm.formula)[2], sep = '')
    TREAT <- treatment
    fit_lmAll <- stats::lm(eval(parse(text=formula1)))
    R.c <- stats::residuals(fit_lmAll)  # Oct 2 messing with residuals...
  } else {  # 1 group only, set residuals to original matrix
    print('Got 1 treatment grp')
	  mod.c <- as.numeric(t(treatment))
    R.c <- t(as.matrix(complete))  # needs to be transposed to match the matrix returned from lm
    TREAT <- treatment
  }

  print('Computing SVD, estimating Eigentrends...') # let user know what is going on
  # residuals are centered around 0, here center samples not peptides/metabolites
  # centering is basic normalization

  R.c_center <- scale(R.c, center = TRUE, scale = FALSE)  # t(scale(t(R.c), center = TRUE, scale = FALSE))
  my.svd <- svd(R.c_center)  # can use wrapper below to chek if SVD has a problem...
  temp <- my.svd$u
  my.svd$u <- my.svd$v
  my.svd$v <- temp

  #identify number of eigenvalues that account for a significant amount of residual variation
  numcompletepep <- dim(complete)[1] # save to return to the user as part of the return list
  # this is important info for publications
  # tell users how many peptides/metabolites the trends are based on
  # can also be determined by doing dim(return_value_fromEIg_norm1$pres)

  print(paste('Number of treatments: ', n.u.treatment))
  h.c <- sva.id(complete, treatment, n.u.treatment, lm.fm=lm.fm)$n.sv
  print(paste("Number of significant eigenpeptides/trends", h.c) )

  # show RAW trends
  # center each peptide around zero (subtract its mean across samples)
  complete_center <- scale(t(complete), center = TRUE, scale = FALSE)
  print('Preparing to plot...')

  n.u.treatment
  toplot1 <- svd(complete_center) # scales above
  temp <- toplot1$u
  toplot1$u <- toplot1$v
  toplot1$v <- temp

  graphics::par(mfcol=c(3,2))
  graphics::par(mar = c(2,2,2,2))
  #plot.eigentrends(toplot1, "Raw Data")
  #plot.eigentrends(my.svd, "Residual Data")

  d <- my.svd$d;  ss <- d^2;
  Tk <- signif(ss/sum(ss)* 100, 2)

  retval <- list(m=m, treatment=treatment, my.svd=my.svd,
            pres=pres, n.treatment=n.treatment, n.u.treatment=n.u.treatment,
            h.c=h.c, present=present, prot.info=prot.info,
            complete=complete, toplot1=toplot1, Tk=Tk, ncompl=numcompletepep,
            grp=grp)
  return(retval)
}


# Second portion of EigenMS: remove effects of bias
# split into 2 functions to allo the user to examine the bias trends and be able to change the number
# by resetting h.c returned by eig_norm1(return_value_from_eig_norm1)
eig_norm2 <- function(rv) {
  # UNPUT:
  #   rv - return value from the eig_norm1
  #   if user wants to change the number of bias trends that will be eliminated h.c in rv should
  #   be updates to the desired number
  #
  # OUTPUT:
  #   normalized - matrix of normalized abundances with 2 columns of protein and peptdie names
  #   norm_m - matrix of normalized abundances, no extra columns
  #   eigentrends - found in raw data, bias trendsup to h.c
  #   rescrange - rescaling range for the addition of the while noise to avoid overfitting
  #   norm.svd - trends in normalized data, if one wanted to plot at later time.
  #   exPeps - excluded peptides - excluded due to exception in fitting a linear model

  m <- rv$pres # yuliya: use pres matrix, as we cannot deal with m anyways, need to narrow it down to 'complete' peptides
  treatment <- rv$treatment
  my.svd <- rv$my.svd
  pres <- rv$pres
  n.treatment <- rv$n.treatment
  n.u.treatment <- rv$n.u.treatment
  numFact <- dim(rv$treatment)[2]
  print(paste('Unique number of treatment combinations:', n.u.treatment) )
  h.c <- rv$h.c
  present <- rv$present
  toplot1 <- rv$toplot1
  # vector of indicators of peptides that threw exeptions
  exPeps <- vector(mode = "numeric", length = nrow(pres))

  print("Normalizing...")
  treatment <- data.frame(treatment) # does this need to be done?
  if(n.u.treatment > 1) {
    lm.fm <- makeLMFormula(treatment, 'ftemp')
    mtmp <- stats::model.matrix(lm.fm$lm.formula, data=treatment, eval(parse(text=lm.fm$lm.params)))  #contrasts=list(bl="contr.sum", it="contr.sum",Pi="contr.sum", tp="contr.sum"))
  } else {  # have 1 treatment group
    mtmp <- treatment # as.numeric(t(treatment))
  }
  # above needed to know how many values will get back for some matrices
  # create some variables:
  betahat <- matrix(NA,nrow=dim(mtmp)[2],ncol=nrow(pres))
  newR <- array(NA, c(nrow(pres), ncol(pres))) #, n.treatment))
  norm_m <- array(NA, c(nrow(pres), ncol(pres))) # , n.treatment))
  numsamp <- dim(pres)[2]
  numpep <- dim(pres)[1]
  betahat_n <- matrix(NA,nrow=dim(mtmp)[2],ncol=nrow(pres))
  rm(mtmp)

  V0 <- my.svd$v[,seq_len(h.c),drop=FALSE]   # residual eigenpeptides

  if(n.u.treatment == 1) { # got 1 treatment group
    for (ii in seq_len(nrow(pres))) {
      if(ii%%250 == 0) { print(paste('Processing peptide ',ii))  }
      pep <- pres[ii, ]
      pos <- !is.na(pep)
      peptemp <- as.matrix(pep[pos]) # take only the observed values
      resm <- rep(NA, numsamp)
      resm[pos] <- as.numeric(pep[pos])
      bias <- array(NA, numsamp)
      bias[pos] <- resm[pos] %*% V0[pos,] %*% t(V0[pos,])
      norm_m[ii, ] <- as.numeric(pep - bias)
    }

  } else { # got 2+ treatment groups
    for (ii in seq_len(nrow(pres))) {
      if(ii %% 100 == 0) { print(paste('Processing peptide ',ii))  }
      pep <- pres[ii, ]
      pos <- !is.na(pep)
      peptemp <- as.matrix(pep[pos]) # take only the observed values, may not be needed in R? but this works
      ftemp <- treatment[pos,]
      ftemp <- data.frame(ftemp)
      #### use try, not entirely sure if need for modt, need it for solve lm?!
      options(warn = -1)
      lm.fm <- makeLMFormula(ftemp, 'ftemp') # using general function that can accomodate for 1+ number of factors
      modt <- try(stats::model.matrix(lm.fm$lm.formula, data=ftemp, eval(parse(text=lm.fm$lm.params))), silent=TRUE)
      options(warn = 0)

      if(!inherits(modt, "try-error")) { # do nothing if could not make model matrix
        options(warn = -1)
        # if we are able to solve this, we are able to estimate bias
        bhat <-  try(solve(t(modt) %*% modt) %*% t(modt) %*% peptemp)
        options(warn = 0)
        if(!inherits(bhat, "try-error")) {
          betahat[,ii] <- bhat
          ceffects <- modt %*% bhat  # these are the group effects, from estimated coefficients betahat

          resm <- rep(NA, numsamp) # really a vector only, not m
          resm[pos] <- as.numeric(pep[pos] - ceffects)
          bias <- array(NA, numsamp)
          bias[pos] <- resm[pos] %*% V0[pos,] %*% t(V0[pos,])
          norm_m[ii, ] <- as.numeric(pep - bias)

          # yuliya:  but newR should be computed on Normalized data
          resm_n <- rep(NA, numsamp)
          bhat_n <-  solve(t(modt) %*% modt) %*% t(modt) %*% norm_m[ii, pos]
          betahat_n[,ii] <- bhat_n
          ceffects_n <- modt %*% bhat_n
          resm_n[pos] <- norm_m[ii,pos] - ceffects
          newR[ii, ] <- resm_n
        } else {
          print(paste('got exception 2 at peptide:', ii, 'should not get here...'))
          exPeps[ii] <- 2 # should not get 2 here ever...
        }
      } else {
        print(paste('got exception at peptide:', ii))
        exPeps[ii] <- 1 # keep track of peptides that threw exeptions, check why...
      }
    }
  } # end else - got 2+ treatment groups

  #####################################################################################
  # rescaling has been eliminated form the code after discussion that bias
  # adds variation and we remove it, so no need to rescale after as we removed what was introduced
  y_rescaled <- norm_m # for 1 group normalization only, we do not rescale
  # add column names to y-rescaled, now X1, X2,...
  colnames(y_rescaled) <- colnames(pres) # these have same number of cols
  rownames(y_rescaled) <- rownames(pres)
  y_resc <- data.frame(present, y_rescaled)
  rownames(y_resc) <- rownames(pres)  # rownames(rv$normalized)
  final <- y_resc # row names are assumed to be UNIQUE, peptide IDs are unique

  # rows with all observations present
  complete_all <- y_rescaled[rowSums(is.na(y_rescaled))==0,,drop=FALSE]

  #  x11() # make R open new figure window
  graphics::par(mfcol=c(3,2))
  graphics::par(mar = c(2,2,2,2))
  # center each peptide around zero (subtract its mean across samples)
  # note: we are not changing matrix itself, only centerig what we pass to svd
  complete_all_center <- t(scale(t(complete_all), center = TRUE, scale = FALSE))
  toplot3 <- svd(complete_all_center)
  #plot.eigentrends(toplot1, "Raw Data")
  #plot.eigentrends(toplot3, "Normalized Data")

  print("Done with normalization!!!")
  colnames(V0) <-  paste("Trend", seq_len(ncol(V0)), sep="_")

  maxrange <- NULL # no rescaling # data.matrix(maxrange)
  return(list(normalized=final, norm_m=y_rescaled, eigentrends=V0, rescrange=maxrange,
              norm.svd=toplot3, exPeps=exPeps))
} # end function eig_norm2



### EigenMS helper functions, a few more...
# Tom had Sig set to 0.1, I and Storey's paper has 0.05
# sva.id = function(dat, mod, n.u.treatment, B=500, sv.sig=0.05, seed=NULL) {

# yuliya Sept 1, 2014: changed parameter mod to be treatment, using lm() to obtain residuals
sva.id <- function(dat, treatment, n.u.treatment, lm.fm, B=500, sv.sig=0.05) {
# Executes Surrogate Variable Analysis
# Input:
#   dat: A m peptides/genes by n samples matrix of expression data
#   mod: A model matrix for the terms included in the analysis
#   n.u.treatment - 0 or 1, if we are normalizing data with NO groups or some groups, QC vs samples
#   B: The number of null iterations to perform
#   sv.sig: The significance cutoff for the surrogate variables
#   seed: A seed value for reproducible results
# Output
#    n.sv: Number of significant surrogate variables.
#    id: An indicator of the significant surrogate variables
#    B: number of permutation to do
#    sv.sig: significance level for surrogate variables
  print("Number of complete peptides (and samples) used in SVD")
  print(dim(dat))

  warn <- NULL
  n <- ncol(dat)
  m <- nrow(dat)

  # ncomp = length(as.numeric(n.u.treatment))
  ncomp <- n.u.treatment # JULY 2013: as.numeric(n.u.treatment)
  print(paste("Number of treatment groups (in svd.id): ", ncomp))
  # should be true for either case and can be used later

  if(ncomp > 1) { #
    formula1 <- paste('t(dat)~', as.character(lm.fm$lm.formula)[2], sep = '')
    fit_lmAll <- stats::lm(eval(parse(text=formula1)))
    res <- t(stats::residuals(fit_lmAll))
  } else {
    res <- dat
  }
  # centering was not done before...
  # center each peptide around zero (subtract its mean across samples)
  # note: we are not changing matrix itself, only centerig what we pass to svd
  res_center <- t(scale(t(res), center = TRUE, scale = FALSE))

  uu <- svd(t(res_center)) # NEED a WRAPPER for t(). the diag is min(n, m)
  temp <- uu$u
  uu$u <- uu$v
  uu$v <- temp


  # yuliya: Sept 2014: can I get around without using H??
  #  ndf = min(n, m) - ceiling(sum(diag(H)))
  #  dstat = uu$d[1:ndf]^2/sum(uu$d[1:ndf]^2)
  #  dstat0 = matrix(0,nrow=B,ncol=ndf)
  #  s0 = diag(uu$d) # no need for diag here, should investigate why this is a vector already...
  s0 <- uu$d
  s0 <- s0^2
  dstat <- s0/sum(s0)  # this did not have 'diag' in it in Tom's code...
  ndf <- length(dstat) # sticking to Tom's variable name
# print(paste('length(dstat) = ndf = ', ndf))
  dstat0 <- matrix(0,nrow=B,ncol=ndf) # num samples (?)

print("Starting Bootstrap.....")
# this is the Bootstrap procedure that determines the number of significant eigertrends...
  for(ii in seq_len(B)){
    if(ii %% 50 == 0) { print(paste('Iteration ', ii)) }
    res0 <- t(apply(res, 1, sample, replace=FALSE)) # regression
    # yuliya: not sure if this is needed at all
    # not needed for 1 group normalizaiton
    ##### res0 = res0 - t(H %*% t(res0))
    # yuliya: Sept 3, 2014: REMOVED above line. Do not think this needs to be done..
    # center each peptide around zero (subtract its mean across samples)
    # note: we are not changing matrix itself, only centerig what we pass to svd
    res0_center <- t(scale(t(res0), center = TRUE, scale = FALSE))
    uu0 <- svd(res0_center)
  	temp <- uu0$u  # why did tom do this??
    uu0$u <- uu0$v
    uu0$v <- temp

    ss0 <- uu0$d  # no need for diag....
    ss0 <- ss0^2
    dstat0[ii,] <- ss0 / sum(ss0) # Tk0 in Matlab
  }

# yuliya: check p-values here, Tom had mean value...
  psv <- rep(1,n)
  for(ii in seq_len(ndf)){
	  # psv[ii] = mean(dstat0[,ii] >= dstat[ii])
    # should this be compared to a MEAN?  Should this be dstat0[ii,] ?
    posGreater <- dstat0[,ii] > dstat[ii]
    psv[ii] <- sum(posGreater) / B
  }

  # p-values for peptides have to be in monotonically increasing order,
  # set equal to previous one if not the case
  for(ii in 2:ndf){
    if(psv[(ii-1)] > psv[ii]) {
	    # psv[ii] = max(psv[(ii-1)],psv[ii])
      psv[ii] <- psv[(ii-1)]
    }
  }
  nsv <- sum(psv <= sv.sig)
  # tom - this should be at least 1
  # nsv = min(sum(psv <= sv.sig), 1, na.rm=T)
  return(list(n.sv = nsv,p.sv=psv))
}
# end sva.id


mmul <- function(A, B){
  # multiply square matrix by rectangle with NA's (???)
  X <- A
  Y <- B
  X[is.na(A)] <- Y[is.na(B)] <- 0
  R <- X %*% Y
  R[is.na(B)] <- NA
  R
}
# end mmul



#####    Not used in EigenMS, but a solution to imputing peptides with 1+ group missing completely.
#######################################################################
imp_elim_proteins <- function(nosib.miss, treatment){
# Impute 1 peptide proteins with 1 grp completely missing
#
# INPUT: proteins - 1 peptide proteins with 1 grp missing completely (NaNs)
#        grps - grouping information for observations, can be 2+ grps here,
#               but not sure what to do with more then 2 groups if 2+ gs are
#               missing completely. So only 1 grp is completely missing.
# OUTPUT: prs - imputed proteins, same size as proteins parameter
#nosib.miss <= nosib.miss
#treatment <= treatment
  tlvls <- unique(treatment)
  proteins <- nosib.miss
  ng <- length(unique(treatment))
  for (i in seq_len(nrow(proteins))) {
  	pr <- as.vector(proteins[i,])
    #% find number of missing values in ALL groups
    miss <- array(NA, c(1, ng))
    for (j in seq_len(ng)) miss[j] <- sum(is.na(pr[treatment==unique(treatment)[j]]))
#    pos = miss==0
    pos <- miss==min(miss)  # Tom 092510
    present_groups <- pr[treatment==unique(treatment)[pos]]

    # compute mean and stdev from one of the present groups, make sure no NaNs are used
	pospres <- !is.na(present_groups)
	presvals <- present_groups[pospres]
	pepmean <- mean(presvals)
	pepstd <-  stats::sd(presvals)
	if(is.na(pepstd)) next;

  #% imputing only COMPLETELY missing peptides here
	for (j in seq_len(ng)) {
		if   (!pos[j]) { #% imute only the ones not at pos complete
			imppos <- is.na(pr[treatment==tlvls[j]])  #% should be all in this group, but double check
			imppepmean <- pepmean - 6* pepstd
			imppepstd <- pepstd
			tt <- imppepmean - 3 * imppepstd
			kk <- 0
      while (tt < 0 && kk < 10){  # added kk counter - tom 092510
				offset <- .25
				gap <- imppepstd * offset
				imppepstd <- imppepstd * (1- offset)
				imppepmean <- imppepmean + 3 * gap
				tt <- imppepmean - 3 * imppepstd
				kk <- kk + 1
			}
			imp_tmp <- stats::rnorm(length(imppos), imppepmean, pepstd)
			pr[treatment==tlvls[j]] <- imp_tmp
		}
	}
  proteins[i,] <- pr
  }

  # tom - this routine gives some nearly-blank rows
  # to avoid singularities, i'm going to scan this to see which protein rows
  # have all blanks in one row and remove them
  #  proteins <= proteins
  xx <- (!is.na(proteins)) %*% stats::model.matrix(~treatment-1)
  notblank.idx <- rep(TRUE, nrow(xx))
  for(jj in seq_len(ncol(xx))) notblank.idx <- notblank.idx & xx[,jj]
#  proteins = proteins[blank.idx,,drop=FALSE]

  return(list(proteins=proteins, notblank.idx=notblank.idx))
}

#######################################################################
#######################################################################
my.Psi <- function(x, my.pi){
# calculates Psi
exp(log(1-my.pi)  + stats::dnorm(x, 0, 1, log=TRUE) - log(my.pi + (1 - my.pi) * stats::pnorm(x, 0, 1) ))
}
# end my.Psi

my.Psi.dash <- function(x, my.pi){
# calculates the derivative of Psi
-my.Psi(x, my.pi) * (x + my.Psi(x, my.pi))
}
# end my.Psi.dash

phi <- function(x){stats::dnorm(x)}

rnorm.trunc <- function (n, mu, sigma, lo=-Inf, hi=Inf){
# Calculates truncated noraml
  p.lo <- stats::pnorm (lo, mu, sigma)
  p.hi <- stats::pnorm (hi, mu, sigma)
  u <- stats::runif (n, p.lo, p.hi)
  return (stats::qnorm (u, mu, sigma))
}
# end rnorm.truncf

#' Helper function to read example data
#'
#' @param path NULL to get all example data set files, otherwise specify the file name
#'
#' @return If path=NULL a character vector with the file names, otherwise the path to the specific file
#' @export
#'
#' @examples
#' readPRONE_example()
readPRONE_example <- function(path = NULL){
  if(is.null(path)){
    dir(system.file("extdata", package = "PRONE"))
  } else {
    system.file("extdata", path, package = "PRONE", mustWork = TRUE)
  }
}

#' Helper function to check whether the DEqMS_PSMs_column is in the SummarizedExperiment object
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param DEqMS_PSMs_column String specifying which column name to use for DEqMS (default NULL)
#'
#' @return None
#'
#' @keywords internal
check_DEqMS_parameter <- function(se, DEqMS_PSMs_column){
  stopifnot(methods::is(DEqMS_PSMs_column, "character"))
  if(is.null(DEqMS_PSMs_column)){
    stop("No column name for DEqMS given!")
  } else {
    if(!DEqMS_PSMs_column %in% colnames(data.table::as.data.table(SummarizedExperiment::rowData(se)))){
      stop(paste0("No column named ", DEqMS_PSMs_column, " in SummarizedExperiment!"))
    }
  }
}


#' Helper function to check the condition value
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#'
#' @return String of column for condition
#'
#' @export
#' @keywords internal
get_condition_value <- function(se, condition){
  if(is.null(condition)){
    # check if condition in metadata of se
    if(is.null(S4Vectors::metadata(se)$condition)){
      # print error
      stop("No condition provided!")
    } else {
      condition <- S4Vectors::metadata(se)$condition
      message("Condition of SummarizedExperiment used!")
    }
  } else {
    # check if condition in colData
    if(! condition %in% colnames(data.table::as.data.table(SummarizedExperiment::colData(se)))){
      stop(paste0("No column named ", condition, " in SummarizedExperiment!"))
    }
  }
  return(condition)
}


#' Helper function to get correct value for coloration of plots (color_by parameter)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#'
#' @return String of column to color or NULL if no color should be applied
#'
#' @export
#' @keywords internal
get_color_value <- function(se, color_by){
  if(is.null(color_by)){
    # check if condition in metadata of se
    if(is.null(S4Vectors::metadata(se)$condition)){
      color_by <- NULL
      message("No condition provided. Hence, no color bar added.")
    } else {
      color_by <- S4Vectors::metadata(se)$condition
      message("Condition of SummarizedExperiment used!")
    }
  } else if(length(color_by)==1){
    if(color_by == "No"){
      color_by <- NULL
      message("No color bar added.")
    }
  }
  if(!is.null(color_by)){
    #check if color_by a valid column of the SummarizedExperiment object
    cols <- colnames(data.table::as.data.table(SummarizedExperiment::colData(se)))
    if(sum(!color_by %in% cols) > 0){
      stop("The color_by value(s) not a valid column in the SummarizedExperiment object!")
    }
  }
  return(color_by)
}



#' Helper function to get correct value for sample labeling of plots (label_by parameter)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#'
#' @return String of column to label or NULL if no label should be applied
#'
#' @export
#' @keywords internal
get_label_value <- function(se, label_by){
  show_sample_names <- TRUE
  if(is.null(label_by)){
    # check if condition in metadata of se
    if(is.null(S4Vectors::metadata(se)$label)){
      label_by <- "Column"
      show_sample_names <- FALSE
      message("No label provided. Hence, no labeling of samples.")
    } else {
      label_by <- S4Vectors::metadata(se)$label
      message("Label of SummarizedExperiment used!")
    }
  } else if (label_by == "No") {
    label_by <- "Column"
    show_sample_names <- FALSE
    message("No labeling of samples.")
  } else {
    # check if label_by a valid column of the SummarizedExperiment object
    cols <- colnames(data.table::as.data.table(SummarizedExperiment::colData(se)))
    if(!label_by %in% cols){
      stop("Label_by value not a valid column in the SummarizedExperiment object!")
    }
  }
  return(list(show_sample_names, label_by))
}

#' Helper function to get correct value for shaping of plots (shape_by parameter)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param shape_by String specifying the column to shape the samples (If NULL or "No", no shaping is done.)
#'
#' @return String of column to shape or NULL if no shaping should be done
#'
#' @export
#' @keywords internal
get_shape_value <- function(se, shape_by){
  if(is.null(shape_by)){
      message("No shaping done.")
  } else if(shape_by == "No"){
    shape_by <- NULL
    message("No shaping done.")
  } else {
    # check if shape_by a valid column of the SummarizedExperiment object
    cols <- colnames(data.table::as.data.table(SummarizedExperiment::colData(se)))
    if(!shape_by %in% cols){
      stop("Shape_by value not a valid column in the SummarizedExperiment object!")
    }
  }
  return(shape_by)
}


#' Helper function to get correct value for faceting of plots (facet_by parameter)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param facet_by String specifying the column to facet the samples (If NULL or "No", no faceting is done.)
#'
#' @return String of column to facet or NULL if no faceting should be done
#'
#' @export
#' @keywords internal
get_facet_value <- function(se, facet_by){
  if(is.null(facet_by)){
    message("No faceting done.")
  } else if(facet_by == "No"){
    facet_by <- NULL
    message("No faceting done.")
  } else {
    # check if facet_by a valid column of the SummarizedExperiment object
    cols <- colnames(data.table::as.data.table(SummarizedExperiment::colData(se)))
    if(!facet_by %in% cols){
      stop("Facet_by value not a valid column in the SummarizedExperiment object!")
    }
  }
  return(facet_by)
}

#' Helper function to transform an expression data frame to a data table
#'
#' @param expr_data Expression data frame containing the expression data
#' @param column_names Column names of the expression data
#' @param row_names Row names of the expression data
#'
#' @return Data table containing the expression data
#' 
#' @export
#' @keywords internal
express_to_DT <- function(expr_data, column_names, row_names) {
  data_df <- data.table::as.data.table(t(data.frame(expr_data)))
  colnames(data_df) <- column_names
  rownames(data_df) <- row_names
  return(data_df)
}


#' Helper function to transform a tibble to a data table
#'
#' @param expr_data Tibble data frame containing the expression data
#' @param column_names Column names of the expression data
#' @param row_names Row names of the expression data
#'
#' @return Data table containing the expression data
#'
#' @export
#' @keywords internal
tib_to_DF <- function(expr_data, column_names, row_names) {
  data_df <- data.table::as.data.table(expr_data)
  colnames(data_df) <- column_names
  rownames(data_df) <- row_names
  return(data_df)
}


#' Helper function to check whether all given assays are in SummarizedExperiment object
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#'
#' @return NULL if no methods in SummarizedExperiment object, else all available methods ready for visualization
#'
#' @export
#' @keywords internal
check_input_assays <- function(se, ain) {
  if (is.null(ain)) {
    assays_se <- names(SummarizedExperiment::assays(se))
    message("All assays of the SummarizedExperiment will be used.")
    return(assays_se)
  } else {
    assays_se <- names(SummarizedExperiment::assays(se))
    not_existing_assays <- ain[!ain %in% assays_se]
    existing_assays <- ain[ain %in% assays_se]
    if (length(not_existing_assays) > 0) {
      # some methods of ain are not in SummarizedExperiment object
      # check if there are still some methods of ain in the SummarizedExperiment object
      if (length(existing_assays) > 0) {
        warning(
          paste0(
            paste0(not_existing_assays, collapse = ", "),
            " not in SummarizedExperiment object. Check with names(assays(se)) which assays can be used for visualization!"
          )
        )
        message(paste0(
          paste0(existing_assays, collapse = ", "),
          " used for visualization."
        ))
        return(existing_assays)
      } else {
        stop(
          paste0(
            paste0(not_existing_assays, collapse = ", "),
            " not in SummarizedExperiment object. Check with names(assays(se)) which assays can be used for visualization!"
          )
        )
        return(NULL)
      }
    } else {
      return(ain)
    }
  }
}



#' Check parameters for DE analysis
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param comparisons Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)
#' @param DE_method String specifying which DE method should be applied (limma, ROTS, DEqMS)
#' @param covariate String specifying which column to include as covariate into limma
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#' @param p_adj_method String specifying the method for adjusted p-values
#' @param B Number of bootstrapping for ROTS
#' @param K Number of top-ranked features for reproducibility optimization
#' @param DEqMS_PSMs_column String specifying which column name to use for DEqMS (default NULL)
#'
#' @return list of checked assays and condition column name
#'
#' @keywords internal
check_DE_parameters <- function(se, ain = NULL, condition = NULL, comparisons = NULL, DE_method = "limma", covariate = NULL, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, p_adj_method = "BH", alpha = 0.05, B = 100, K = 500, DEqMS_PSMs_column = NULL){
  # check input parameters
  stopifnot(DE_method %in% c("limma", "ROTS", "DEqMS"))
  stopifnot(p_adj_method %in% c("holm", "hochberg", "hommel", "bonferroni", "BH", "BY","fdr", "none")) # TODO: check which values available
  stopifnot(methods::is(logFC_up, "numeric"))
  stopifnot(methods::is(logFC_down, "numeric"))
  stopifnot(methods::is(B, "numeric"))
  stopifnot(methods::is(K, "numeric"))
  stopifnot(methods::is(alpha, "numeric"))
  stopifnot(methods::is(p_adj, "logical"))
  stopifnot(methods::is(logFC, "logical"))
  
  # check covariate
  if(!is.null(covariate)){
    if(!covariate %in% colnames(data.table::as.data.table(SummarizedExperiment::colData(se)))){
      stop(paste0("No column named ", covariate, " in SummarizedExperiment!"))
    }
  }
  
  # check comparisons
  # TODO
  
  # get condition
  condition <- get_condition_value(se, condition)
  
  # check input
  ain <- check_input_assays(se, ain)
  if(is.null(ain)){
    return(NULL)
  }
  return(list("ain" = ain, "condition" = condition))
}

#' Helper function to check the parameters for plotting the DE results
#'
#' @param de_res data table resulting of run_DE
#' @param ain String of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#'
#' @return list of valid inputs for plotting functions
#'
#' @export
#' @keywords internal
check_plot_DE_parameters <- function(de_res, ain, comparisons){
  # check if logFC, P.Value, Change, Comparison, and Assay in de_res
  stopifnot("logFC" %in% colnames(de_res))
  stopifnot("Change" %in% colnames(de_res))
  stopifnot("P.Value" %in% colnames(de_res))
  stopifnot("Comparison" %in% colnames(de_res))
  stopifnot("Assay" %in% colnames(de_res))

  # check comparisons
  if(is.null(comparisons)){
    comparisons <- unique(de_res$Comparison)
    message("All comparisons of de_res will be visualized.")
  }
  valid_comparisons <- comparisons[comparisons %in% unique(de_res$Comparison)]
  not_valid_comparisons <- comparisons[!comparisons %in% unique(de_res$Comparison)]
  if(length(not_valid_comparisons) > 0){
    if(length(not_valid_comparisons) == length(c(comparisons))){
      # no valid comparisons
      stop("No valid comparison! Please change the comparisons parameter. Check with unique(de_res$Comparisons) which comparisons you can visualize.")
    } else {
      # some invalid comparisons --> notification
      warning(paste0(paste0(not_valid_comparisons, collapse = ", "), ": not valid comparisons. Only valid comparisons will be visualized."))
    }
  }
  comparisons <- valid_comparisons

  # check ain
  if(is.null(ain)){
    ain <- unique(de_res$Assay)
    message("All normalization methods of de_res will be visualized.")
  }
  valid_ain <- ain[ain %in% unique(de_res$Assay)]
  not_valid_ain <- ain[!ain %in% unique(de_res$Assay)]
  if(length(not_valid_ain) > 0){
    if(length(not_valid_ain) == length(c(ain))){
      # no valid input
      stop("No valid normalization methods! Please change the ain parameter. Check with unique(de_res$Assays) which normalization methods can be visualized.")
    } else {
      # some invalid inputs --> notification
      warning(paste0(paste0(not_valid_ain, collapse = ", "), ": not valid normalization methods. Only valid normalization methods will be visualized."))
    }
  }
  ain <- valid_ain
  return(list(de_res, ain, comparisons))
}

#' Helper function to check the parameters for plotting the DE stats of spike-in data sets
#'
#' @param stats data table resulting of get_spiked_stats_DE
#' @param ain String of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#'
#' @return list of valid inputs for plotting functions
#'
#' @export
#' @keywords internal
check_stats_spiked_DE_parameters <- function(stats, ain, comparisons){
  # check Comparison, and Assay in stats
  stopifnot("Assay" %in% colnames(stats))
  stopifnot("Comparison" %in% colnames(stats))

  # check comparisons
  if(is.null(comparisons)){
    comparisons <- unique(stats$Comparison)
    message("All comparisons of stats will be visualized.")
  }
  valid_comparisons <- comparisons[comparisons %in% unique(stats$Comparison)]
  not_valid_comparisons <- comparisons[!comparisons %in% unique(stats$Comparison)]
  if(length(not_valid_comparisons) > 0){
    if(length(not_valid_comparisons) == length(c(comparisons))){
      # no valid comparisons
      stop("No valid comparison! Please change the comparisons parameter. Check with unique(stats$Comparisons) which comparisons you can visualize.")
    } else {
      # some invalid comparisons --> notification
      warning(paste0(paste0(not_valid_comparisons, collapse = ", "), ": not valid comparisons. Only valid comparisons will be visualized."))
    }
  }
  comparisons <- valid_comparisons

  # check ain
  if(is.null(ain)){
    ain <- unique(stats$Assay)
    message("All normalization methods of de_res will be visualized.")
  }
  valid_ain <- ain[ain %in% unique(stats$Assay)]
  not_valid_ain <- ain[!ain %in% unique(stats$Assay)]
  if(length(not_valid_ain) > 0){
    if(length(not_valid_ain) == length(c(ain))){
      # no valid input
      stop("No valid normalization methods! Please change the ain parameter. Check with unique(de_res$Assays) which normalization methods can be visualized.")
    } else {
      # some invalid inputs --> notification
      warning(paste0(paste0(not_valid_ain, collapse = ", "), ": not valid normalization methods. Only valid normalization methods will be visualized."))
    }
  }
  ain <- valid_ain
  return(list(stats, ain, comparisons))
}

#' Load real-world proteomics data into a SummarizedExperiment
#'
#' @param data tabular data table with rows = proteins and columns = samples (such as proteinGroups.txt of MaxQuant)
#' @param md experimental design table (requires a column named "Column" for the column names of the sample intensities in data)
#' @param protein_column name of the column in data containing the protein IDs
#' @param gene_column name of the column in data containing the gene names
#' @param ref_samples reference samples if TMT experiment provided (names of samples)
#' @param batch_column name of the column in md defining the batches
#' @param condition_column name of the column in md defining the condition (can still be changed afterwards)
#' @param label_column name of the column in md containing simple sample names (for visualization)
#' @importFrom magrittr %>%
#'
#' @return SummarizedExperiment object
#' @export
#'
#' @examples
#' data_path <- readPRONE_example("tuberculosis_protein_intensities.csv")
#' md_path <- readPRONE_example("tuberculosis_metadata.csv")
#' data <- read.csv(data_path)
#' md <- read.csv(md_path)
#' md$Column <- stringr::str_replace_all(md$Column, " ", ".")
#' ref_samples <- md[md$Group == "ref",]$Column
#' se <- load_data(data, md, protein_column = "Protein.IDs",
#'                gene_column = "Gene.names", ref_samples = ref_samples,
#'                batch_column = "Pool", condition_column = "Group",
#'                label_column = "Label")
#'
load_data <- function(data, md, protein_column = "Protein.IDs", gene_column = "Gene.Names", ref_samples = NULL, batch_column = NULL, condition_column = NULL, label_column = NULL){
  # convert to data.table
  data <- data.table::as.data.table(data)
  md <- data.table::as.data.table(md)
  # assays
  raw <- data[,md$Column, with=FALSE]
  raw[raw == 0] <- NA
  log2 <- log2(raw)
  # rowData
  rowData <- data[, !colnames(data) %in% md$Column, with = FALSE]
  rowData$IDs <- rownames(raw)
  rowData <- rowData %>% dplyr::rename("Protein.IDs" = protein_column, "Gene.Names" = gene_column)
  # colData
  colData <- md

  # check if ref samples in data
  if(!is.null(ref_samples)){
    if(length(c(ref_samples) %in% colData$Column) != length(c(ref_samples))){
      stop("Reference samples not all included in data. Aborted!")
    }
  }
  # check if batch column in data
  if(!is.null(batch_column)){
    if(!batch_column %in% colnames(colData)){
      stop("Batch column not in the data. Aborted!")
    }
  }
  # check if label column in the data
  if(!is.null(label_column)){
    if(!label_column %in% colnames(colData)){
      stop("Label column not in the data. Aborted!")
    }
  }
  # check if condition column in the data
  if(!is.null(condition_column)){
    if(!condition_column %in% colnames(colData)){
      stop("Condition column not in the data. Aborted!")
    }
  }

  # metadata
  metadata <- list(condition = condition_column, batch = batch_column, refs = ref_samples, label = label_column)
  # SummarizedExperiment
  se <- SummarizedExperiment::SummarizedExperiment(assays = list(raw = raw, log2 = log2), colData = colData, rowData = rowData, metadata = metadata)
  return(se)
}


#' Load spike-in proteomics data into a SummarizedExperiment
#'
#' @param data tabular data table with rows = proteins and columns = samples (such as proteinGroups.txt of MaxQuant)
#' @param md experimental design table (requires a column named "Column" for the column names of the sample intensities in data)
#' @param spike_column name of the column specifying which proteins are the spike-ins
#' @param spike_value String value specifying the spike-in proteins in the spike-in column
#' @param spike_concentration name of the column in md defining the spike-in concentration per sample
#' @param protein_column name of the column in data containing the protein IDs
#' @param gene_column name of the column in data containing the gene names
#' @param ref_samples reference samples if TMT experiment provided (names of samples)
#' @param batch_column name of the column in md defining the batches
#' @param condition_column name of the column in md defining the condition (can still be changed afterwards)
#' @param label_column name of the column in md containing simple sample names (for visualization)
#' @importFrom magrittr %>%
#'
#' @return SummarizedExperiment object
#' @export
#'
#' @examples
#' data_path <- readPRONE_example("Ecoli_human_MaxLFQ_protein_intensities.csv")
#' md_path <- readPRONE_example("Ecoli_human_MaxLFQ_metadata.csv")
#' data <- read.csv(data_path)
#' md <- read.csv(md_path)
#' mixed <- grepl("Homo sapiens.*Escherichia|Escherichia.*Homo sapiens", data$Fasta.headers)
#' data <- data[!mixed,]
#' data$Spiked <- rep("HUMAN", nrow(data))
#' data$Spiked[grepl("ECOLI", data$Fasta.headers)] <- "ECOLI"
#' se <- load_spike_data(data, md, spike_column = "Spiked", spike_value = "ECOLI", 
#'         spike_concentration = "Concentration", protein_column = "Protein.IDs", 
#'         gene_column = "Gene.names", ref_samples = NULL, batch_column = NULL, 
#'         condition_column = "Condition", label_column = "Label")
#'
load_spike_data <- function(data, md, spike_column, spike_value, spike_concentration, protein_column = "Protein.IDs", gene_column = "Gene.Names", ref_samples = NULL, batch_column = NULL, condition_column = NULL, label_column = NULL){
  # convert to data.table
  data <- data.table::as.data.table(data)
  md <- data.table::as.data.table(md)
  # assays
  raw <- data[,md$Column, with=FALSE]
  raw[raw == 0] <- NA
  log2 <- log2(raw)
  # rowData
  rowData <- data[, !colnames(data) %in% md$Column, with = FALSE]
  rowData$IDs <- rownames(raw)
  rowData <- rowData %>% dplyr::rename("Protein.IDs" = protein_column, "Gene.Names" = gene_column)
  # colData
  colData <- md

  # check if ref samples in data
  if(!is.null(ref_samples)){
    if(length(c(ref_samples) %in% colData$Column) != length(c(ref_samples))){
      stop("Reference samples not all included in data. Aborted!")
    }
  }
  # check if batch column in data
  if(!is.null(batch_column)){
    if(!batch_column %in% colnames(colData)){
      stop("Batch column not in the data. Aborted!")
    }
  }
  # check if label column in the data
  if(!is.null(label_column)){
    if(!label_column %in% colnames(colData)){
      stop("Label column not in the data. Aborted!")
    }
  }
  # check if condition column in the data
  if(!is.null(condition_column)){
    if(!condition_column %in% colnames(colData)){
      stop("Condition column not in the data. Aborted!")
    }
  }

  # check if spike column in the data
  if(is.null(spike_column)){
    stop("Spike column need to be specified!")
  } else {
    if(!spike_column %in% colnames(rowData)){
      stop("Spike column not in the data. Aborted!")
    } else {
      # check if spike_value in data
      sc <- rowData[[spike_column]]
      if(!spike_value %in% sc){
        stop("Spike value not in spike column. Aborted!")
      }
    }
  }

  # check if spike_concentration column in data
  if(!is.null(spike_concentration)){
    if(!spike_concentration %in% colnames(colData)){
      stop("Spike concentration column not in the data. Aborted!")
    }
  }

  # metadata
  metadata <- list(condition = condition_column, batch = batch_column, refs = ref_samples, label = label_column, spike_column = spike_column, spike_value = spike_value, spike_concentration = spike_concentration)
  # SummarizedExperiment
  se <- SummarizedExperiment::SummarizedExperiment(assays = list(raw = raw, log2 = log2), colData = colData, rowData = rowData, metadata = metadata)
  return(se)
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)

## ----message = FALSE----------------------------------------------------------
# Load and attach PRONE
library(PRONE)

## ----load_real_tmt------------------------------------------------------------
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se

## ----eval = TRUE, include = TRUE----------------------------------------------
se <- subset_SE_by_norm(se, ain = c("raw", "log2"))

## ----overview_NA_table--------------------------------------------------------
knitr::kable(get_NA_overview(se, ain = "log2"))

## ----fig.cap = "Overview barplot of the number of samples per condition."-----
plot_condition_overview(se, condition = NULL)

## ----fig.cap = "Overview barplot of the number of samples per pool."----------
plot_condition_overview(se, condition = "Pool")

## ----fig.cap = "Heatmap of the log2-protein intensities with columns and proteins being clustered with hclust."----
available_ains <- names(assays(se))

plot_heatmap(se, ain = "log2", color_by = c("Pool", "Group"), 
             label_by = NULL, only_refs = FALSE)

## ----fig.cap = "Upset plot of the non-NA protein intensities with sets defined by the Pool column.", fig.width = 8, fig.height = 8----
plot_upset(se, color_by = NULL, label_by = NULL, mb.ratio = c(0.7,0.3), 
           only_refs = FALSE)

## ----fig.cap = "Boxplot of the log2-protein intensities of the markers Q92954;J3KP74;E9PLR3, Q9Y6Z7, and Q68CQ4. If specific biomarkers are known to be upregulated in some conditions, you can use this plot to get an impression of the intensities before doing differential expression analysis."----
p <- plot_markers_boxplots(se, 
                           markers = c("Q92954;J3KP74;E9PLR3", "Q9Y6Z7"), 
                           ain = "log2", 
                           id_column = "Protein.IDs", 
                           facet_norm = FALSE, 
                           facet_marker = TRUE)
p[[1]] + ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))

## -----------------------------------------------------------------------------
se <- filter_out_complete_NA_proteins(se)

## -----------------------------------------------------------------------------
se <- filter_out_proteins_by_value(se, "Reverse", "+")
se <- filter_out_proteins_by_value(se, "Only.identified.by.site", "+")
#se <- filter_out_proteins_by_value(se, "Potential.contaminant", "+")

## -----------------------------------------------------------------------------
pot_contaminants <- get_proteins_by_value(se, "Potential.contaminant", "+")
se <- filter_out_proteins_by_ID(se, pot_contaminants)

## ----fig.cap = "Heatmap of the missing value pattern. Proteins with at least one missing value are included in this heatmap."----
plot_NA_heatmap(se, color_by = NULL, label_by = NULL, cluster_samples = TRUE, 
                cluster_proteins = TRUE)

## ----fig.cap = "Density plot of protein intensities of proteins with missing values and proteins without missing values. This can help to check whether the missing values are biased to lower intense proteins. In this case, the missing values are biased towards the lower intense proteins."----
plot_NA_density(se)

## ----fig.cap = "Protein identification overlap. This plot shows the number of identified proteins (y-axis) per number of samples (x-axis)."----
plot_NA_frequency(se)

## ----fig.cap = "Heatmap of the missing value pattern after filtering proteins with too many missing values (threshold was set to 70%). Proteins with at least one missing value are included in this heatmap."----
se <- filter_out_NA_proteins_by_threshold(se, thr = 0.7) 

plot_NA_heatmap(se)

## ----fig.cap = "Barplot on the number of non-zero proteins per samples colored by condition. This plot helps as quality control to check whether the number of proteins is similar across samples. In this case, only very few proteins have been detected for sample 1.HC_Pool1 compared to the other samples."----
plot_nr_prot_samples(se, color_by = NULL, label_by = NULL)

## ----fig.cap = "Barplot on the total protein intensity per samples colored by condition. This plot helps as quality control to check whether the total protein intensity is similar across samples. In this case, the total protein intensities of samples 1.HC_Pool1 and 1.HC_Pool2 are much lower compared to the other samples."----
plot_tot_int_samples(se, color_by = NULL, label_by = NULL)

## -----------------------------------------------------------------------------
se <- remove_samples_manually(se, "Label", c("1.HC_Pool1", "1.HC_Pool2"))

## -----------------------------------------------------------------------------
se_no_refs <- remove_reference_samples(se)

## -----------------------------------------------------------------------------
poma_res <- detect_outliers_POMA(se, ain = "log2")

## ----fig.cap = "Polygon plot of the principal coordinates calculated using the POMA algorithm. The original distances are reduced to principal coordinates (see POMA and the vegan::betadisper method)."----
poma_res$polygon_plot

## ----fig.cap = "Boxplot of the distances of the samples to the group centroid calculated using POMA."----
poma_res$distance_boxplot

## -----------------------------------------------------------------------------
knitr::kable(poma_res$outliers, 
             caption = "Outliers detected by the POMA algorithm.", digits = 2)

## -----------------------------------------------------------------------------
se <- remove_POMA_outliers(se, poma_res$outliers)

## -----------------------------------------------------------------------------
utils::sessionInfo()

#' Volcano plots of DE results
#'
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#' @param facet_norm Boolean indicating whether to facet by normalization method (TRUE) or not (FALSE)
#' @param facet_comparison Boolean indicating whether to facet by comparison (TRUE) or not (FALSE). Only valid if facet_norm = FALSE.
#'
#' @return list of ggplot objects
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' plot_volcano_DE(tuberculosis_TMT_de_res, ain = NULL,
#'                 comparisons = NULL, facet_norm = TRUE,
#'                 facet_comparison = FALSE)
#'
plot_volcano_DE <- function(de_res, ain = NULL, comparisons = NULL, facet_norm = TRUE, facet_comparison = FALSE){
  # check parameters
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  de_res <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]
  de_res <- de_res[de_res$Assay %in% ain,]
  # plot
  p <- list()
  if(facet_norm){
    # facet by normalization method
    for(comp in comparisons){
      dt <- de_res[de_res$Comparison == comp,]
      if("Significant Change" %in% dt$Change){
        color_values <- c("No Change" = "grey", "Significant Change" = "#D55E00")
      } else if ("Up Regulated" %in% dt$Change | "Down Regulated" %in% dt$Change){
        color_values <- c("No Change" = "grey", "Up Regulated" = "#D55E00", "Down Regulated" =  "#0072B2")
      } else {
        color_values <- c("No Change" = "grey")
      }
      tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("logFC"), y=-log10(get("P.Value")))) +
        ggplot2::geom_vline(xintercept=0) +
        ggplot2::geom_point(ggplot2::aes(col=get("Change"))) +
        ggplot2::labs(y = expression(-log[10]~"P-value"), x= "logFC") +
        ggplot2::scale_color_manual(values = color_values, name = "Change") +
        ggplot2::facet_wrap(~Assay, scales = "free")
      p[[comp]] <- tmp
    }
  } else if (facet_comparison){
    # facet by comparison
    for(method in ain){
      dt <- de_res[de_res$Assay == ain,]
      if("Significant Change" %in% dt$Change){
        color_values <- c("No Change" = "grey", "Significant Change" = "#D55E00")
      } else if ("Up Regulated" %in% dt$Change | "Down Regulated" %in% dt$Change){
        color_values <- c("No Change" = "grey", "Up Regulated" = "#D55E00", "Down Regulated" =  "#0072B2")
      } else {
        color_values <- c("No Change" = "grey")
      }
      tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("logFC"), y=-log10(get("P.Value")))) +
        ggplot2::geom_vline(xintercept=0) +
        ggplot2::geom_point(ggplot2::aes(col=get("Change"))) +
        ggplot2::labs(y = expression(-log[10]~"P-value"), x= "logFC") +
        ggplot2::scale_color_manual(values = color_values, name = "Change") +
        ggplot2::facet_wrap(~Comparison, scales = "free")
      p[[method]] <- tmp
    }
  } else {
    # no facet at all --> individual plots for each method and each comparison
    for(comp in comparisons){
      for(method in ain){
        dt <- de_res[de_res$Assay == ain,]
        dt <- dt[dt$Comparison == comp,]
        if("Significant Change" %in% dt$Change){
          color_values <- c("No Change" = "grey", "Significant Change" = "#D55E00")
        } else if ("Up Regulated" %in% dt$Change | "Down Regulated" %in% dt$Change){
          color_values <- c("No Change" = "grey", "Up Regulated" = "#D55E00", "Down Regulated" =  "#0072B2")
        } else {
          color_values <- c("No Change" = "grey")
        }
        tmp <- ggplot2::ggplot(dt, ggplot2::aes(x=get("logFC"), y=-log10(get("P.Value")))) +
          ggplot2::geom_vline(xintercept=0) +
          ggplot2::geom_point(ggplot2::aes(col=get("Change"))) +
          ggplot2::labs(y = expression(-log[10]~"P-value"), x= "logFC") +
          ggplot2::scale_color_manual(values = color_values, name = "Change")
        p[[paste0(comp, "_", method)]] <- tmp
      }
    }
  }
  return(p)
}

#' Heatmap of DE results
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set (including the normalized intensities)
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparison String of comparison (must be a valid comparison saved in de_res)
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#' @param pvalue_column column name of p-values in de_res
#' @param col_vector Vector of colors to use for the heatmap. If NULL, default colors are used.
#'
#' @return list of ComplexHeatmaps for each method
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' data(tuberculosis_TMT_de_res)
#' plot_heatmap_DE(tuberculosis_TMT_se, tuberculosis_TMT_de_res, ain = NULL,
#'                 comparison = "PTB-HC",
#'                 condition = NULL, label_by = NULL,
#'                 pvalue_column = "adj.P.Val", col_vector = NULL)
#'
plot_heatmap_DE <- function(se, de_res, ain, comparison, condition = NULL, label_by = NULL, pvalue_column = "adj.P.Val", col_vector = NULL){
  # check parameters
  if(length(comparison) != 1){
    stop("Only one comparison as input!")
  }
  ain <- check_input_assays(se, ain)
  tmp <- check_plot_DE_parameters(de_res, ain, comparison)
  de_res <- tmp[[1]]
  ain <- tmp[[2]]
  comparison <- tmp[[3]]
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]
  condition <- get_condition_value(se, condition)
  if(!pvalue_column %in% colnames(de_res)){
    stop("No column named ", pvalue_column, " in DE results. Consider changing the pvalue_column parameter!")
  }
  # TODO: check if comparison matches condition column
  # subset data
  de_res <- de_res[de_res$Comparison == as.character(comparison),]
  # plot
  plots <- list()
  for(method in ain){
    # extract data
    dt <- de_res[de_res$Assay == method,]
    # extract metadata
    cond_a <- strsplit(as.character(comparison), split="-")[[1]][1]
    cond_b <- strsplit(as.character(comparison), split="-")[[1]][2]
    md <- data.table::as.data.table(SummarizedExperiment::colData(se))
    md <- md[md[[condition]] %in% c(cond_a, cond_b),]
    # extract significant proteins
    sig <- dt[ dt$Change != "No Change",]
    if(nrow(sig) > 0){
      # extract intensities of significant proteins
      data <- data.table::as.data.table(SummarizedExperiment::assays(se)[[method]])
      data$IDs <- rownames(data)
      data <- data[data$IDs %in% sig$IDs,]
      data <- data[, c("IDs",md$Column)]
      rownames(data) <- data$ID
      data$IDs <- NULL
      if(show_sample_names){
        colnames(data) <- md[, label_by]
      }
      # color vector
      if(is.null(col_vector)){
        qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
        col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
        col_vector <- rev(col_vector)
      }

      # Heatmap annotation
      colors <- col_vector[seq_len(length(unique(md[,condition])))]
      names(colors) <- unique(md[, condition])
      col_annotation <- ComplexHeatmap::columnAnnotation(
        Condition = md[, condition],
        annotation_legend_param = list(Condition = list(title = condition)),
        col = list(Condition = colors)
      )
      row_annotation <- ComplexHeatmap::rowAnnotation(
        P.Value = sig[[pvalue_column]],
        annotation_legend_param = list(P.Value = list(title = pvalue_column)),
        col = list(P.Value = circlize::colorRamp2(c(min(sig[[pvalue_column]]), max(sig[[pvalue_column]])), c("green", "white")))
      )

      # Cluster
      cluster_cols <- FALSE
      cluster_rows <- FALSE
      tryCatch({
        tmp <- stats::hclust(stats::dist(as.matrix(data)))
        cluster_cols <- TRUE
        cluster_rows <- TRUE
      }, error = function(e){
        print(e)
      })

      p <- ComplexHeatmap::Heatmap(
        as.matrix(data),
        top_annotation = col_annotation,
        right_annotation = row_annotation,
        show_column_names = TRUE,
        show_row_names = TRUE,
        cluster_rows = cluster_rows,
        cluster_columns = cluster_cols,
        name = paste0("Intensity (", method, ")")
      )
      plots[[method]] <- p

    } else {
      warning(paste0("No significant changes for method ", method, " and comparison ", comparison, ": nothing to plot."))
    }
  }
  return(plots)
}

#' Overview plots of DE results
#'
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#' @param plot_type String indicating whether to plot a single plot per comparison ("single"), facet by comparison ("facet_comp"), stack the number of DE per comparison ("stacked"), or stack the number of DE per comparison but facet by up- and down-regulated ("facet_regulation")
#'
#' @return list of ggplot objects or single object if plot_type = facet or stacked
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' plot_overview_DE_bar(tuberculosis_TMT_de_res, ain = NULL, comparisons = NULL,
#'                      plot_type = "facet_regulation")
#'
plot_overview_DE_bar <- function(de_res, ain = NULL, comparisons = NULL, plot_type = "single"){
  # check parameters
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  de_res <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]
  stopifnot(plot_type %in% c("single", "facet_comp", "stacked", "facet_regulation"))

  de_res <- de_res[de_res$Comparison %in% comparisons,]

  # get overview DE
  dt <- get_overview_DE(de_res)
  dt <- dt[dt$Assay %in% ain, ]
  melted_dt <- data.table::melt(dt, id.vars = c("Assay", "Comparison"), variable.name = "Change", value.name = "N")
  melted_dt$Assay <- factor(melted_dt$Assay, levels = sort(as.character(unique(melted_dt$Assay))))
  # plot
  p <- list()
  if(plot_type == "stacked"){
    # sum up- and down-regulated proteins
    plot_dt <- melted_dt %>% dplyr::group_by(Comparison, Assay) %>% dplyr::summarise(N = sum(N))
    p <-  ggplot2::ggplot(plot_dt, ggplot2::aes(x = get("N"), y = get("Assay"), fill = get("Comparison"), label = get("N"))) +
      ggplot2::geom_bar(stat = "identity", position = ggplot2::position_stack()) +
      ggplot2::scale_fill_brewer(palette = "Set2", name = "Comparison") +
      ggplot2::labs(title = "Overview of DE results", x = "Number of proteins", y = "Assay") +
      ggplot2::theme_minimal()
  } else if(plot_type == "facet_regulation"){
    p <-  ggplot2::ggplot(melted_dt, ggplot2::aes(x = get("N"), y = get("Assay"), fill = get("Comparison"), label = get("N"))) +
      ggplot2::geom_bar(stat = "identity", position = ggplot2::position_stack()) +
      ggplot2::scale_fill_brewer(palette = "Set2", name = "Comparison") +
      ggplot2::facet_wrap(~Change, scales = "free_x") +
      ggplot2::labs(title = "Overview of DE results", x = "Number of proteins", y = "Assay") +
      ggplot2::theme_minimal()
  } else if(plot_type == "facet_comp"){
    if("Significant Change" %in% melted_dt$Change){
      color_values <- c("No Change" = "grey", "Significant Change" = "#D55E00")
    } else if ("Up Regulated" %in% dt$Change | "Down Regulated" %in% dt$Change){
      color_values <- c("No Change" = "grey", "Up Regulated" = "#D55E00", "Down Regulated" =  "#0072B2")
    } else {
      color_values <- c("No Change" = "grey")
    }
    p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x = get("N"), y = get("Assay"), fill = get("Change"), label = get("N"))) +
      ggplot2::geom_bar(stat = "identity", position = ggplot2::position_stack()) +
      ggplot2::facet_wrap(~Comparison, scales = "free_x") +
      ggplot2::scale_fill_manual(values = color_values, name = "Change") +
      ggplot2::labs(title = "Overview of DE results", x = "Number of proteins", y = "Assay") +
      ggplot2::theme_minimal()
  } else {
    for(comp in comparisons){
      dt <- melted_dt[melted_dt$Comparison == comp,]
      if("Significant Change" %in% dt$Change){
        color_values <- c("No Change" = "grey", "Significant Change" = "#D55E00")
      } else if ("Up Regulated" %in% dt$Change | "Down Regulated" %in% dt$Change){
        color_values <- c("No Change" = "grey", "Up Regulated" = "#D55E00", "Down Regulated" =  "#0072B2")
      } else {
        color_values <- c("No Change" = "grey")
      }
      tmp <- ggplot2::ggplot(dt, ggplot2::aes(x = get("N"), y = get("Assay"), fill = get("Change"), label = get("N"))) +
        ggplot2::geom_bar(stat = "identity", position = ggplot2::position_stack()) +
        ggplot2:: scale_fill_manual(values = color_values, name = "Change") +
        ggplot2::labs( y = "Normalization Method", x = "Number of DE Proteins")
      p[[comp]] <- tmp
    }
  }
  return(p)
}


#' Overview heatmap plot of DE results
#'
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in de_res)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' plot_overview_DE_tile(tuberculosis_TMT_de_res, ain = NULL,
#'                       comparisons = NULL)
#'
plot_overview_DE_tile <- function(de_res, ain = NULL, comparisons = NULL){
  # check parameters
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  de_res <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  # get overview DE
  dt <- de_res[de_res$Change != "No Change",]
  dt <- dt[dt$Assay %in% ain, ]
  dt <- dt[dt$Comparison %in% comparisons,]
  dt <- dt %>% dplyr::count(Comparison, Assay, sort = TRUE)

  # plot
  p <- ggplot2::ggplot(dt, ggplot2::aes(x = get("Assay"), y = get("Comparison"), fill = get("n"))) +
    ggplot2::geom_tile() +
    ggplot2:: theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 1)) +
    ggplot2::labs(x = "Normalization Method", y = "Comparison") +
    ggplot2::scale_fill_distiller(name = "DE Proteins", direction = 1)
  return(p)
}

#'
#' @rdname tuberculosis_TMT_se
#' @name tuberculosis_TMT_se
#' @title Example SummarizedExperiment of a real-world proteomics data set
#' @description
#' A \code{SummarizedExperiment} containing the raw and log2-scaled data of 301 proteins measured in 20 samples
#' @source Biadglegne et al. Mycobacterium tuberculosis Affects Protein and Lipid Content of Circulating Exosomes in Infected Patients Depending on Tuberculosis Disease State. Biomedicines 10.4 (Mar. 2022), p. 783. doi: 10.3390/ biomedicines10040783.
#' @usage data(tuberculosis_TMT_se)
"tuberculosis_TMT_se"

#'
#' @rdname tuberculosis_TMT_de_res
#' @name tuberculosis_TMT_de_res
#' @title Example data.table of DE results of a real-world proteomics data set
#' @description
#' A \code{data.table} containing the DE results of the tuberculosis_TMT_se data set (limma, logFC > 1, logFC < -1, p.adj < 0.05)
#' @source Biadglegne et al. Mycobacterium tuberculosis Affects Protein and Lipid Content of Circulating Exosomes in Infected Patients Depending on Tuberculosis Disease State. Biomedicines 10.4 (Mar. 2022), p. 783. doi: 10.3390/ biomedicines10040783.
#' @usage data(tuberculosis_TMT_de_res)
"tuberculosis_TMT_de_res"

#'
#' @rdname spike_in_se
#' @name spike_in_se
#' @title Example SummarizedExperiment of a spike-in proteomics data set
#' @description
#' A \code{SummarizedExperiment} containing the raw and log2-scaled data of 301 proteins measured in 20 samples. Due to size restriction, we only included the relevant columns of the original proteinGroups.txt of MaxQuant. 
#' @source Jürgen Cox, Marco Y. Hein, Christian A. Luber, Igor Paron, Nagarjuna Nagaraj, and Matthias Mann.Accurate Proteome-wide Label-free Quantification by Delayed Normalization and Maximal Peptide Ratio Extraction, Termed MaxLFQ. Molecular & Cellular Proteomics 13.9 (Sept. 2014), pp. 2513–2526. <https://doi.org/10.1074/mcp.M113.031591>.
#' @usage data(spike_in_se)
"spike_in_se"

#'
#' @rdname spike_in_de_res
#' @name spike_in_de_res
#' @title Example data.table of DE results of a spike-in proteomics data set
#' @description
#' A \code{data.table} containing the DE results of the spike_in_se data set (limma, logFC > 1, logFC < -1, p.adj < 0.05)
#' @source Jürgen Cox, Marco Y. Hein, Christian A. Luber, Igor Paron, Nagarjuna Nagaraj, and Matthias Mann.Accurate Proteome-wide Label-free Quantification by Delayed Normalization and Maximal Peptide Ratio Extraction, Termed MaxLFQ. Molecular & Cellular Proteomics 13.9 (Sept. 2014), pp. 2513–2526. <https://doi.org/10.1074/mcp.M113.031591>.
#' @usage data(spike_in_de_res)
"spike_in_de_res"

utils::globalVariables(c("Column", "ID", "Intensity", "valid_val", "pepIDs", "Change", "Assay", "Comparison", ".", "p_value", "Spiked", "TP", "FN", "FP", "TN", "Concentration", "Sensitivity", "Precision", "Value", "AUC", "Assays", "Median_FP", "Median_TP", "Q1_FP", "Q1_TP", "Q3_FP", "Q3_TP", "NAs", "n", "N", "Var1", "Var2", "value", "Protein.IDs"))

#' Create vector of comparisons for DE analysis (either by single condition (sep = NULL) or by combined condition)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param condition Column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param sep Separator that separates both groups in the condition vector (NULL if condition composed only of single group)
#' @param control String of control samples (how the control condition is named) (NULL if no control sample)
#'
#' @return Vector of comparisons for DE analysis
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' comparisons <- specify_comparisons(tuberculosis_TMT_se, condition = NULL,
#'                             sep = NULL, control = NULL)
#'
specify_comparisons <- function(se, condition = NULL, sep = NULL, control = NULL){
  # get condition
  condition <- get_condition_value(se, condition)
  
  # get condition vector
  condition_vector <- unique(SummarizedExperiment::colData(se)[[condition]])
  
  comparisons <- c()
  for(index_a in seq_len(length(condition_vector)-1)){
    for(index_b in seq(index_a+1, length(condition_vector))){
      sample_a <- condition_vector[index_a]
      sample_b <- condition_vector[index_b]
      
      if(is.null(sep)){
        # only one condition to compare
        comparisons <- c(comparisons, paste0(sample_b, "-", sample_a))
      } else {
        # check if a or b are controls
        if(!is.null(control)){
          if((sample_a == control) || (sample_b == control)){
            next
          }
        }
        
        # check of how many individual groups the condition is composed
        splits_a <- stringr::str_split(sample_a, sep)[[1]]
        splits_b <- stringr::str_split(sample_b, sep)[[1]]
        must_match <- length(splits_a) - 1 # one group should stay variable
        
        # check how many groups are the same --> n - 1 groups need to be the same to add the comparison
        match_count <- 0
        for(i in seq_len(length(splits_a))){
          split_a <- splits_a[i]
          split_b <- splits_b[i]
          if(split_a == split_b){
            match_count <- match_count + 1
          }
        }
        if(match_count == must_match){
          comparisons <- c(comparisons, paste0(sample_b, "-", sample_a))
        }
      }
    }
  }
  
  # add control comparisons
  if(!is.null(control)){
    for(index_a in seq(length(condition_vector))){
      sample_a <- condition_vector[index_a]
      if(sample_a != control){
        comparisons <- c(comparisons, paste0(sample_a, "-", control))
      }
    }
  }
  
  return(as.factor(comparisons))
}

#' Fitting a linear model using limma
#'
#' @param data Data table of intensities (rows = proteins, cols = samples)
#' @param condition_vector Vector of experimental design specifying the condition(s) to compare
#' @param comparisons Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)
#' @param covariate String specifying which column to include as covariate into limma
#' @param trend logical, should an intensity-dependent trend be allowed for the prior variance? If FALSE then the prior variance is constant. Alternatively, trend can be a row-wise numeric vector, which will be used as the covariate for the prior variance.
#' @param robust logical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?
#'
#' @return eBayes object
#'
perform_limma <- function(data, condition_vector, comparisons, covariate = NULL, trend = TRUE, robust = TRUE){
  # Create design matrix
  groupsM <- as.factor(condition_vector)
  if(is.null(covariate)){
    designM <- stats::model.matrix(~0+groupsM)
    colnames(designM) <- levels(groupsM)
  } else {
    designM <- stats::model.matrix(~0+groupsM+covariate)
    colnames(designM)[seq(length(levels(groupsM)))] <- levels(groupsM)
  }
  
  # Fit linear moel
  fit <- limma::lmFit(data, designM)
  
  # Create contrasts
  contr <- limma::makeContrasts(contrasts = comparisons, levels = colnames(stats::coef(fit)))
  
  # Contrast fit and ebayes
  fit2 <- limma::contrasts.fit(fit, contr)
  ebfit <- limma::eBayes(fit2, trend=trend, robust = robust)
  return(ebfit)
}


#' Extract the DE results from eBayes fit of perform_limma function.
#'
#' @param fit eBayes object resulting from perform_limma method
#' @param comparisons Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#'
#' @return Data table with limma DE results
#'
extract_limma_DE <- function(fit, comparisons, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, alpha = 0.05){
  de_res <- NULL
  for (i in seq_len(length(comparisons))){
    # get results for each comparison
    top.table <- limma::topTable(fit, sort.by = "P", number=Inf, coef=c(i), adjust.method = "BH")
    gene_reg <- data.table::setDT(top.table, keep.rownames = "ID") # save row names as column
    if(logFC){
      # logFC
      if(p_adj){
        # p.adjust
        gene_reg$Change <- ifelse(gene_reg$logFC >= logFC_up & gene_reg$adj.P.Val <= alpha, "Up Regulated", ifelse(gene_reg$logFC <= logFC_down & gene_reg$adj.P.Val <= alpha, "Down Regulated", "No Change"))
      } else {
        # p.value
        gene_reg$Change <- ifelse(gene_reg$logFC >= logFC_up & gene_reg$P.Value <= alpha, "Up Regulated", ifelse(gene_reg$logFC <= logFC_down & gene_reg$P.Value <= alpha, "Down Regulated", "No Change"))
      }
    } else {
      # no logFC
      if(p_adj){
        # p.adjust
        gene_reg$Change <- ifelse(gene_reg$adj.P.Val <= alpha, "Significant Change", "No Change")
      } else {
        # p.value
        gene_reg$Change <- ifelse(gene_reg$P.Value <= alpha, "Significant Change", "No Change")
      }
    }
    gene_reg$Change <- as.factor(gene_reg$Change)
    gene_reg$Comparison <- rep(comparisons[i], nrow(gene_reg))
    if(is.null(de_res)){
      de_res <- gene_reg
    } else {
      de_res <- rbind(de_res, gene_reg)
    }
  }
  return(de_res)
}


#' Performing ROTS
#'
#' @param data Data table of intensities (rows = proteins, cols = samples)
#' @param condition Vector of experimental design specifying the condition(s) to compare
#' @param comparisons Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)
#' @param condition_name String of name of condition in colData
#' @param coldata colData of the SummarizedExperiment
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#' @param B Number of bootstrapping for ROTS
#' @param K Number of top-ranked features for reproducibility optimization
#'
#' @return Data table with DE results
#'
perform_ROTS <- function(data, condition, comparisons, condition_name, coldata, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, alpha = 0.05, B =100, K = 500){
  de_res <- NULL
  for (comp in comparisons){
    # extract data of comparison
    sampleA <- strsplit(comp, "-")[[1]][1]
    sampleB <- strsplit(comp, "-")[[1]][2]
    coldata_chunk <- coldata[coldata[[condition_name]] %in% c(sampleA, sampleB),]
    coldata_chunk <- coldata_chunk %>% dplyr::arrange(factor(get(condition_name), levels = c(sampleA, sampleB)))
    dt_chunk <- data[, coldata_chunk$Column]
    # specify group vector
    group <- factor(coldata_chunk[[condition_name]], levels = c(sampleA, sampleB))
    group <- as.numeric(group)
    # remove protein groups with less than 2 valid values per group
    for (i in unique(group)){
      to_remove <- rowSums(is.na(dt_chunk[, which(group == i)])) >= 2
      dt_chunk <- dt_chunk[!to_remove,]
    }
    # perform ROTS
    rots <- ROTS::ROTS(data = dt_chunk, groups = group, B = B, K = K, seed = 1234)
    # extract ROTS results
    gene_reg <- data.table::data.table(ID = rownames(rots$data), logFC = rots$logfc, adj.P.Val = rots$FDR, P.Value = rots$pvalue)
    gene_reg$Comparison <- comp
    
    if(logFC){
      # logFC
      if(p_adj){
        # p.adjust
        gene_reg$Change <- ifelse(gene_reg$logFC >= logFC_up & gene_reg$adj.P.Val <= alpha, "Up Regulated", ifelse(gene_reg$logFC <= logFC_down & gene_reg$adj.P.Val <= alpha, "Down Regulated", "No Change"))
      } else {
        # p.value
        gene_reg$Change <- ifelse(gene_reg$logFC >= logFC_up & gene_reg$P.Value <= alpha, "Up Regulated", ifelse(gene_reg$logFC <= logFC_down & gene_reg$P.Value <= alpha, "Down Regulated", "No Change"))
      }
    } else {
      # no logFC
      if(p_adj){
        # p.adjust
        gene_reg$Change <- ifelse(gene_reg$adj.P.Val <= alpha, "Significant Change", "No Change")
      } else {
        # p.value
        gene_reg$Change <- ifelse(gene_reg$P.Value <= alpha, "Significant Change", "No Change")
      }
    }
    gene_reg$Change <- as.factor(gene_reg$Change)
    #gene_reg$Comparison <- rep(comparisons[i], nrow(gene_reg))
    if(is.null(de_res)){
      de_res <- gene_reg
    } else {
      de_res <- rbind(de_res, gene_reg)
    }
  }
  return(de_res)
}

#' Additional function of the DEqMS package
#'
#' @param fit linear model from function perform_limma
#' @param coef_col an integer vector indicating the column(s) of fit$coefficients for which the function is to be performed. if not specified, all coefficients are used.
#'
#' @return list object
#'
spectraCounteBayes_DEqMS <- function(fit, coef_col){
  logVAR <- log(fit$sigma^2)
  df <- fit$df.residual
  numgenes <- length(logVAR[df > 0])
  df[df == 0] <- NA
  eg <- logVAR - digamma(df/2) + log(df/2)
  names(fit$count) <- rownames(fit$coefficients)
  output <- fit
  output$fit.method <- "loess"
  #loess
  x <- log2(fit$count)
  loess.model <- stats:: loess(logVAR ~ x, span = 0.75, na.action = stats::na.exclude)
  y.pred <- stats::fitted(loess.model)
  output$model <- loess.model
  
  egpred <- y.pred - digamma(df/2) + log(df/2)
  myfct <- (eg - egpred)^2 - trigamma(df/2)
  mean.myfct <- mean(myfct, na.rm = TRUE)
  priordf <- vector()
  testd0 <- vector()
  for (i in seq(1, numgenes * 10)) {
    testd0[i] <- i/10
    priordf[i] <- abs(mean.myfct - trigamma(testd0[i]/2))
    if (i > 2) {
      if (priordf[i - 2] < priordf[i - 1]) {
        break
      }
    }
  }
  d0 <- testd0[match(min(priordf), priordf)]
  s02 <- exp(egpred + digamma(d0/2) - log(d0/2))
  post.var <- (d0 * s02 + df * fit$sigma^2)/(d0 + df)
  post.df <- d0 + df
  sca.t <- as.matrix(fit$coefficients[, coef_col]/(fit$stdev.unscaled[,
                                                                      coef_col] * sqrt(post.var)))
  sca.p <- as.matrix(2 * stats::pt(abs(sca.t), post.df, lower.tail = FALSE))
  output$sca.t <- sca.t
  output$sca.p <- sca.p
  output$sca.postvar <- post.var
  output$sca.priorvar <- s02
  output$sca.dfprior <- d0
  return(output)
}


#' Perform DEqMS
#'
#' @param fit eBayes object resulting from perform_limma method
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param DEqMS_PSMs_column String specifying which column name to use for DEqMS (default NULL). Any column of the rowData(se) is accepted.
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#'
#' @return data.table of DE results
#'
perform_DEqMS <- function(fit, se, DEqMS_PSMs_column = NULL, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, alpha = 0.05){
  # check again DEqMS_PSMs_column
  check_DEqMS_parameter(se, DEqMS_PSMs_column)
  
  # create PSMs table
  prot <- rownames(fit$coefficients)
  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  PSMs <- data.frame("PSMs" = rowdata[[DEqMS_PSMs_column]])
  rownames(PSMs) <- rowdata$Protein.IDs
  fit$count <- PSMs[prot, "PSMs"]
  fit_DEqMS <- spectraCounteBayes_DEqMS(fit) # model variance
  
  # create DEqMS results
  DEqMS_results <- NULL
  for (i in seq(length(colnames(fit_DEqMS$coefficients)))){
    comp <- colnames(fit_DEqMS$coefficients)[i]
    results <- DEqMS::outputResult(fit_DEqMS, coef_col = i)
    results$ID <- row.names(results)
    results$adj.P.Val <- results$sca.adj.pval
    results$P.Value <- results$sca.P.Value
    results <- results[, c("ID", "logFC", "AveExpr", "t", "P.Value", "adj.P.Val")]
    results$Comparison <- comp
    if(is.null(DEqMS_results)){
      DEqMS_results <- results
    } else {
      DEqMS_results <- rbind(DEqMS_results, results)
    }
  }
  
  if(logFC){
    # logFC
    if(p_adj){
      # p.adjust
      DEqMS_results$Change <- ifelse(DEqMS_results$logFC >= logFC_up & DEqMS_results$adj.P.Val <= alpha, "Up Regulated", ifelse(DEqMS_results$logFC <= logFC_down & DEqMS_results$adj.P.Val <= alpha, "Down Regulated", "No Change"))
    } else {
      # p.value
      DEqMS_results$Change <- ifelse(DEqMS_results$logFC >= logFC_up & DEqMS_results$P.Value <= alpha, "Up Regulated", ifelse(DEqMS_results$logFC <= logFC_down & DEqMS_results$P.Value <= alpha, "Down Regulated", "No Change"))
    }
  } else {
    # no logFC
    if(p_adj){
      # p.adjust
      DEqMS_results$Change <- ifelse(DEqMS_results$adj.P.Val <= alpha, "Significant Change", "No Change")
    } else {
      # p.value
      DEqMS_results$Change <- ifelse(DEqMS_results$P.Value <= alpha, "Significant Change", "No Change")
    }
  }
  DEqMS_results$Change <- as.factor(DEqMS_results$Change)
  return(data.table::as.data.table(DEqMS_results))
}

#' Run DE analysis on a single normalized data set
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param method String specifying which assay should be used as input
#' @param comparisons Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param DE_method String specifying which DE method should be applied (limma, ROTS, DEqMS)
#' @param covariate String specifying which column to include as covariate into limma
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#' @param B Number of bootstrapping for ROTS
#' @param K Number of top-ranked features for reproducibility optimization
#' @param trend logical, should an intensity-dependent trend be allowed for the prior variance? If FALSE then the prior variance is constant. Alternatively, trend can be a row-wise numeric vector, which will be used as the covariate for the prior variance.
#' @param robust logical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?
#' @param DEqMS_PSMs_column String specifying which column name to use for DEqMS (default NULL).  Any column of the rowData(se) is accepted.
#'
#' @return Data table of DE results
#'
run_DE_single <- function(se, method, comparisons, condition = NULL, DE_method = "limma", covariate = NULL, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, alpha = 0.05, B = 100, K = 500, trend = TRUE, robust = TRUE, DEqMS_PSMs_column = NULL){
  # check parameters (if users are calling this function instead of run_DE)
  params <- check_DE_parameters(se, ain = method, condition = condition, comparisons = comparisons, DE_method = DE_method, covariate = covariate, logFC = logFC, logFC_up = logFC_up, logFC_down = logFC_down, p_adj = p_adj, alpha = alpha, B = B, K = K, DEqMS_PSMs_column = DEqMS_PSMs_column)
  method <- params[["ain"]]
  condition <- params[["condition"]]
  
  # get covariate
  if(!is.null(covariate)){
    covariate <- SummarizedExperiment::colData(se)[[covariate]]
  }
  
  # prepare data
  dt <- as.data.frame(SummarizedExperiment::assays(se)[[method]])
  rownames(dt) <- data.table::as.data.table(SummarizedExperiment::rowData(se))$Protein.IDs
  dt <- dt[rowSums(is.na(dt)) != ncol(dt), ] # remove complete NAs
  condition_vector <- SummarizedExperiment::colData(se)[[condition]]
  
  # run DE
  if(DE_method == "limma"){
    # run limma
    fit <- perform_limma(data = dt, condition_vector = condition_vector, comparisons = comparisons, covariate = covariate, trend = trend, robust = robust)
    de_chunk <- extract_limma_DE(fit = fit, comparisons = comparisons, logFC = logFC, logFC_up = logFC_up, logFC_down = logFC_down, p_adj = p_adj, alpha = alpha)
  } else if (DE_method == "ROTS"){
    # run ROTS
    de_chunk <- perform_ROTS(data = dt, condition = condition, comparisons = comparisons, condition_name = condition, coldata = data.table::as.data.table(SummarizedExperiment::colData(se)), logFC = logFC, logFC_up = logFC_up, logFC_down = logFC_down, p_adj = p_adj, alpha = alpha, B = B, K = K)
  } else if (DE_method == "DEqMS"){
    # first run limma model
    fit <- perform_limma(data = dt, condition_vector = condition_vector, comparisons = comparisons, covariate = covariate, trend = trend, robust = robust)
    de_chunk <- perform_DEqMS(fit = fit, se = se, DEqMS_PSMs_column = DEqMS_PSMs_column, logFC = logFC, logFC_up = logFC_up, logFC_down = logFC_down, p_adj = p_adj, alpha = alpha)
  }
  
  # add other information
  de_chunk$Assay <- method
  de_chunk$Protein.IDs <- de_chunk$ID
  de_chunk$ID <- NULL
  de_chunk <- de_chunk[, c("Protein.IDs", "logFC", "P.Value", "adj.P.Val", "Change", "Comparison", "Assay")]
  
  # add missing proteins (that could not be calculated)
  rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  for(comp in comparisons){
    # take comparison
    de_res_comp <- de_chunk[de_chunk$Comparison == comp,]
    if(sum(rd$Protein.IDs %in% de_res_comp$Protein.IDs) != nrow(rd)){
      missing <- rd$Protein.IDs[! rd$Protein.IDs %in% de_res_comp$Protein.IDs]
      if(length(missing) > 0){
        de <- data.table::data.table("Protein.IDs" = missing, "logFC" = rep(NA, length(missing)), "P.Value" = rep(NA, length(missing)), "adj.P.Val" = rep(NA, length(missing)), "Change" = rep("No Change", length(missing)), "Comparison" = rep(comp, length(missing)), "Assay" = rep(method, length(missing)))
        de_chunk <- rbind(de_chunk, de)
      }
    }
  }
  de_chunk$Change[is.na(de_chunk$Change)] <- "No Change"
  
  if(is.null(S4Vectors::metadata(se)$spike_column)){
    rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))[,c("Protein.IDs", "Gene.Names", "IDs")]
  } else {
    # add spike info
    spike_column <- S4Vectors::metadata(se)$spike_column
    cols <- c("Protein.IDs", "Gene.Names", "IDs", spike_column)
    rd <- data.table::as.data.table(SummarizedExperiment::rowData(se))[, cols]
  }
  
  de_chunk <- merge(de_chunk, rd, by="Protein.IDs")
  de_chunk$Comparison <- factor(de_chunk$Comparison, levels = comparisons)
  return(de_chunk)
}

#' Run DE analysis of a selection of normalized data sets
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param comparisons Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)
#' @param ain Vector of strings which assay should be used as input (default NULL).
#'            If NULL then all normalization of the se object are plotted next to each other.
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param DE_method String specifying which DE method should be applied (limma, ROTS, DEqMS)
#' @param covariate String specifying which column to include as covariate into limma
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#' @param B Number of bootstrapping for ROTS
#' @param K Number of top-ranked features for reproducibility optimization
#' @param trend logical, should an intensity-dependent trend be allowed for the prior variance? If FALSE then the prior variance is constant. Alternatively, trend can be a row-wise numeric vector, which will be used as the covariate for the prior variance.
#' @param robust logical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?
#' @param DEqMS_PSMs_column String specifying which column name to use for DEqMS (default NULL).  Any column of the rowData(se) is accepted.
#'
#' @return Data table of DE results of selected normalized data sets
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' comparisons <- specify_comparisons(tuberculosis_TMT_se, condition = NULL,
#'                             sep = NULL, control = NULL)
#' de_res <- run_DE(tuberculosis_TMT_se, comparisons,
#'               ain = NULL, condition = NULL, DE_method = "limma",
#'               logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE,
#'               alpha = 0.05, B = 100, K = 500, trend = TRUE, robust = TRUE)
#'
run_DE <- function(se, comparisons, ain = NULL, condition = NULL, DE_method = "limma", covariate = NULL, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, alpha = 0.05, B = 100, K = 500, trend = TRUE, robust = TRUE, DEqMS_PSMs_column = NULL){
  # check parameters
  params <- check_DE_parameters(se, ain = ain, condition = condition, comparisons = comparisons, DE_method = DE_method, covariate = covariate, logFC = logFC, logFC_up = logFC_up, logFC_down = logFC_down, p_adj = p_adj, alpha = alpha, B = B, K = K)
  ain <- params[["ain"]]
  condition <- params[["condition"]]
  
  if("raw" %in% ain){
    message("DE Analysis will not be performed on raw data.")
    ain <- ain[ain != "raw"]
  }
  
  # run DE
  de_res <- NULL
  for(method in c(ain)){
    de_chunk <- run_DE_single(se, method = method, condition = condition, comparisons = comparisons, DE_method = DE_method, covariate = covariate, logFC = logFC, logFC_up = logFC_up, logFC_down = logFC_down, p_adj = p_adj, alpha = alpha, B = B, K = K, trend = trend, robust = robust, DEqMS_PSMs_column = DEqMS_PSMs_column)
    # add to overall results
    if(is.null(de_res)){
      de_res <- de_chunk
    } else {
      de_res <- rbind(de_res, de_chunk)
    }
    message(paste0(method, ": DE analysis completed."))
  }
  return(de_res)
}


#' Apply other thresholds to DE results
#'
#' @param de_res data table resulting of run_DE
#' @param logFC Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)
#' @param logFC_up Upper log2 fold change threshold (dividing into up regulated)
#' @param logFC_down Lower log2 fold change threshold (dividing into down regulated)
#' @param p_adj Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)
#' @param alpha Threshold for adjusted p-values or p-values
#'
#' @return data table updating the Change column with the newly applied thresholds
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' de_res <- apply_thresholds(tuberculosis_TMT_de_res, logFC = FALSE,
#'                            p_adj = TRUE, alpha = 0.01)
#'
apply_thresholds <- function(de_res, logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE, alpha = 0.05){
  stopifnot("Change" %in% colnames(de_res))
  
  if(logFC){
    # logFC
    if(p_adj){
      # p.adjust
      de_res$Change <- ifelse(de_res$logFC >= logFC_up & de_res$adj.P.Val <= alpha, "Up Regulated", ifelse(de_res$logFC <= logFC_down & de_res$adj.P.Val <= alpha, "Down Regulated", "No Change"))
    } else {
      # p.value
      de_res$Change <- ifelse(de_res$logFC >= logFC_up & de_res$P.Value <= alpha, "Up Regulated", ifelse(de_res$logFC <= logFC_down & de_res$P.Value <= alpha, "Down Regulated", "No Change"))
    }
  } else {
    # no logFC
    if(p_adj){
      # p.adjust
      de_res$Change <- ifelse(de_res$adj.P.Val <= alpha, "Significant Change", "No Change")
    } else {
      # p.value
      de_res$Change <- ifelse(de_res$P.Value <= alpha, "Significant Change", "No Change")
    }
  }
  de_res$Change <- as.factor(de_res$Change)
  return(de_res)
}


#' Get overview table of DE results
#'
#' @param de_res data table resulting of run_DE
#'
#' @return data table of numbers of DE proteins per comparison and per normalization method
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_de_res)
#' get_overview_DE(tuberculosis_TMT_de_res)
#'
get_overview_DE <- function(de_res){
  if("Significant Change" %in% de_res$Change){
    dt <- de_res %>% dplyr::group_by(Assay, Comparison) %>% dplyr::summarize('Significant Change' = sum(Change == "Significant Change", na.rm=TRUE)) %>% data.table::as.data.table()
  } else if ("Up Regulated" %in% de_res$Change | "Down Regulated" %in% de_res$Change){
    dt <- de_res %>% dplyr::group_by(Assay, Comparison) %>% dplyr::summarize('Up Regulated' = sum(Change == "Up Regulated", na.rm=TRUE),
                                                                             'Down Regulated' = sum(Change == "Down Regulated", na.rm=TRUE)) %>% data.table::as.data.table()
  } else {
    stop("No DE proteins found for any comparison and normalization method!")
  }
  dt$Assay <- factor(dt$Assay, levels = unique(de_res$Assay))
  return(dt)
}

################# ----------- Filter Samples Functions ----------- ###################

#' Remove outliers samples detected by the detect_outliers_POMA function
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param poma_res_outliers Outliers data.table returned by the detect_outliers_POMA function
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' poma_res <- detect_outliers_POMA(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- remove_POMA_outliers(tuberculosis_TMT_se, poma_res$outliers)
#'
remove_POMA_outliers <- function(se, poma_res_outliers){
  if(nrow(poma_res_outliers) == 0){
    message("No outlier samples detected! Hence, no samples were removed.")
    return(se)
  } else {
    se_subset <- se[, !se$Column %in% poma_res_outliers$sample]
    rm <- ncol(se) - ncol(se_subset)
    if(rm == 0){
      message("No outlier samples detected! Hence, no samples removed.")
      return(se)
    } else {
      message(paste0(rm, " outlier samples removed."))
      return(se_subset)
    }
  }
}


#' Remove samples with specific value in column manually
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param column String specifying the column of the meta data (samples with the specified value in this column will be removed)
#' @param values Vector of Strings specifying the value for the removal of samples (samples with this value in the specified column will be removed)
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- remove_samples_manually(tuberculosis_TMT_se,
#'                                 column = "Label", values = c("1.HC_Pool1"))
#'
remove_samples_manually <- function(se, column, values){
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  # check if column in object
  if(! column %in% colnames(coldata)){
    stop(paste0(column, " not in data!"))
  } else {
    col <- coldata[[column]]
    # check if there is a sample with the specific value in the corresponding column
    if(sum(!c(values) %in% col) == length(c(values))){
      stop(paste0("No sample(s) found with ", values, " in ", column, "column!"))
    } else {
      se_subset <- se[, !se[[column]] %in% values]
      # check if all samples would be removed
      if(ncol(se_subset) == 0){
        stop("All samples would be removed. Aborted!")
      } else {
        rm <- ncol(se) - ncol(se_subset)
        message(paste0(rm, " samples removed."))
        return(se_subset)
      }
    }
  }
}


#' Remove reference samples of SummarizedExperiment object (reference samples specified during loading)
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#'
#' @return filtered SummarizedExperiment object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' tuberculosis_TMT_se <- remove_reference_samples(tuberculosis_TMT_se)
#'
remove_reference_samples <- function(se){
  refs <- S4Vectors::metadata(se)$refs
  condition <- S4Vectors::metadata(se)$condition
  if(is.null(refs)){
    stop("No reference samples specified during data loading!")
  } else {
    se_subset <- se[,! se$Column %in% c(refs)]
    rm <- ncol(se) - ncol(se_subset)
    message(paste0(rm, " reference samples removed from the SummarizedExperiment object."))
    if(!is.null(levels(se[[condition]]))){
      se_subset[[condition]] <- droplevels(se_subset[[condition]])
    }
    return(se_subset)
  }
}


################# ----------- Plotting Functions ----------- ###################

#' Plot number of non-zero proteins per sample
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which data type should be used (default raw)
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_nr_prot_samples(tuberculosis_TMT_se, ain="raw", color_by = "Group",
#'                      label_by = "Label")
#'
plot_nr_prot_samples <- function(se, ain="raw", color_by = NULL, label_by = NULL){
  # get color and label values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  # prepare data
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  dt$ID <- rownames(dt)
  dt <- data.table::melt(dt, id.vars = "ID", variable.name = "Column", value.name = "Intensity")
  dt$Intensity[is.na(dt$Intensity)] <- 0
  dt <- dt[dt$Intensity != 0,]
  dt <- dt %>% dplyr::count(Column)
  dt <- merge(dt, data.table::as.data.table(SummarizedExperiment::colData(se)), by="Column")
  dt <- data.table::as.data.table(dt)

  # order data
  if(!is.null(color_by)){
    dt[, color_by] <- factor(dt[,color_by], levels = unique(dt[,color_by]))
    dt <- dt[order(dt[,color_by]),]
    if(show_sample_names){
      dt[, label_by] <- factor(dt[,label_by], levels = unique(dt[,label_by]))
    } else {
      dt$Column <- factor(dt$Column, levels = dt$Column)
    }
  }

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  if(is.null(color_by)){
    p <- ggplot2::ggplot(dt, ggplot2::aes(x=get(label_by), y=get("n"))) +
      ggplot2::geom_bar(stat="identity") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust=0.5, hjust=1)) +
      ggplot2::labs(x = "Samples", y ="Number of Proteins \n (non-zero protein abundance)")
  } else {
    p <- ggplot2::ggplot(dt, ggplot2::aes(x=get(label_by), y=get("n"), fill=get(color_by))) +
      ggplot2::geom_bar(stat="identity") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust=0.5, hjust=1)) +
      ggplot2::scale_fill_manual(name = color_by, values = col_vector ) +
      ggplot2::labs(x = "Samples", y ="Number of Proteins \n (non-zero protein abundance)")
  }
  if(!show_sample_names){
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_blank(), axis.ticks.x = ggplot2::element_blank())
  }
  return(p)
}

#' Plot total protein intensity per sample
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which data type should be used (default raw)
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)
#'
#' @return list of a ggplot object and the dataframe of outliers
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' plot_tot_int_samples(tuberculosis_TMT_se, ain="raw", color_by = NULL,
#'                      label_by = NULL)
#'
plot_tot_int_samples <- function(se, ain="raw", color_by = NULL, label_by = NULL){
  # get color and label values
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  # prepare data
  dt <- data.table::as.data.table(SummarizedExperiment::assays(se)[[ain]])
  dt$ID <- rownames(dt)
  dt <- data.table::melt(dt, id.vars = "ID", variable.name = "Column", value.name = "Intensity")
  dt$Intensity[is.na(dt$Intensity)] <- 0
  dt <- dt %>% dplyr::group_by(Column) %>% dplyr::summarise(total = sum(Intensity)) %>% data.table::as.data.table()
  dt <- merge(dt, data.table::as.data.table(SummarizedExperiment::colData(se)), by="Column")
  dt$total <- as.numeric(dt$total)

  # order data
  if(!is.null(color_by)){
    dt[, color_by] <- factor(dt[,color_by], levels = unique(dt[,color_by]))
    dt <- dt[order(dt[,color_by]),]
    if(show_sample_names){
      dt[, label_by] <- factor(dt[,label_by], levels = unique(dt[,label_by]))
    } else {
      dt$Column <- factor(dt$Column, levels = dt$Column)
    }
  }

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  if(is.null(color_by)){
    p <- ggplot2::ggplot(dt, ggplot2::aes(x=get(label_by), y=get("total"))) +
      ggplot2::geom_bar(stat="identity") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust=0.5, hjust=1)) +
      ggplot2::labs(x = "Samples", y ="Total Protein Intensity")
  } else {
    p <- ggplot2::ggplot(dt, ggplot2::aes(x=get(label_by), y=get("total"), fill=get(color_by))) +
      ggplot2::geom_bar(stat="identity") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust=0.5, hjust=1)) +
      ggplot2::scale_fill_manual(name = color_by, values = col_vector ) +
      ggplot2::labs(x = "Samples", y ="Total Protein Intensity")
  }
  if(!show_sample_names){
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_blank(), axis.ticks.x = ggplot2::element_blank())
  }
  return(p)
}


#' Outlier detection via POMA R Package
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param ain String which data type should be used (default raw)
#' @param condition Column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param method String specifying the method that should be used to calculate the distance matrix
#' @param type String specifying the type of distance calculation to centroid or spatial median
#' @param group String specifying if the outlier detection should be performed multi-variate
#'             (with conditions) or on the complete data set
#' @param coeff This value corresponds to the classical 1.5 in Q3 + 1.5 * IQR formula to detect outliers. By changing this value, the permissiveness in outlier detection will change.
#' @importFrom magrittr %>%
#' @importFrom ggtext element_textbox_simple
#'
#' @return list of two ggplot objects and a data.table with outlier samples
#' @export
#'
#' @examples
#' data(tuberculosis_TMT_se)
#' poma_res <- detect_outliers_POMA(tuberculosis_TMT_se, ain="raw",
#'                                  condition = NULL, method="euclidean",
#'                                  type="median", group=TRUE, coeff = 1.5)
detect_outliers_POMA <- function(se, ain="log2", condition = NULL, method="euclidean", type="median", group=TRUE, coeff = 1.5){

  # get condition
  condition <- get_condition_value(se, condition)
  
  stopifnot(length(ain) == 1)

  # prepare data
  md <- data.table::as.data.table(SummarizedExperiment::colData(se))
  if(group){
    condition_vector <- md[[condition]]
  } else {
    condition <- "complete"
    condition_vector <- rep("complete",nrow(md))
  }
  new_md <- data.table::data.table("Condition" = as.factor(condition_vector), "Column" = md$Column)
  colnames(new_md)[1] <- condition
  data <- SummarizedExperiment::SummarizedExperiment(assays = SummarizedExperiment::assays(se)[[ain]], colData = new_md, rowData=SummarizedExperiment::rowData(se))
  
  # perform POMA outlier detection
  poma_res <- POMA::PomaOutliers(data, method=method, type=type, coef = coeff)

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # modify plots
  poma_res$polygon_plot <- poma_res$polygon_plot +
    ggplot2::scale_fill_manual(name = condition, values = col_vector) +
    ggplot2::scale_color_manual(condition, values = c(rep("black", length(unique(md[[condition]]))))) +
    ggplot2::scale_shape_manual(name = condition, values = seq_len(length(unique(md[[condition]]))))

  poma_res$distance_boxplot <- poma_res$distance_boxplot +
    ggplot2::scale_fill_manual(name = condition, values = col_vector) +
    ggplot2::labs(x = condition, y = "Distance to Group Centroid", fill = condition)

  poma_res$outliers <- data.table::as.data.table(poma_res$outliers)

  return(poma_res)
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)

## ----message = FALSE----------------------------------------------------------
# Load and attach PRONE
library(PRONE)

## ----load_real_tmt------------------------------------------------------------
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se

## ----eval = TRUE, include = TRUE----------------------------------------------
se <- subset_SE_by_norm(se, ain = c("raw", "log2"))

## -----------------------------------------------------------------------------
get_normalization_methods()

## -----------------------------------------------------------------------------
se_norm <- normalize_se(se, c("RobNorm", "Mean", "Median"), 
                        combination_pattern = NULL)

## -----------------------------------------------------------------------------
se_norm <- normalize_se(se, c("RobNorm", "Mean", "Median", "IRS_on_RobNorm", 
                        "IRS_on_Mean", "IRS_on_Median"), 
                        combination_pattern = "_on_")

## -----------------------------------------------------------------------------
se_norm <- medianNorm(se_norm, ain = "log2", aout = "Median")

## -----------------------------------------------------------------------------
names(assays(se_norm))

## ----fig.cap = "Boxplots of protein intensities of all normalization methods of the SummarizedExperiment object. This plot shows the protein distributions across samples.", fig.height = 8----
plot_boxplots(se_norm, ain = NULL, color_by = NULL, 
              label_by = NULL, ncol = 3, facet_norm = TRUE) + 
  ggplot2::theme(legend.position = "bottom", legend.direction = "horizontal")


## ----fig.cap = "Boxplots of protein intensities of a selection of normalization methods and colored by batch. This plot shows the protein distributions across samples."----
plot_boxplots(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
              color_by = "Pool", label_by = NULL, facet_norm = TRUE)

## ----fig.cap = "Single boxplot of protein intensities per selected normalization method and colored by batch .This plot shows the protein distributions across samples."----
plot_boxplots(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
              color_by = "Pool", label_by = NULL, facet_norm = FALSE)

## ----fig.cap = "Density plot of protein intensities of for a selection of normalization method."----
plot_densities(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
               color_by = NULL, facet_norm = TRUE)

## ----fig.cap = "Single PCA plot per normalization method, colored and faceted by condition, and shaped by batch effect. This plot helps to identify batch effects."----
plot_PCA(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
         color_by = "Group", label_by = "No", shape_by = "Pool", 
         facet_norm = FALSE, facet_by = "Group")

## ----fig.cap = "Combined PCA plot of a selection of normalization methods, colored by condition and shaped by batch effect. This plot helps to identify batch effects."----
plot_PCA(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
         color_by = "Group", label_by = "No", shape_by = "Pool", 
         facet_norm = TRUE)

## ----fig.cap = "Intragroup similarity measured by Pearson correlation for all normalization methods of the SummarizedExperiment object. The correlation between samples within the same group was calculated for all normalization methods and sample groups.."----
plot_intragroup_correlation(se_norm, ain = NULL, condition = NULL, 
                            method = "pearson")

## ----fig.cap = "Intragroup variation by calculation of the pooled coefficient of variation (PCV) for all normalization methods of the SummarizedExperiment object. The PCV was calculated for all normalization methods and sample groups."----
plot_intragroup_PCV(se_norm, ain = NULL, condition = NULL, diff = FALSE)

## ----fig.cap = "Intragroup variation by calculation of the pooled estimate of variance (PEV) for all normalization methods of the SummarizedExperiment object. The PEV was calculated for all normalization methods and sample groups."----
plot_intragroup_PEV(se_norm, ain = NULL, condition = NULL, diff = FALSE)

## ----fig.cap = "Intragroup variation by calculation of the pooled median absolute deviation (PMAD) for all normalization methods of the SummarizedExperiment object. The PMAD was calculated for all normalization methods and sample groups."----
plot_intragroup_PMAD(se_norm, ain = NULL, condition = NULL, diff = FALSE)

## ----fig.cap = "Reduction of intragroup variation, here using PCV, for all normalization methods of the SummarizedExperiment object compared to log2."----
plot_intragroup_PCV(se_norm, ain = NULL, condition = NULL, diff = TRUE) 

## ----fig.cap = "Reduction of intragroup variation, here using PEV, for all normalization methods of the SummarizedExperiment object compared to log2."----
plot_intragroup_PEV(se_norm, ain = NULL, condition = NULL, diff = TRUE)

## ----fig.cap = "Reduction of intragroup variation, here using PMAD, for all normalization methods of the SummarizedExperiment object compared to log2."----
plot_intragroup_PMAD(se_norm, ain = NULL, condition = NULL, diff = TRUE)

## -----------------------------------------------------------------------------
se_no_MAD <- remove_assays_from_SE(se_norm, assays_to_remove = c("Mean"))

## -----------------------------------------------------------------------------
se_subset <- subset_SE_by_norm(se_norm, 
                               ain = c("IRS_on_RobNorm", "IRS_on_Median"))

## -----------------------------------------------------------------------------
utils::sessionInfo()

#' Get performance metrics of DE results of spike-in data set.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param de_res data table resulting of run_DE
#'
#' @return data table with multiple performance metrics of the DE results
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
#'
get_spiked_stats_DE <- function(se, de_res){
  spike_column <- S4Vectors::metadata(se)$spike_column
  spike_val <- S4Vectors::metadata(se)$spike_value
  stats <- de_res %>% dplyr::group_by(Assay, Comparison) %>%
    dplyr::summarise(TP = sum(Change %in% c("Up Regulated", "Down Regulated", "Significant Change") & get(spike_column) == spike_val, na.rm=TRUE),
                     FP = sum(Change %in% c("Up Regulated", "Down Regulated", "Significant Change") & get(spike_column) != spike_val, na.rm=TRUE),
                     FN = sum(Change == "No Change" & get(spike_column) == spike_val, na.rm=TRUE),
                     TN = sum(Change == "No Change" & get(spike_column) != spike_val, na.rm=TRUE),
                     Sensitivity = TP / (TP + FN),
                     Specificity = TN /(TN + FP),
                     Precision = TP / (TP + FP),
                     FPR = FP / (FP + TN),
                     F1Score = (2 * TP) / (2 * TP + FP + FN),
                     Accuracy = (TP + TN)/(TP + TN + FP + FN)) %>%
    data.table::as.data.table()
  return(stats)
}


#' Heatmap of performance metrics for spike-in data sets
#'
#' @param stats data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#' @param metrics vector of Strings specifying the metrics (must be colnames of stats)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
#' plot_stats_spiked_heatmap(stats, ain = NULL, comparisons = NULL,
#'                           metrics = c("F1Score", "Accuracy"))
#'
plot_stats_spiked_heatmap <- function(stats, ain = NULL, comparisons = NULL, metrics = c("Accuracy", "Precision", "F1Score")){
  # check if measures in stats
  if(is.null(metrics)){
    message("All available metrics will be used for plotting")
    valid_metrics <- colnames(stats)[!colnames(stats) %in% c("TP", "FN", "TN", "FP")]
  } else {
    metrics <- c(metrics)
    valid_metrics <- metrics[metrics %in% colnames(stats)]
    non_valid_metrics <- metrics[!metrics %in% colnames(stats)]
    if(length(valid_metrics)== 0){
      stop("No valid metrics! Check colnames of stats.")
    } else if(length(non_valid_metrics)>0){
      warning(paste0("Not all metrics are valid!", metrics, " are not visualized!"))
    }
  }
  metrics <- valid_metrics
  dt <- stats[, colnames(stats) %in% c("Assay", "Comparison", metrics)]

  # check stats, ain, comparisons
  tmp <- check_stats_spiked_DE_parameters(stats, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  dt <- dt[dt$Assay %in% ain,]
  dt <- dt[dt$Comparison %in% comparisons,]

  # prepare data
  melted_dt <- data.table::melt(dt, variable.name = "Metric", value.name = "Value", id.vars = c("Assay", "Comparison"))
  p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x = get("Assay"), y = get("Comparison"), fill = get("Value"))) +
    ggplot2::geom_tile(colour = "white") +
    ggplot2::labs(x = "Normalization Method", y = "Comparison") +
    ggplot2::guides(fill = ggplot2::guide_colorbar(barwidth = 2, barheight = 5, title = "Value"))
  # plot
  if(length(metrics) == 1){
   p <- p + ggplot2::scale_fill_distiller(name = metrics[1],palette = "YlOrRd", direction = 1, limits = c(0,1))
  } else {
    p <- p + ggplot2::facet_wrap(~Metric, ncol = 2) + ggplot2::scale_fill_distiller(name = "Measure",palette = "YlOrRd", direction = 1, limits = c(0,1))
  }
  return(p)
}


#' Barplot of true and false positives for specific comparisons and normalization methods
#'
#' @param stats data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#'
#' @return ggplot object (barplot)
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
#' plot_TP_FP_spiked_bar(stats, ain = NULL, comparisons = NULL)
#'
plot_TP_FP_spiked_bar <- function(stats, ain = NULL, comparisons = NULL){
  # check stats, ain, comparisons
  tmp <- check_stats_spiked_DE_parameters(stats, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  dt <- stats[, c("Assay", "Comparison", "TP", "FP")]
  dt <- dt[dt$Assay %in% ain,]
  dt <- dt[dt$Comparison %in% comparisons,]

  dt$TP <- as.integer(dt$TP)
  dt$FP <- as.integer((-1) * as.integer(dt$FP))

  melted_dt <- data.table::melt(dt, variable.name = "Class", value.name = "Value", measure.vars = c("TP", "FP"))

  # plot
  p <- ggplot2::ggplot(melted_dt, ggplot2::aes(x=get("Assay"), y=get("Value"), fill = get("Class"))) +
    ggplot2::geom_bar(stat = "identity") +
    ggplot2::labs(y="False Positives | True Positives", x = "Normalization Method") +
    ggplot2::scale_fill_manual(values = c("#D55E00", "#0072B2"), name = "Class") +
    ggplot2::facet_wrap(~Comparison, scales="free_y") +
    ggplot2::scale_y_continuous(labels = abs) +
    ggplot2::coord_flip()
  return(p)
}

#' Boxplot of true and false positives for specific comparisons and normalization methods
#'
#' @param stats data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#'
#' @return ggplot object (barplot)
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
#' plot_TP_FP_spiked_box(stats, ain = NULL, comparisons = NULL)
#'
plot_TP_FP_spiked_box <- function(stats, ain = NULL, comparisons = NULL){
  # check stats, ain, comparisons
  tmp <- check_stats_spiked_DE_parameters(stats, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  dt <- stats[, c("Assay", "Comparison", "TP", "FP")]
  dt <- dt[dt$Assay %in% ain,]
  dt <- dt[dt$Comparison %in% comparisons,]

  dt$TP <- as.integer(dt$TP)
  dt$FP <- as.integer(dt$FP)

  melted_dt <- data.table::melt(dt, variable.name = "Class", value.name = "Value", measure.vars = c("TP", "FP"))

  # order methods
  tps <- melted_dt[melted_dt$Class == "TP",]
  meds <- tps %>% dplyr::group_by(Assay) %>% dplyr::summarise(Median = stats::median(Value, na.rm = TRUE)) %>% data.table::as.data.table()
  meds <- meds[order(meds$Median),]
  melted_dt_1 <- melted_dt
  melted_dt_1$Assay <- factor(melted_dt_1$Assay, levels = meds$Assay)

  # plot
  p <- ggplot2::ggplot(melted_dt_1, ggplot2::aes(x = get("Assay"), y = get("Value"), fill = get("Class"))) +
    ggplot2::geom_boxplot() +
    ggplot2::scale_fill_manual(values = c("#D55E00", "#0072B2"), name = "Class") +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle =90, vjust =0.5)) +
    ggplot2::labs(x = "Normalization Method", y="Number of Proteins")
  return(p)
}

#' Scatterplot of true positives and false positives (median with errorbars as Q1, and Q3) for all comparisons
#'
#' @param stats data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
#' plot_TP_FP_spiked_scatter(stats, ain = NULL, comparisons = NULL)
#'
plot_TP_FP_spiked_scatter <- function(stats, ain = NULL, comparisons = NULL){
  # check stats, ain, comparisons
  tmp <- check_stats_spiked_DE_parameters(stats, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  dt <- stats[, c("Assay", "Comparison", "TP", "FP")]
  dt <- dt[dt$Assay %in% ain,]
  dt <- dt[dt$Comparison %in% comparisons,]
  dt$TP <- as.integer(dt$TP)
  dt$FP <- as.integer(dt$FP)
  summarized_stats <- dt %>% dplyr::group_by(Assay) %>% dplyr::summarize(Median_TP = stats::median(TP, na.rm = TRUE), Median_FP = stats::median(FP, na.rm = TRUE), Q1_TP = stats::quantile(TP, c(0.25), na.rm = TRUE), Q3_TP = stats::quantile(TP,c(0.75), na.rm = TRUE),Q1_FP = stats::quantile(FP, c(0.25), na.rm = TRUE), Q3_FP = stats::quantile(FP,c(0.75), na.rm = TRUE))

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  p <- ggplot2::ggplot(summarized_stats, ggplot2::aes(x = Median_TP, y = Median_FP, color = Assay)) +
    ggplot2::geom_point(size = 6, shape = 15) +
    ggplot2::geom_errorbar(ggplot2::aes(ymin = Q1_FP, ymax = Q3_FP), linewidth = 1) +
    ggplot2::scale_y_continuous(trans = "log10", labels = scales::scientific) +
    ggplot2::geom_errorbarh(ggplot2::aes(xmin = Q1_TP, xmax = Q3_TP), linewidth = 1) +
    ggplot2::scale_x_continuous(trans = "log10", labels = scales::scientific) +
    ggplot2::scale_color_manual(name = "Normalization", values = col_vector) +
    ggplot2::labs(x = "log10(TPs)", y = "log10(FPs)")
  return(p)
}

#' Boxplot of log fold changes of spike-in and background proteins for specific normalization methods and comparisons. The ground truth (calculated based on the concentrations of the spike-ins) is shown as a horizontal line.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param de_res data table resulting of run_DE
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' plot_fold_changes_spiked(spike_in_se, spike_in_de_res,
#'                          condition = "Condition", ain = NULL,
#'                          comparisons = NULL)
#'
plot_fold_changes_spiked <- function(se, de_res, condition, ain = NULL, comparisons = NULL){
  # check input
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  de_res <- de_res[de_res$Assay %in% ain,]
  de_res <- de_res[de_res$Comparison %in% comparisons,]

  # check if spike_column in de_res
  spike_column <- S4Vectors::metadata(se)$spike_column
  if(!spike_column %in% colnames(de_res)){
    stop(paste0(spike_column, " not in de_res. Please perform run_DE again!"))
  }

  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))

  # check condition
  condition <- get_condition_value(se, condition)

  # retrieve concentration
  spike_concentration <- S4Vectors::metadata(se)$spike_concentration
  concentrations <- unique(coldata[, c(condition, spike_concentration)])

  comps <- data.table::data.table(Comparison = unique(de_res$Comparison))
  comps$SampleA <- sapply(strsplit(as.character(comps$Comparison),"-"), "[", 1)
  comps$SampleB <- sapply(strsplit(as.character(comps$Comparison),"-"), "[", 2)
  comps <- merge(comps, concentrations, by.x = "SampleA", by.y = condition)
  comps <- comps %>% dplyr::rename("ConcentrationA" = Concentration)
  comps <- merge(comps, concentrations, by.x = "SampleB", by.y = condition)
  comps <- comps %>% dplyr::rename("ConcentrationB" = Concentration)
  comps$Truth <- log2(comps$ConcentrationA / comps$ConcentrationB)

  spike_value <- S4Vectors::metadata(se)$spike_value
  types <- unique(de_res[[spike_column]])
  levels <- c(spike_value, types[!types %in% spike_value])
  de_res[[spike_column]] <- factor(de_res[[spike_column]], levels = levels)

  de_res <- merge(de_res, comps[, c("Comparison", "Truth")], by="Comparison")

  p <- ggplot2::ggplot(de_res, ggplot2::aes(x=get("Assay"), y=get("logFC"), fill=get(spike_column))) +
    ggplot2::geom_boxplot() +
    ggplot2::facet_wrap(~Comparison, ncol=1, scales = "free_y") +
    ggplot2::labs(fill = spike_column, x = "Normalization Method", y = "LogFC") +
    ggplot2::scale_fill_manual(values = c("#D55E00", "#0072B2")) +
    ggplot2::geom_hline(yintercept = 0, linetype = "dashed", colour="#0072B2", alpha=0.8)  +
    ggplot2::geom_hline(ggplot2::aes(yintercept = get("Truth")), linetype = "dashed", color="#D55E00", alpha=0.8)
  return(p)
}


#' Boxplot of p-values of spike-in and background proteins for specific normalization methods and comparisons. The ground truth (calculated based on the concentrations of the spike-ins) is shown as a horizontal line.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' plot_pvalues_spiked(spike_in_se, spike_in_de_res, ain = NULL,
#'                     comparisons = NULL)
#'
plot_pvalues_spiked <- function(se, de_res, ain = NULL, comparisons = NULL){
  # check input
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  de_res <- de_res[de_res$Assay %in% ain,]
  de_res <- de_res[de_res$Comparison %in% comparisons,]

  # check if spike_column in de_res
  spike_column <- S4Vectors::metadata(se)$spike_column
  if(!spike_column %in% colnames(de_res)){
    stop(paste0(spike_column, " not in de_res. Please perform run_DE again!"))
  }

  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))

  spike_value <- S4Vectors::metadata(se)$spike_value
  types <- unique(de_res[[spike_column]])
  levels <- c(spike_value, types[!types %in% spike_value])
  de_res[[spike_column]] <- factor(de_res[[spike_column]], levels = levels)


  p <- ggplot2::ggplot(de_res, ggplot2::aes(x=get("Assay"), y=log10(get("P.Value")), fill=get(spike_column))) +
    ggplot2::geom_boxplot() +
    ggplot2::facet_wrap(~Comparison, ncol=1, scales = "free_y") +
    ggplot2::labs(fill = spike_column, x = "Normalization Method", y = expression(-log[10]~"P-value")) +
    ggplot2::scale_fill_manual(values = c("#D55E00", "#0072B2"))
  return(p)
}


#' Line plot of number of true and false positives when applying different logFC thresholds
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param de_res data table resulting of run_DE
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#' @param nrow number of rows for facet wrap
#' @param alpha threshold for adjusted p-values
#'
#' @return list of ggplot objects
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' plot_logFC_thresholds_spiked(spike_in_se, spike_in_de_res,
#'                              condition = "Condition", ain = NULL,
#'                              comparisons = NULL, nrow = 2, alpha = 0.05)
#'
plot_logFC_thresholds_spiked <- function(se, de_res, condition, ain = NULL, comparisons = NULL, nrow = 2, alpha = 0.05){
  # check input
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  de_res <- de_res[de_res$Assay %in% ain,]
  de_res <- de_res[de_res$Comparison %in% comparisons,]

  # check condition
  condition <- get_condition_value(se, condition)

  # retrieve concentrations to calculate ground truth logFC per comparison
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  concentration <- S4Vectors::metadata(se)$spike_concentration
  condition <- S4Vectors::metadata(se)$condition
  concentrations <- unique(coldata[, c(condition, concentration), with=FALSE])
  comps <- data.table::data.table(Comparison = unique(de_res$Comparison))
  comps$SampleA <- sapply(strsplit(as.character(comps$Comparison),"-"), "[", 1)
  comps$SampleB <- sapply(strsplit(as.character(comps$Comparison),"-"), "[", 2)
  comps <- merge(comps, concentrations, by.x = "SampleA", by.y = condition)
  comps <- comps %>% dplyr::rename("ConcentrationA" = Concentration)
  comps <- merge(comps, concentrations, by.x = "SampleB", by.y = condition)
  comps <- comps %>% dplyr::rename("ConcentrationB" = Concentration)
  comps$Truth <- log2(comps$ConcentrationA / comps$ConcentrationB)

  step <- ifelse(round(max(comps$Truth)) < 0, -0.5, 0.5)
  logFCs <- seq(0, round(max(comps$Truth)), step)
  alpha <- 0.05

  stats <- NULL
  for(thr in logFCs){
    de_res$Change <- ifelse(de_res$adj.P.Val <= alpha & de_res$logFC >= thr , "Significant Change", "No Change")
    stats_chunk <- get_spiked_stats_DE(se, de_res)
    stats_chunk$logFCthr <- thr
    if(is.null(stats)){
      stats <- stats_chunk
    } else {
      stats <- rbind(stats, stats_chunk)
    }
  }

  # add ground truth
  stats <- merge(stats, comps[, c("Comparison", "Truth")])

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == "qual",]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  # plot
  p_tp <- ggplot2::ggplot(stats, ggplot2::aes(x = get("logFCthr"), y= get("TP"), color = get("Assay"))) +
    ggplot2::geom_line(lwd = 1) +
    ggplot2::facet_wrap(~Comparison, scales = "free_y", nrow = nrow) +
    ggplot2::labs(x = "Fold Change Threshold", y="Number of True Positives") +
    ggplot2::geom_vline(ggplot2::aes(xintercept = get("Truth")), linetype="dotted") +
    ggplot2::scale_x_continuous(breaks = seq(0, round(max(stats$Truth)))) +
    ggplot2::scale_color_manual(name = "Normalization Method", values = col_vector)

  p_fp <- ggplot2::ggplot(stats, ggplot2::aes(x = get("logFCthr"), y= get("FP"), color = get("Assay"))) +
    ggplot2::geom_line(lwd =1) +
    ggplot2::facet_wrap(~Comparison, scales = "free_y", nrow = nrow) +
    ggplot2::labs(x = "Fold Change Threshold", y="Number of False Positives") +
    ggplot2::scale_x_continuous(breaks = seq(0, round(max(stats$Truth)))) +
    ggplot2::scale_color_manual(name = "Normalization Method", values = col_vector)
  return(list("TP" = p_tp, "FP" = p_fp))
}


#' Plot ROC curve and barplot of AUC values for each method for a specific comparion or for all comparisons
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param de_res data table resulting of run_DE
#' @param ain Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)
#' @param comparisons Vector of comparisons (must be valid comparisons saved in stats)
#'
#' @return list of ggplot objects
#' @export
#'
#' @examples
#' data(spike_in_se)
#' data(spike_in_de_res)
#' plot_ROC_AUC_spiked(spike_in_se, spike_in_de_res)
#'
plot_ROC_AUC_spiked <- function(se, de_res, ain = NULL, comparisons = NULL){
  # check input
  tmp <- check_plot_DE_parameters(de_res, ain, comparisons)
  stats <- tmp[[1]]
  ain <- tmp[[2]]
  comparisons <- tmp[[3]]

  de_res <- de_res[de_res$Assay %in% ain,]
  de_res <- de_res[de_res$Comparison %in% comparisons,]

  # extract adjusted p-values from limma
  p.adj <- data.table::data.table("Protein.IDs" = de_res$Protein.IDs, "P.Adj" = de_res$adj.P.Val, "Assay" = de_res$Assay, "Comparison" = de_res$Comparison)
  # extract ground truth
  spike <- S4Vectors::metadata(se)$spike_column
  spike_val <- S4Vectors::metadata(se)$spike_value
  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  truth <- data.table::data.table(Protein.IDs = rowdata$Protein.IDs, spike = rowdata[[spike]])
  colnames(truth) <- c("Protein.IDs", spike)
  truth$Truth <- ifelse(truth[[spike]] == spike_val, 1, 0)

  dt <- merge(p.adj, truth, by ="Protein.IDs")
  dt <- dt[order(dt$P.Adj, decreasing = TRUE),]

  cuts <- 0
  round <- 3
  ymin <- 0
  ymax <- 1

  dt$P.Adj <- 1 - as.numeric(dt$P.Adj)

  # colors
  qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
  col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  col_vector <- rev(col_vector)

  roc <- ggplot2::ggplot(dt, ggplot2::aes(d=get("Truth"), m=get("P.Adj"), color = Assay)) +
    plotROC::geom_roc(n.cuts = cuts, labelround = round) +
    ggplot2::ylim(ymin, ymax) +
    ggplot2::xlab ("FPR") +
    ggplot2::ylab("TPR") +
    ggplot2::scale_color_manual(name = "Normalization", values =col_vector) +
    ggplot2::facet_wrap(~Comparison)

  auc_dt <- plotROC::calc_auc(roc)
  auc_bars <- ggplot2::ggplot(auc_dt, ggplot2::aes(x=get("Assay"), y=get("AUC"), fill=get("Assay"))) +
    ggplot2::geom_bar(stat = "identity") +
    ggplot2::facet_wrap(~Comparison) +
    ggplot2::scale_fill_manual(name = "Normalization", values = col_vector) +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust=0.5)) +
    ggplot2::labs(x = "Normalization")
  auc_box <- ggplot2::ggplot(auc_dt, ggplot2::aes(x = Assay, y=AUC, fill=Assay)) +
    ggplot2::geom_boxplot() +
    ggplot2::scale_fill_manual(name = "Normalization", values = col_vector) +
    ggplot2::labs(x = "Normalization")

  return(list("ROC" = roc, "AUC_bars" = auc_bars, "AUC_box" = auc_box,"AUC_dt" = auc_dt))
}

#' Plot number of identified spike-in proteins per sample.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param color_by String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)
#' @param label_by String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)#'
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' plot_identified_spiked_proteins(spike_in_se, color_by = NULL,
#'                                 label_by = NULL)
#'
plot_identified_spiked_proteins <- function(se, color_by = NULL, label_by = NULL){
  # check parameters
  color_by <- get_color_value(se, color_by)
  tmp <- get_label_value(se, label_by)
  show_sample_names <- tmp[[1]]
  label_by <- tmp[[2]]

  # extract data
  dt <- SummarizedExperiment::assays(se)$log2
  spike_column <- S4Vectors::metadata(se)$spike_column
  spike_val <- S4Vectors::metadata(se)$spike_value
  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))

  # Make Data Binary (NA --> 0, all other values --> 1)
  dt[is.na(dt)] <- 0
  dt[dt != 0] <- 1
  dt$Spiked <- rowdata[[spike_column]]

  # How Many spiked and BG Proteins per Sample
  stats <- dt %>% dplyr::group_by(Spiked) %>% dplyr::summarise(dplyr::across(everything(), sum))

  stats <- t(stats)
  colnames(stats) <- stats[1,]
  stats <- stats[2:nrow(stats),]
  column <- row.names(stats)
  stats <- data.table::as.data.table(stats)
  stats$Column <- column

  # Add coldata
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  stats <- merge(stats, coldata, by="Column")
  stats$Spiked <- as.numeric(stats[,spike_val])

  # Ordering
  if(!is.null(color_by)){
    stats <- stats[order(stats[[color_by]]),]

    # color vector
    qual_col_pals <- RColorBrewer::brewer.pal.info[RColorBrewer::brewer.pal.info$category == 'qual',]
    col_vector <- unlist(mapply(RColorBrewer::brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
    col_vector <- rev(col_vector)

    # Plot
    p <- ggplot2::ggplot(stats, ggplot2::aes(x=get("Label"), y=get("Spiked"), group = get(color_by), fill=get(color_by), label=get("Spiked"))) +
      ggplot2::geom_bar(stat = "identity", width=0.8, position=ggplot2::position_dodge(width=0.2)) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5, hjust=1)) +
      ggplot2::labs(x = "Samples", y=paste0("Number of Identified ", spike_val," Proteins")) +
      ggplot2::scale_fill_manual(name=color_by, values=col_vector) +
      ggplot2::geom_label(fill="white", show.legend = FALSE, color="black")

  } else {
    # Plot
    p <- ggplot2::ggplot(stats, ggplot2::aes(x=get("Label"), y=get("Spiked"), label=get("Spiked"))) +
      ggplot2::geom_bar(stat = "identity", width=0.8, position=ggplot2::position_dodge(width=0.2)) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5, hjust=1)) +
      ggplot2::labs(x = "Samples", y=paste0("Number of Identified ", spike_val," Proteins")) +
      ggplot2::geom_label(fill="white", show.legend = FALSE, color="black")
  }
  if(!show_sample_names){
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_blank())
  }
  return(p)
}

#' Plot histogram of the spike-in and background protein intensities per condition.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param condition column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' plot_histogram_spiked(spike_in_se, condition = NULL)
#'
plot_histogram_spiked <- function(se, condition = NULL){
  # get condition
  condition <- get_condition_value(se, condition)

  dt <- SummarizedExperiment::assays(se)$log2
  spike_column <- S4Vectors::metadata(se)$spike_column
  spike_val <- S4Vectors::metadata(se)$spike_value

  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))

  dt[[spike_column]] <- rowdata[[spike_column]]

  dt <- data.table::melt(dt, id.vars = spike_column, variable.name = "Column", value.name = "Intensity")
  dt <- merge(dt, coldata, by = "Column")

  types <- unique(dt[[spike_column]])
  levels <- c(spike_val, types[!types %in% spike_val])
  dt[[spike_column]] <- factor(dt[[spike_column]], levels = levels)


  colors <- c("red", "grey80")

  p <- ggplot2::ggplot(dt, ggplot2::aes(x=get("Intensity"), fill=get(spike_column))) +
    ggplot2::geom_histogram(bins = 50, position="identity", alpha=0.7) +
    ggplot2::facet_wrap(~get(condition)) +
    ggplot2::scale_fill_manual(name = spike_column, values = colors) +
    ggplot2::labs(x="log2 Intensity", y="Protein Number")
  return(p)
}

#' Plot profiles of the spike-in and background proteins using the log2 average protein intensities as a function of the different concentrations.
#'
#' @param se SummarizedExperiment containing all necessary information of the proteomics data set
#' @param xlab String for the x-label of the plot
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' data(spike_in_se)
#' plot_profiles_spiked(spike_in_se, xlab = "Concentration")
#'
plot_profiles_spiked <- function(se, xlab = "Concentration"){
  # prepare data
  dt <- SummarizedExperiment::assays(se)[["log2"]]
  spike_column <- S4Vectors::metadata(se)$spike_column
  spike_val <- S4Vectors::metadata(se)$spike_value
  spike_concentration <- S4Vectors::metadata(se)$spike_concentration

  rowdata <- data.table::as.data.table(SummarizedExperiment::rowData(se))
  coldata <- data.table::as.data.table(SummarizedExperiment::colData(se))
  samples <- colnames(dt)

  dt$Protein.IDs <- rowdata[,"Protein.IDs"]

  dt <- data.table::melt(data.table::as.data.table(dt), id.vars = "Protein.IDs", measure.vars = colnames(dt), variable.name = "Column", value.name = "Intensity")

  dt <- merge(dt, coldata, by = "Column")
  dt <- merge(dt, rowdata[, c("Protein.IDs", spike_column), with = FALSE], by = "Protein.IDs")
  bg_value <- unique(dt[[spike_column]])[unique(dt[[spike_column]]) != spike_val]


  col_vector <- c("red", "grey70")
  dt[[spike_column]] <- factor(dt[[spike_column]], levels = c(spike_val, bg_value))

  group <- c("Protein.IDs", spike_concentration, spike_column)
  dt$Intensity <- as.numeric(dt$Intensity)
  dt[[spike_concentration]] <- as.numeric(dt[[spike_concentration]])

  average <- dt %>% dplyr::group_by(dplyr::across(dplyr::all_of(group))) %>% dplyr::summarize(Mean = mean(Intensity, na.rm=TRUE)) %>% data.table::as.data.table()

  p <- ggplot2::ggplot(average, ggplot2::aes(x= get(spike_concentration), y = get("Mean"), group = get("Protein.IDs"), color = get(spike_column))) +
  ggplot2::geom_point() +
  ggplot2::geom_line(alpha = 0.7) +
  ggplot2::labs(x = xlab, y = "Log2 Average Intensity") +
  ggplot2::scale_x_continuous(breaks = unique(average[, spike_concentration])) +
  ggplot2::theme_bw() +
  ggplot2::scale_color_manual(name = spike_column, values = col_vector)  +
  ggplot2::facet_wrap(~get(spike_column), scales = "free_y")
  return(p)
}

---
title: "PRONE with Spike-In Data"
author: 
- name: Lis Arend
bibliography: references.bib
biblio-style: apalike
link-citation: yes
colorlinks: yes
output: 
  bookdown::html_document2:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{6. PRONE with Spike-In Data}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---


```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)
```

# Load PRONE Package

```{r setup, message = FALSE}
library(PRONE)
```

# Example Spike-in Data Set

PRONE also offers some additional functionalities for the evaluation of normalization techniques on spike-in data sets with a known ground truth. These functionalities will be delineated subsequently. Additionally, all functionalities detailed in the context of real-world data sets remain applicable to the SummarizedExperiment object associated with spike-in data sets.

The example spike-in data set is from [@cox_accurate_2014]. For the illustration of the package functionality, a smaller subset of the data consisting of 1500 proteins was used. For the complete data set, please refer to the original publication.

```{r}
data_path <- readPRONE_example("Ecoli_human_MaxLFQ_protein_intensities.csv")
md_path <- readPRONE_example("Ecoli_human_MaxLFQ_metadata.csv")

data <- read.csv(data_path)
md <- read.csv(md_path)
```

# Load Data

Before loading the data into a SummarizedExperiment object, it is important to check the organism of the protein groups. Proteins should be uniquely assigned to either the spike-in organism or the background organism. If some protein groups are mixed, they should be removed from the data since these can't be used for classification into true positives, false positives, etc.

In our example, we can extract the information from the "Fasta.headers" column:

```{r}
# Check if some protein groups are mixed
mixed <- grepl("Homo sapiens.*Escherichia|Escherichia.*Homo sapiens",data$Fasta.headers) 
data <- data[!mixed,]

table(mixed) 
```

In this case, all proteins were assigned either as a spike-in or background protein. Hence, a SummarizedExperiment container of the data can be created. However, before we need to add a column of the actual organism that can be used to calculate true positives, false positives, etc.

```{r}
data$Spiked <- rep("HUMAN", nrow(data))
data$Spiked[grepl("ECOLI", data$Fasta.headers)] <- "ECOLI"
```

In contrast to the real-world data sets, you need to specify the "spike_column", "spike_value", "spike_concentration", and utilize the `load_spike_data()` function for this purpose. 

Here, the "spike_column" denotes the column in the protein intensity data file encompassing information whether a proteins is classified as spike-in or background protein. The "spike_value" determines the value/identifier that is used to identify the spike-in proteins in the "spike_column", and the "spike_concentration" identifies the column containing the concentration values of the spike-in proteins (in this case the different conditions that will be tested in DE analysis).

```{r}
se <- load_spike_data(data, 
                      md, 
                      spike_column = "Spiked", 
                      spike_value = "ECOLI", 
                      spike_concentration = "Concentration",
                      protein_column = "Protein.IDs", 
                      gene_column = "Gene.names", 
                      ref_samples = NULL, 
                      batch_column = NULL, 
                      condition_column = "Condition", 
                      label_column = "Label")
```

# Overview of the Data

To get an overview on the number of identified (non-NA) spike-in proteins per sample, you can use the `plot_identified_spiked_proteins()` function.

```{r, fig.cap = "Overview of the number of identified spike-in proteins per sample, colored by condition. In this data set, the conditions were labeled with H and L. H indicates the sample group with high concentrations of spike-in proteins added to the background proteome, while L represents the sample group with low concentrations."}
plot_identified_spiked_proteins(se)
```

To compare the distributions of spike-in and human proteins in the different sample groups (here high-low), use the function `plot_histogram_spiked()`. Again, "condition = NULL" means that the condition specified by loading the data is used, but you can also specify any other column of the meta data.

```{r, fig.cap = "Histogram of the protein intensities of the spike-in proteins (ECOLI) and the background proteins (HUMAN) in the different conditions. This plot helps to compare the distributions of spike-in (red) and background proteins (grey) for the different spike-in levels."}
plot_histogram_spiked(se, condition = NULL)
```

If you want to have a look at the amount of actual measure spike-in, you can use the `plot_profiles_spiked()` function. Moreover, you can analyze whether the intensities of the background proteins, here HUMAN proteins, are constant across the different spike-in concentrations.

```{r, fig.cap = "Profiles of the spike-in proteins (ECOLI) and the background proteins (HUMAN) in the different conditions. This plot helps to analyze whether the intensities of the background proteins are constant across the different spike-in concentrations. Spike-in proteins (red) should increase in intensity with increasing spike-in concentrations, while background proteins (grey) should remain constant."}
plot_profiles_spiked(se, xlab = "Concentration")
```

# Preprocessing, Normalization, & Imputation

Given that the preprocessing (including filtering of proteins and samples), normalization, and imputation operations remain invariant for spike-in data sets compared to real-world data sets, the same methodologies can be employed across both types. In this context, normalization will only be demonstrated here as the performance of the methods will be evaluated in DE analysis, while detailed descriptions of the other functionalities are available in preceding sections. 

```{r}
se_norm <- normalize_se(se, c("Median", "Mean", "MAD", "LoessF"), 
                        combination_pattern = NULL)
```


# Differential Expression Analysis

Due to the known spike-in concentrations, the normalization methods can be evaluated based on their ability to detect DE proteins. The DE analysis can be conducted using the same methodology as for real-world data sets. However, other visualization options are available and performance metrics can be calculated for spike-in data sets.

## Run DE Analysis

First, you need to specify the comparisons you want to perform in DE analysis. For this, a special function was developed which helps to build the right comparison strings.

```{r}
comparisons <- specify_comparisons(se_norm, condition = "Condition", 
                                   sep = NULL, control = NULL)
```

Then you can run DE analysis:

```{r}
de_res <- run_DE(se = se_norm, 
                     comparisons = comparisons,
                     ain = NULL, 
                     condition = NULL, 
                     DE_method = "limma", 
                     covariate = NULL, 
                     logFC = TRUE, 
                     logFC_up = 1, 
                     logFC_down = -1, 
                     p_adj = TRUE, 
                     alpha = 0.05, 
                     B = 100, 
                     K = 500)
```

## Evaluate DE Results with Performance Metrics

Before being able to visualize the DE results, you need to run `get_spiked_stats_DE()` to calculate multiple performance metrics, such as the number of true positives, number fo false positives, etc.

```{r}
stats <- get_spiked_stats_DE(se_norm, de_res)

# Show tp, fp, fn, tn, with F1 score
knitr::kable(stats[,c("Assay", "Comparison", "TP", "FP", "FN", "TN", "F1Score")], caption = "Performance metrics for the different normalization methods and pairwise comparisons.", digits = 2)
```

You have different options to visualize the amount of true and false positives for the different normalization techniques and pairwise comparisons. For all these functions, you can specify a subset of normalization methods and comparisons. If you do not specify anything, all normalization methods and comparisons of the "stats" data frame are used.

The `plot_TP_FP_spiked_bar()` function generates a barplot showing the number of false positives and true positives for each normalization method and is facetted by pairwise comparison.


```{r, fig.cap = "Barplot showing the number of false positives (FP) and true positives (TP) for each normalization method and is facetted by pairwise comparison. This plot shows the impact of normalization on DE results."}
plot_TP_FP_spiked_bar(stats, ain = c("Median", "Mean", "MAD", "LoessF"), 
                      comparisons = NULL)
```

If many pairwise comparisons were performed, the `plot_TP_FP_spiked_box()` function can be used to visualize the distribution of true and false positives for all pairwise comparisons in a boxplot. 

Given that the data set encompasses merely two distinct spike-in concentrations and therefore only one pairwise comparison has been conducted in DE analysis, a barplot would be more appropriate. Nonetheless, for demonstration purposes, a boxplot will be used here.

```{r, fig.cap = "Boxplot showing the distribution of true positives (TP) and false positives (FP) for each normalization method across all pairwise comparisons. This plot helps to visualize the distribution of TP and FP for each normalization method. Since in this dataset, only two conditions are available, hence a single pairwise comparison, this plot is not very informative."}
plot_TP_FP_spiked_box(stats, ain = c("Median", "Mean", "MAD", "LoessF"), 
                      comparisons = NULL)
```

Furthermore, similarly the `plot_TP_FP_spiked_scatter()` function can be used to visualize the true and false positives in a scatter plot. Here, a scatterplot of the median true positives and false positives is calculated across all comparisons and displayed for each normalization method with errorbars showing the Q1 and Q3. Here again, this plot is more suitable for data sets with multiple pairwise comparisons.

```{r, fig.cap = "Scatter plot showing the median true positives (TP) and false positives (FP) for each normalization method across all pairwise comparisons."}
plot_TP_FP_spiked_scatter(stats, ain = NULL, comparisons = NULL)
```

Furthermore, other performance metrics that the number of true positives and false positives can be visualized using the `plot_stats_spiked_heatmap()` function. Here, currently, the sensitivity, specificity, precision, FPR, F1 score, and accuracy can be visualized for the different normalization methods and pairwise comparisons.

```{r, fig.cap = "Heatmap showing a selection of performance metrics for the different normalization methods and pairwise comparisons."}
plot_stats_spiked_heatmap(stats, ain = c("Median", "Mean", "MAD"), 
                          metrics = c("Precision", "F1Score"))
```

Finally, receiver operating characteristic (ROC) curves and AUC values can be calculated and visualized using the `plot_ROC_AUC_spiked()` function. This function returns a plot showing the ROC curves, a bar plot with the AUC values for each comparison, and a boxplot with the distributions of AUC values across all comparisons.

```{r, fig.cap = "ROC curves and AUC barplots and boxplots for the different normalization methods and pairwise comparisons. AUC barplots are shown for each pairwise comparison, while the boxplot shows the distribution of AUC values across all comparisons."}
plot_ROC_AUC_spiked(se_norm, de_res, ain = c("Median", "Mean", "LoessF"), 
                    comparisons = NULL)
```

## Log Fold Change Distributions

Furthermore, you can visualize the distribution of log fold changes for the different conditions using the `plot_fold_changes_spiked()` function. The fold changes of the background proteins should be centered around zero, while the spike-in proteins should be centered around the actual log fold change calculated based on the spike-in concentrations.

```{r, fig.cap = "Boxplot showing the distribution of log fold changes for the different normalization methods and pairwise comparisons. The dotted blue line is at y = 0 because logFC values of the background proteins should be centered around 0, while the dotted red line shows the expected logFC value based on the spike-in concentrations of both sample groups."}
plot_fold_changes_spiked(se_norm, de_res, condition = "Condition", 
                         ain = c("Median", "Mean", "MAD"), comparisons = NULL)
```


## P-Value Distributions

Similarly, the distributions of the p-values can be visualized using the `plot_pvalues_spiked()` function.

```{r, fig.cap = "Boxplot showing the distribution of p-values for the different normalization methods and pairwise comparisons."}
plot_pvalues_spiked(se_norm, de_res, ain = c("Median", "Mean", "MAD"), 
                    comparisons = NULL)
```

## Log Fold Change Thresholds

Due to the high amount of false positives encountered in spike-in data sets, we provided a function to test for different log fold change thresholds to try to reduce the amount of false positives. The function `plot_logFC_thresholds_spiked()` can be used to visualize the number of true positives and false positives for different log fold change thresholds.

```{r}
plots <- plot_logFC_thresholds_spiked(se_norm, de_res, condition = NULL, 
                                      ain = c("Median", "Mean", "MAD"), 
                                      nrow = 1, alpha = 0.05)
```

```{r, fig.cap = "Barplot showing the number of true positives for each normalization method and pairwise comparison for different log fold change thresholds. This plot helps to analyze the impact of different log fold change thresholds on the number of true positives. The dotted line in the plot shows the expected logFC value based on the spike-in concentrations of both sample groups."}
plots[[1]]
```

```{r, fig.cap = "Barplot showing the number of false positives for each normalization method and pairwise comparison for different log fold change thresholds. This plot helps to analyze the impact of different log fold change thresholds on the number of false positives. The dotted line in the plot shows the expected logFC value based on the spike-in concentrations of both sample groups."}
plots[[2]]
```

# Session Info

```{r}
utils::sessionInfo()
```

# References

---
title: "Getting started with PRONE"
author: 
- name: Lis Arend
bibliography: references.bib
biblio-style: apalike
link-citation: yes
colorlinks: yes
output: 
  bookdown::html_document2:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{1. Getting started with PRONE}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)
```

# Introduction

High-throughput omics data are often affected by systematic biases
introduced throughout all the steps of a clinical study, from sample
collection to quantification. Failure to account for these biases can
lead to erroneous results and misleading conclusions in downstream
analysis. Normalization methods aim to adjust for these biases to make
the actual biological signal more prominent. However, selecting an
appropriate normalization method is challenging due to the wide range of
available approaches. Therefore, a comparative evaluation of
unnormalized and normalized data is essential in identifying an
appropriate normalization strategy for a specific data set. This R
package provides different functions for preprocessing, normalizing, and
evaluating different normalization approaches. Furthermore,
normalization methods can be evaluated on downstream steps, such as
differential expression analysis and statistical enrichment analysis.
Spike-in data sets with known ground truth and real-world data sets of
biological experiments acquired by either tandem mass tag (TMT) or
label-free quantification (LFQ) can be analyzed.

# Installation

```{r loading, eval = FALSE}
# Official BioC installation instructions
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("PRONE")
```

```{r, message = FALSE}
# Load and attach PRONE
library(PRONE)
```

# Workflow

A six-step workflow was developed in R version 4.2.2 to evaluate the
effectiveness of the previously defined normalization methods on
proteomics data. The workflow incorporates a set of novel functions and
also integrates various methods adopted by state-of-the-art tools.

```{r, echo=FALSE, fig.cap="Six-step workflow of PRONE.", out.width="700px"}
knitr::include_graphics("../man/figures/Workflow_PRONE.png")
```

Following the upload of the proteomics data into a SummarizedExperiment
object, proteins with too many missing values can be removed, outlier
samples identified, and normalization carried out. Furthermore, an
exploratory analysis of the performance of normalization methods can be
conducted. Finally, differential expression analysis can be executed to
further evaluate the effectiveness of normalization methods. For data
sets with known ground truth, such as spike-in and simulated data sets,
performance metrics, such as true positives (TPs), false positives
(FPs), and area under the curve (AUC) values, can be computed. The
evaluation of DE results of real-world experiments is based on visual
quality inspection, for instance, using volcano plots, and an
intersection analysis of the DE proteins of different normalization
methods is available.

# Usage

This guide serves as an introduction to the PRONE R package, designed to facilitate the preparation of your data set for utilization of the PRONE package's functionalities. It begins by delineating the underlying data structure essential for the application of the package, followed by a brief description of how to apply different normalization techniques to your data. Additionally, this tutorial shows how to export the normalized data at the end.

Beyond the scope of this introductory tutorial, PRONE encompassess a broad spectrum of functionalities, ranging from preprocessing steps, imputation, normalization and evaluation of the performance of different normalization techniques, to the identification of differentially expressed proteins. These functionalities are detailed in dedicated vignettes, offering detailed insights and instructions for leveraging full capabilities of the PRONE package:

* [Preprocessing Tutorial](Preprocessing.html)
* [Imputation Tutorial](Imputation.html)
* [Normalization Tutorial](Normalization.html)
* [Differential Expression Tutorial](Differential_Expression.html)

Furthermore, PRONE provides additional functionalities for the analysis of spike-in data sets, which are detailed in the following vignette:

* [Spike-In Tutorial](Spike_In_Data.html)

# Load Data

PRONE uses the [SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html) class as storage for protein intensities and meta data information on the proteomics data set. Hence, before being able to execute the functionalities of PRONE, the data needs to be saved accordingly. For this, the `load_data()` function was implemented and requires different parameters which are explained in the following: 

* __data__: refers to the data.frame containing the protein intensities
* __md__: refers to the data.frame containing the meta-data information
* __protein_column__: refers to the column in the data frame that contains the protein IDs
* __gene_column__ (optional): refers to the column in the data frame that contains the gene IDs
* __condition_column__ (optional): refers to the column in the meta-data table that contains the condition information - this can also be specified later
* __label_column__ (optional): refers to the column in the meta-data table that contains sample label information - sometimes the sample names are very long and this column gives the option to label the samples with shorter names for visualization purposes

If you have a tandem mass tag (TMT) data set with samples being measured in different batches than you have to specify the batch information. If reference samples were included in each batch, then additionally specify the samples names of the reference samples.

* __batch_column__ (optional): refers to the column in the meta-data table that contains the batch information
* __ref_samples__ (optional): refers to the samples that should be used as reference samples for normalization

<b>Attention:</b> You need to make sure that the sample names are saved in a column named "Column" in the meta-data table and are named accordingly in the protein intensity table.

## Example 1: TMT Data Set

The example TMT data set originates from [@biadglegne_mycobacterium_2022].

```{r load_real_tmt}
data_path <- readPRONE_example("tuberculosis_protein_intensities.csv")
md_path <- readPRONE_example("tuberculosis_metadata.csv")

data <- read.csv(data_path)
md <- read.csv(md_path)

md$Column <- stringr::str_replace_all(md$Column, " ", ".")

ref_samples <- md[md$Group == "ref",]$Column

se <- load_data(data, md, protein_column = "Protein.IDs", 
                gene_column = "Gene.names", ref_samples = ref_samples, 
                batch_column = "Pool", condition_column = "Group", 
                label_column = "Label")

```

## Example 2: Label-free (LFQ) Data Set

The example data set originates from [@vehmas_liver_2016]. This data set is used for the subsequent examples in this tutorial.

```{r load_real_lfq}
data_path <- readPRONE_example("mouse_liver_cytochrome_P450_protein_intensities.csv")
md_path <- readPRONE_example("mouse_liver_cytochrome_P450_metadata.csv")

data <- read.csv(data_path, check.names = FALSE)
md <- read.csv(md_path)

se <- load_data(data, md, protein_column = "Accession", 
                gene_column = "Gene names", ref_samples = NULL, 
                batch_column = NULL, condition_column = "Condition", 
                label_column = NULL)
```

# Data Structure

The SummarizedExperiment object contains the protein intensities as "assay", the meta-data table as "colData", and additional columns for instance resulting from MaxQuant as "rowData". Furthermore, information on the different columns, for instance, which columns contains the batch information, can be found in the "metadata" slot.

```{r}
se
```

The different data types can be accessed by using the `assays()` function. Currently, only the raw data and log2-transformed data are stored in the SummarizedExperiment object.

```{r}
assays(se)
```

# Preprocessing, Imputation, Normalization, Evaluation, and Differential Expression

As already mentioned in the introduction section, many functionalities are available in PRONE. All these functionalities are mainly based on the SummarizedExperiment object.

In this tutorial, we will only perform simple normalization of the data using median and LoessF normalization. 

```{r}
se <- normalize_se(se, c("Median", "LoessF"))
```

The normalized intensities will be saved as additional assays in the SummarizedExperiment object.

```{r}
assays(se)
```

Again, more information on the individual processes can be find in dedicated vignettes.

# Download Data

Finally, you can easily download the normalized data by using the `export_data()` function. This function will save the specified assays as CSV files and the SummarizedExperiment object as an RDS file in a specified output directory. Make sure that the output directory exists.

```{r, eval = FALSE}
if(!dir.exists("output/")) dir.create("output/")

export_data(se, out_dir = "output/", ain = c("log2", "Median", "LoessF"))
```

# Session Info

```{r}
utils::sessionInfo()
```

# References

---
title: "Differential Expression Analysis"
author: 
- name: Lis Arend
bibliography: references.bib
biblio-style: apalike
link-citation: yes
colorlinks: yes
output: 
  bookdown::html_document2:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{5. Differential Expression Analysis}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---


```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)
```

# Load PRONE Package

```{r setup, message = FALSE}
library(PRONE)
```

# Load Data (TMT)

Here, we are directly working with the [SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html) data. For more information on how to create the SummarizedExperiment from a proteomics data set, please refer to the ["Get Started"](PRONE.html) vignette.

The example TMT data set originates from [@biadglegne_mycobacterium_2022].

```{r load_real_tmt}
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se
```

# Normalize Data

In order to compare the performance of different normalization methods on their ability to detect differentially expressed proteins, we performed some normalization with batch effect correction technqiues here. For more details about how to normalize data and evaluate the normalization approaches quantitatively and qualitatively using PRONE, please refer to the ["Normalization"](Normalization.html) vignette.

```{r}
se_norm <- normalize_se(se, c("IRS_on_RobNorm", "IRS_on_Median", 
                              "IRS_on_LoessF", "IRS_on_Quantile"), 
                        combination_pattern = "_on_")
```

# Differential Expression Analysis

After having performed normalization and evaluated the different normalization methods via qualitative and quantitative analysis, differential expression analysis can be used to further analyze the differences of the normalization methods and assess the impact of normalization on downstream analyses.

However before, you need to remove the reference samples in case of a TMT experiment. This can be easily done with the function `remove_reference_samples()`.

```{r}
se_norm <- remove_reference_samples(se_norm)
```

## Run DE Analysis

### Specific Comparisons

First, you need to specify the comparisons you want to perform in DE analysis. For this, the function `specify_comparisons()` was developed which helps to build the right comparison strings. 

However, you can also just simply create a vector of comparisons to ensure the correct order and handle this vector over to the DE analysis method.

```{r}
comparisons <- specify_comparisons(se_norm, condition = "Group", 
                                   sep = NULL, control = NULL)

comparisons <- c("PTB-HC", "TBL-HC", "TBL-PTB", "Rx-PTB")
```

The function `specify_comparisons()` becomes handy when having a lot of sample groups and foremost samples of multiple conditions (not the case for this dataset). 

For instance, you have a data set with diabetic and healthy samples (condition) that were measured at day 3 (3d), day 7 (7d), and day 17 (d14) after operation (timepoints. In DE analysis, you want to perform comparisons between the diabetic and healthy samples at each time point but also between the different time points for a fixed condition (e.g. diabetic). Instead of writing all comparisons manually, the function helps to build the right comparison strings by only considering comparisons where at least one of the groups (timepoint or condition) remains static. For this you only need to have a column in your metadata named for instance "Condition" that combines the two groups by "_", with values diabetic_3d, diabetic_7d, diabetic_14d, etc. And in the function you specify the column name "Condition" and the separator (sep = "_").

To ensure clarity, a comparison in the form of Condition-Reference, where the logFC is positive, signifies that the protein intensity is greater in the Condition compared to the Reference.

### Perform DE Analysis

The function `run_DE()` performs the DE analysis on the selected SummarizedExperiment and comparisons. A novel feature of PRONE is to compare the DE results of different normalization methods as it has been shown that normalization has an impact on downstream analyses. 

Therefore, DE analysis can be performed on multiple assays (normalization methods) at once using the already known "ain" parameter.

In the following, a more detailed explanation of the other parameters is given:

* The condition of the SummarizedExperiment object, specified at the beginning, can be used (condition = NULL) or any other column of the meta data can specified. 
* Three methods are available for DE analysis: limma [@ritchie_limma_2015], DEqMS [@zhu_deqms:_2020], and ROTS [@suomi_rots:_2017]. 
* The logFC parameter specifies if the log2 fold change should be calculated.
* The logFC_up and logFC_down parameters specify the log2 fold change thresholds for up- and down-regulated proteins.
* The p_adj parameter specifies if the p-values should be adjusted.
* The alpha parameter specifies the significance level for the p-values.

In addition, the following parameters are specific for the DE analysis methods:

* Limma (DOI: 10.18129/B9.bioc.limma):
  * The covariate parameter can be used to include a covariate in the DE analysis in case limma is performed. This can be any column of the meta data.
  * The trend parameter specifies if the trend test should be performed in case limma is used.
  * The robust parameter specifies if the robust method should be used in case limma is used.
  
* ROTS (DOI: 10.18129/B9.bioc.ROTS): 
  * B is the number of bootstrapping and K is the number of top-ranked features for reproducibility optimization.
* DEqMS (DOI: 10.18129/B9.bioc.DEqMS)
  * The DEqMS_PSMs_column need to be specified. This can be any column in the `rowData(se)` that represents the number of quantified peptides or PSMs. It is used in DEqMS to estimate prior variance for proteins quantified by different number of PSMs. 

```{r}
de_res <- run_DE(se = se_norm, 
                     comparisons = comparisons,
                     ain = NULL, 
                     condition = NULL, 
                     DE_method = "limma", 
                     logFC = TRUE, 
                     logFC_up = 1, 
                     logFC_down = -1, 
                     p_adj = TRUE, 
                     alpha = 0.05,
                     covariate = NULL, 
                     trend = TRUE,
                     robust = TRUE,
                     B = 100,
                     K = 500
                 ) 
```

If you want to apply other logFC or p-value threshold, there is no need to re-run the DE analysis again. With `apply_thresholds()`, you can simply change the threshold values.

For instance, if you want to not apply a logFC threshold and only consider proteins with an adjusted p-value of 0.05 as DE, just set the logFC parameter to FALSE. In this case, the proteins are not classified into up- and down-regulated but only as significant change or no change.

```{r}
new_de_res <- apply_thresholds(de_res = de_res, logFC = FALSE, p_adj = TRUE, 
                               alpha = 0.05)
```

However, if you still want to see if a protein has a positive or negative logFC, you can set the logFC parameter to TRUE with the logFC_up and logFC_down parameters to 0.
 
```{r}
new_de_res <- apply_thresholds(de_res = de_res, logFC = TRUE, 
                               logFC_up = 0, logFC_down = 0, 
                               p_adj = TRUE, alpha = 0.05)
```


## Visualize DE Results

### Barplot
To get an overview of the DE results of the different normalization methods, you can visualize the number of significant DE proteins per normalization method in a barplot using `plot_overview_DE_bar()`. This plot can be generated in different ways by specifying the "plot_type" parameter:

* single: plot a single barplot for each comparison (default)
* facet_comp: facet the barplot by comparison
* stacked: stack the number of DE per comparison
* facet_regulation: stack the number of DE per comparison but facet by up- and down-regulated

```{r, fig.cap = "Barplot showing the number of DE proteins per normalization method colored by comparison and facetted by up- and down-regulation."}
plot_overview_DE_bar(de_res, ain = NULL, comparisons = comparisons, 
                     plot_type = "facet_regulation")
```

You can also just visualize two specific comparisons:

```{r, fig.cap = "Barplot showing the number of DE proteins per normalization method faceted by comparison."}
plot_overview_DE_bar(de_res, ain = NULL, comparisons = comparisons[seq_len(2)], 
                     plot_type = "facet_comp")
```


#### Tile Plot

You can also get an overview of the DE results in form of a heatmap using the `plot_overview_DE_tile()`.

```{r, fig.cap = "Heatmap showing the number of DE proteins per comparison and per normalization method."}
plot_overview_DE_tile(de_res)
```

#### Volcano Plots

Another option is to generate volcano plots for each comparison. The function `plot_volcano_DE()` generates a grid of volcano plots for each normalization techniques (facet_norm = TRUE) or for each comparison (facet_comparison = TRUE). A list of volcano plots is returned.

```{r, fig.cap = "Volcano plots per normalization method for a single comparison."}
plot_volcano_DE(de_res, ain = NULL, comparisons = comparisons[1], 
                facet_norm = TRUE)
```

#### Heatmap of DE Results

Furthermore, you can visualize the DE results in form of a heatmap. The function `plot_heatmap_DE()` generates a heatmap of the DE results for a specific comparison and normalization method.

```{r, fig.cap = "Individual heatmap of the DE results for a specific comparison and a selection of normalization methods. The adjusted p-values are added as row annotation, while the condition of each sample is shown as column annotation."}
plot_heatmap_DE(se_norm, de_res, ain = c("RobNorm", "IRS_on_RobNorm"), 
                comparison = "PTB-HC", condition = NULL, label_by = NULL, 
                pvalue_column = "adj.P.Val")
```

### Intersection Analysis of DE Results

Moreover, you can also intersect the DE results of different normalization methods to see how many DE proteins overlap. You can either plot for each requested comparison an individual upset plot (plot_type = "single") or stack the number of overlapping DE proteins per comparison ("stacked"). Not only the upset plot(s) are returned, but also a table with the intersections is provided by the `plot_upset_DE()`function.

```{r, fig.cap = "Upset plot showing the overlapping DE proteins of different normalization methods colored by comparison.", fig.height = 12}
intersections <- plot_upset_DE(de_res, ain = NULL, 
                               comparisons = comparisons[seq_len(3)], 
                               min_degree = 6, plot_type = "stacked")
if(!is.null(intersections)){
  # put legend on top due to very long comparisons
intersections$upset[[2]] <- intersections$upset[[2]] + 
  ggplot2::theme(legend.position = "top", legend.direction = "vertical")
intersections$upset
}
```

Additionally, the Jaccard similarity index can be calculated to quantify the similarity of the DE results between the different normalization methods. A individual heatmap can be generated for each comparison ("plot_type = single"), a single heatmap facetted by comparison ("facet_comp") or a single heatmap taking all comparisons into account ("all") can be generated.

```{r, fig.cap = "Heatmap showing the Jaccard similarity indices of the DE results between different normalization methods for all comparisons."}
plot_jaccard_heatmap(de_res, ain = NULL, comparisons = comparisons, 
                     plot_type = "all")
```

PRONE offers the functionality to extract a consensus set of DEPs based on a selection of normalization methods and a threshold for the number of methods that need to agree on the DE status of a protein. The function `get_consensus_DE()` returns a list of consensus DE proteins for either each comparison separately or for all comparisons combined.

```{r}
DT::datatable(extract_consensus_DE_candidates(de_res, ain = NULL, 
                                              comparisons = comparisons, 
                                              norm_thr = 0.8, 
                                              per_comparison = TRUE), 
              options = list(scrollX = TRUE))
```

# Functional enrichment analysis

Finally, to biologically interpret the DE results of the different normalization methods, PRONE offers the ability to perform functional enrichment on the different sets of DE proteins originating from different normalization methods. The function `plot_intersection_enrichment()` can be used to visualize the functional enrichment results of the DE proteins of different normalization methods. This function returns two types of plot: a heatmap of enriched terms visualizing whether a term in enriched in the DE set of a specific normalization method and a heatmap showing Jaccard similarity coefficients to quantify the similarity of the enriched terms between the different normalization methods.

For this analysis, the `gprofiler2` package is used to perform the functional enrichment analysis. The following parameters are required:

* se: SummarizedExperiment object
* de_res: DE results
* comparison: Specific comparison
* ain: Vector of normalization methods to perform functional enrichment
* id_column: Column name of the rowData of the SummarizedExperiment object which includes the gene names. If MaxQuant data is provided with multiple gene names per protein group, the entries in the id_column are split by ";".
* organism: Organism name (gprofiler parameter, example: hsapiens, mmusculus)
* source: Data source to use (gprofiler parameter, example: KEGG, GO:BP, GO:MF, GO:CC, REAC, HP, ...)

```{r}
enrich_results <- plot_intersection_enrichment(se, de_res, comparison = "PTB-HC", 
                             ain = c("IRS_on_Median", "IRS_on_RobNorm", "RobNorm"), 
                             id_column = "Gene.Names", organism = "hsapiens", 
                             source = "KEGG", signif_thr = 0.05)
```

```{r, fig.cap = "Heatmap showing enriched terms of the DE sets between different normalization methods for a specific comparison."}
enrich_results$enrichment_term_plot

```

```{r, fig.cap = "Heatmap showing the Jaccard similarity indices of the enriched terms between different normalization methods for a specific comparison."}
enrich_results$jaccard_intersection_plot
```

# Session Info

```{r}
utils::sessionInfo()
```

# References

---
title: "Preprocessing"
author: 
- name: Lis Arend
bibliography: references.bib
biblio-style: apalike
link-citation: yes
colorlinks: yes
output: 
  bookdown::html_document2:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{2. Preprocessing}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)
```

# Load PRONE Package

```{r, message = FALSE}
# Load and attach PRONE
library(PRONE)
```

# Load Data (TMT)

Here, we are directly working with the [SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html) data. For more information on how to create the SummarizedExperiment from a proteomics data set, please refer to the ["Get Started"](PRONE.html) vignette.

The example TMT data set originates from [@biadglegne_mycobacterium_2022].

```{r load_real_tmt}
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se
```

This SummarizedExperiment object already includes data of different normalization methods. Since this vignette should show you how to use the PRONE workflow for novel proteomics data, we will remove the normalized data and only keep the raw and log2 data that are available after loading the data accordingly. 

```{r, eval = TRUE, include = TRUE}
se <- subset_SE_by_norm(se, ain = c("raw", "log2"))
```

# Overview of the Data

To get an overview on the number of NAs, you can simply use the function `get_NA_overview()`:

```{r overview_NA_table}
knitr::kable(get_NA_overview(se, ain = "log2"))
```

To get an overview on the number of samples per sample group or batch, you can simply use the function `plot_condition_overview()` by specifying the column of the meta-data that should be used for coloring. By default (condition = NULL), the column specified in `load_data()` will be used.

```{r, fig.cap = "Overview barplot of the number of samples per condition."}
plot_condition_overview(se, condition = NULL)
```


```{r, fig.cap = "Overview barplot of the number of samples per pool."}
plot_condition_overview(se, condition = "Pool")
```

A general overview of the protein intensities across the different samples is provided by the function `plot_heatmap()`. The parameter "ain" specifies the data to plot, currently only "raw" and "log2" is available (names(assays(se)). Later if multiple normalization methods are executed, these will be saved as assays, and the normalized data can be visualized.

```{r, fig.cap = "Heatmap of the log2-protein intensities with columns and proteins being clustered with hclust."}
available_ains <- names(assays(se))

plot_heatmap(se, ain = "log2", color_by = c("Pool", "Group"), 
             label_by = NULL, only_refs = FALSE)
```

Similarly, an upset plot can be generated to visualize the overlaps between sets defined by a specific column in the metadata. The sets are generated by using non-NA values. 

```{r, fig.cap = "Upset plot of the non-NA protein intensities with sets defined by the Pool column.", fig.width = 8, fig.height = 8}
plot_upset(se, color_by = NULL, label_by = NULL, mb.ratio = c(0.7,0.3), 
           only_refs = FALSE)
```

If you are interested in the intensities of specific biomarkers, you can use the `plot_markers_boxplots()` function to compare the distribution of intensities per group. The plot can be generated per marker and facet by normalization method (facet_norm = TRUE) or by normalization method and facet by marker (facet_marker = TRUE).

```{r, fig.cap = "Boxplot of the log2-protein intensities of the markers Q92954;J3KP74;E9PLR3, Q9Y6Z7, and Q68CQ4. If specific biomarkers are known to be upregulated in some conditions, you can use this plot to get an impression of the intensities before doing differential expression analysis."}
p <- plot_markers_boxplots(se, 
                           markers = c("Q92954;J3KP74;E9PLR3", "Q9Y6Z7"), 
                           ain = "log2", 
                           id_column = "Protein.IDs", 
                           facet_norm = FALSE, 
                           facet_marker = TRUE)
p[[1]] + ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5))
```


# Filter Proteins 

## Remove Proteins With Missing Values in ALL Samples

```{r}
se <- filter_out_complete_NA_proteins(se)
```

## Remove Proteins With a Specific Value in a Specific Column

Typically proteins with "+" in the columns "Reverse", "Only.identified.by.site", and "Potential.contaminant" are removed in case of a MaxQuant proteinGroups.txt output file.

```{r}
se <- filter_out_proteins_by_value(se, "Reverse", "+")
se <- filter_out_proteins_by_value(se, "Only.identified.by.site", "+")
#se <- filter_out_proteins_by_value(se, "Potential.contaminant", "+")
```

## Remove Proteins by ID

If you don't want to remove for instance all proteins with "Potential.contaminant == +", you can also first get the protein ID with the specific value, check them in Uniprot, and then remove only some by using the function `filter_out_proteins_by_ID()`.

```{r} 
pot_contaminants <- get_proteins_by_value(se, "Potential.contaminant", "+")
se <- filter_out_proteins_by_ID(se, pot_contaminants)
```

## Explore Missing Value Pattern

Due to the high amount of missing values in MS-based proteomics data, it is important to explore the missing value pattern in the data. The function `plot_NA_heatmap()` provides a heatmap of the proteins with at least one missing value across all samples. 

```{r, fig.cap = "Heatmap of the missing value pattern. Proteins with at least one missing value are included in this heatmap."}
plot_NA_heatmap(se, color_by = NULL, label_by = NULL, cluster_samples = TRUE, 
                cluster_proteins = TRUE)
```

Another way to explore the missing value pattern is to use the functions `plot_NA_density()` and `plot_NA_frequency()`. 

```{r, fig.cap = "Density plot of protein intensities of proteins with missing values and proteins without missing values. This can help to check whether the missing values are biased to lower intense proteins. In this case, the missing values are biased towards the lower intense proteins."}
plot_NA_density(se)
```

```{r, fig.cap = "Protein identification overlap. This plot shows the number of identified proteins (y-axis) per number of samples (x-axis)."}
plot_NA_frequency(se)
```

## Filter Proteins By Applying a Missing Value Threshold

To reduce the amount of missing values, it is possible to filter proteins by applying a missing value threshold. The function `filter_out_NA_proteins_by_threshold()` removes proteins with more missing values than the specified threshold. The threshold is a value between 0 and 1, where 0.7, for instance, means that proteins with less than 70% of real values will be removed, i.e., proteins with more than 30% missing values will be removed.

```{r, fig.cap = "Heatmap of the missing value pattern after filtering proteins with too many missing values (threshold was set to 70%). Proteins with at least one missing value are included in this heatmap."}
se <- filter_out_NA_proteins_by_threshold(se, thr = 0.7) 

plot_NA_heatmap(se)
```

# Filter Samples

Following filtering proteins by different criteria, samples can be analyzed more in detail. PRONE provides some functions, such as `plot_nr_prot_samples()` and `plot_tot_int_samples()`, to get an overview of the number of proteins and the total intensity per sample, but also offers the automatic outlier detection method of POMA.

## Quality Control

```{r, fig.cap = "Barplot on the number of non-zero proteins per samples colored by condition. This plot helps as quality control to check whether the number of proteins is similar across samples. In this case, only very few proteins have been detected for sample 1.HC_Pool1 compared to the other samples."}
plot_nr_prot_samples(se, color_by = NULL, label_by = NULL)
```

```{r, fig.cap = "Barplot on the total protein intensity per samples colored by condition. This plot helps as quality control to check whether the total protein intensity is similar across samples. In this case, the total protein intensities of samples 1.HC_Pool1 and 1.HC_Pool2 are much lower compared to the other samples."}
plot_tot_int_samples(se, color_by = NULL, label_by = NULL)
```

## Remove Samples Manually

Based on these plots, samples "1.HC_Pool1" and 1_HC_Pool2 seem to be outliers. You can easily remove samples manually by using the `remove_samples_manually()` function.

```{r}
se <- remove_samples_manually(se, "Label", c("1.HC_Pool1", "1.HC_Pool2"))
```

## Remove Reference Samples

And you can remove the reference samples directly using the function `remove_reference_samples()`. But attention: possibly you need them for normalization! That is exactly why we currently keep them!

```{r}
se_no_refs <- remove_reference_samples(se)
```


## Outlier Detection via POMA R Package

The POMA R package provides a method to detect outliers in proteomics data. The function `detect_outliers_POMA()` detects outliers in the data based on the POMA algorithm. The method calculates the euclidean distances (or maximum or manhattan distances) between all sample pairs and then group centroids are computed either as the average distance of group members or the spatial median. The distances of the group members to the corresponding group centroid are then calculated to apply the classical univariate outlier detection formula Q3 + 1.5 * IQR (1.5 is adjustable) to detect group-dependent outliers.
 
The function returns a list with the following elements: polygon plot, distance boxplot, and the outliers. For further information on the POMA algorithm, please refer to the original publication [@castellano-escuder_pomashiny:_2021]: 

```{r}
poma_res <- detect_outliers_POMA(se, ain = "log2")
```

```{r, fig.cap = "Polygon plot of the principal coordinates calculated using the POMA algorithm. The original distances are reduced to principal coordinates (see POMA and the vegan::betadisper method)."}
poma_res$polygon_plot
```

```{r, fig.cap = "Boxplot of the distances of the samples to the group centroid calculated using POMA."}
poma_res$distance_boxplot
```

```{r}
knitr::kable(poma_res$outliers, 
             caption = "Outliers detected by the POMA algorithm.", digits = 2)
```

To remove the outliers detected via the POMA algorithm, just put the data.table of the `detect_outliers_POMA()` function into the `remove_POMA_outliers()` function.

```{r}
se <- remove_POMA_outliers(se, poma_res$outliers)
```

# Session Info

```{r}
utils::sessionInfo()
```

# References

---
title: "Imputation"
author: 
- name: Lis Arend
bibliography: references.bib
biblio-style: apalike
link-citation: yes
colorlinks: yes
output: 
  bookdown::html_document2:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{4. Imputation}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---


```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)
```

# Load PRONE Package

```{r setup, message = FALSE}
library(PRONE)
```

# Load Data (TMT)

Here, we are directly working with the [SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html) data. For more information on how to create the SummarizedExperiment from a proteomics data set, please refer to the ["Get Started"](PRONE.html) vignette.

The example TMT data set originates from [@biadglegne_mycobacterium_2022].

```{r load_real_tmt}
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se
```

# Preprocessing 

As we have seen in the Preprocessing phase, that samples "1.HC_Pool1" and "1.HC_Pool2" have been removed from the data set due to their high amount of missing values (more than 80% of NAs per sample), before imputing the data we will here remove these two samples.

```{r}
se <- remove_samples_manually(se, "Label", c("1.HC_Pool1", "1.HC_Pool2"))
```

# Missigness in Proteomics Data

Since proteomics data is often affected by missing values and some statistical tests do not allow a high amount of missingness in the data, people have to options to reduce the amount of missingness in the data: (1) remove proteins with missing values or (2) impute missing values.

(1): this point is already shown in the Preprocessing tutorial, where we removed samples with a high amount of missing values using a predefined threshold.

(2): this point will be discussed here.


# Impute Data

Since the initial focus of PRONE was on the evaluation of the performance of normalization methods and a selection of methods was made based on an extensive literature review, the imputation methods are currently still limited. However, to ensure that PRONE offers all steps of a typical proteomics analysis workflow, we have included a basic imputation method since in some cases imputation is favored over removing a high amount of proteins. 

So currently, there is only a mixed imputation method available in PRONE: k-nearest neighbor imputation for proteins with missing values at random and a left-shifted Gaussian distribution for proteins with missing values not at random. Imputation can be performed on a selection of normalized data sets using the "ain" parameter in the `impute_SE` function. The default is to impute all assays (ain = NULL). 

```{r impute}
se <- impute_se(se, ain = NULL)
```

ATTENTION: 

Please note that imputation can introduce bias in the data and should be used with caution. After imputing your data, have a look at the exploratory data analysis plots (such as boxplots, PCA plots, etc.) to see if the imputation method has skewed the distributions of your samples and introduced biases in your data. These visualizations options are already shown in the ["Normalization"](Normalization.html) tutorial.


# Session Info

```{r}
utils::sessionInfo()
```

# References

---
title: "Normalization"
author: 
- name: Lis Arend
bibliography: references.bib
biblio-style: apalike
link-citation: yes
colorlinks: yes
output: 
  bookdown::html_document2:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{3. Normalization}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---


```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>", message = TRUE, warning = FALSE,
  fig.width=8,
  fig.height =6
)
```

# Load PRONE Package

```{r, message = FALSE}
# Load and attach PRONE
library(PRONE)
```

# Load Data (TMT)

Here, we are directly working with the [SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html) data. For more information on how to create the SummarizedExperiment from a proteomics data set, please refer to the ["Get Started"](PRONE.html) vignette.

The example TMT data set originates from [@biadglegne_mycobacterium_2022].

```{r load_real_tmt}
data("tuberculosis_TMT_se")
se <- tuberculosis_TMT_se
```

This SummarizedExperiment object already includes data of different normalization methods. Since this vignette should show you how to use the PRONE workflow for novel proteomics data, we will remove the normalized data and only keep the raw and log2 data that are available after loading the data accordingly. 

```{r, eval = TRUE, include = TRUE}
se <- subset_SE_by_norm(se, ain = c("raw", "log2"))
```


# Normalization

For normalization, there are multiple functions available which can be used to normalize the data. First of all, to know which normalization methods can be applied:

```{r}
get_normalization_methods()
```

You can use `normalize_se()` by specifying all normalization methods you want to apply on the data. For instance, if you want to perform RobNorm, median, and mean normalization, just execute this line:

```{r}
se_norm <- normalize_se(se, c("RobNorm", "Mean", "Median"), 
                        combination_pattern = NULL)
```

Tandem mass tag (TMT), a chemical labeling method that enables the simultaneous MS-analysis of up to 18 samples pooled together, is increasingly being applied in large-scale proteomic studies. Since the integration of multiple TMT batches within a single analysis leads to high batch variation and affects data quality, a batch effect correction method, such as internal reference scaling (IRS) or the `limma::removeBatchEffects` method (in PRONE: limBE), is required to adjust for these systematic biases. Commonly, batch effect correction is applied after basic normalization. However, the order of normalization and batch effect correction can be changed in PRONE.

For instance, if you want to perform IRS to reduce the batch effects on top of the previously normalized data, you can use the combination pattern "_on_".  

```{r}
se_norm <- normalize_se(se, c("RobNorm", "Mean", "Median", "IRS_on_RobNorm", 
                        "IRS_on_Mean", "IRS_on_Median"), 
                        combination_pattern = "_on_")
```


Finally, you can also normalize your data by applying the specific normalization method. This makes it possible to design the parameters of an individual function more specifically. For instance, if you want to normalize the data by the median, you can use the function `medianNorm()`. By default, median normalization is performed on raw-data. Using the individual normalization functions, you can easily specify

```{r}
se_norm <- medianNorm(se_norm, ain = "log2", aout = "Median")
```

All normalized intensities are stored in the SummarizedExperiment object and you can check the already performed normalization techniques using:

```{r}
names(assays(se_norm))
```

We suggest using the default value of the on_raw parameter. This parameter specifies whether the data should be normalized on raw or log2-transformed data. The default value of the "on_raw" parameters was made for each normalization method individually based on publications.


# Qualitative and Quantitative Evaluation

Sample distributions are often skewed due to the systematic biases introduced throughout all steps of an MS-experiment. To evaluate the performance of the normalization methods, the distribution of the normalized data can be visualized using boxplots. One would expect to align the sample distributions more closely after normalization.

Moreover, since normalization tries to remove the technical bias while keeping the biological variation, PCA plots of the log2-transformed data should be used to analyze if the technical bias is more prominent than the biological variation. After normalization, the samples should cluster according to the biological groups rather than the technical biases. So it may be helpful to analyze the PCA plots of the different normalization techniques to see which normalization method mostly reduced the technical bias.

Finally, the assessment of the normalization methods is commonly centered on their ability to decrease intragroup variation between samples, using intragroup pooled coefficient of variation (PCV), pooled estimate of variance (PEV), and pooled median absolute deviation (PMAD) as measures of variability. Furthermore, the Pearson correlation between samples is used to measure the similarity of the samples within the same group. A normalization method should reduce  intragroup variation between samples and increases the correlation between samples within the same group. However, please do not focus solely on intragroup variation, but also consider the other evaluation methods and perform differential expression analysis to further evaluate the methods and analyze the impact of normalization on the downstream results. More details on how to evaluate the performance of the normalization techniques are coming along with our paper. Once it is published, it will be referenced here.

Hence, PRONE offers many functions to comparatively evaluate the performance of the normalization methods. Notably, the parameter "ain" can always be set. By specifying "ain = NULL", all normalization methods that were previously performed and are saved in the SummarizedExperiment object are considered. If you want to evaluate only a selection of normalization methods, you can specify them in the "ain" parameter. For instance, if you want to evaluate only the IRS_on_RobNorm and Mean normalization methods, you can set "ain = c("IRS_on_RobNorm", "Mean")".

## Visual Inspection

You can comparatively visualize the normalized data by using the function `plot_boxplots()`, `plot_densities()`, and `plot_pca()`.

### Boxplots of Normalized Data

```{r, fig.cap = "Boxplots of protein intensities of all normalization methods of the SummarizedExperiment object. This plot shows the protein distributions across samples.", fig.height = 8}
plot_boxplots(se_norm, ain = NULL, color_by = NULL, 
              label_by = NULL, ncol = 3, facet_norm = TRUE) + 
  ggplot2::theme(legend.position = "bottom", legend.direction = "horizontal")

```

But you can also just plot a selection of normalization methods and color for instance by batch:

```{r, fig.cap = "Boxplots of protein intensities of a selection of normalization methods and colored by batch. This plot shows the protein distributions across samples."}
plot_boxplots(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
              color_by = "Pool", label_by = NULL, facet_norm = TRUE)
```

Another option that you have is to return the boxplots for each normalized data independently as a single ggplot object. For this, you need to set facet = FALSE:

```{r, fig.cap = "Single boxplot of protein intensities per selected normalization method and colored by batch .This plot shows the protein distributions across samples."}
plot_boxplots(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
              color_by = "Pool", label_by = NULL, facet_norm = FALSE)
```

### Densities of Normalized Data

Similarly you can visualize the densities of the normalized data.

```{r, fig.cap = "Density plot of protein intensities of for a selection of normalization method."}
plot_densities(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
               color_by = NULL, facet_norm = TRUE)
```

### PCA of Normalized Data

Furthermore, you can visualize the normalized data in a PCA plot. Here you have some more arguments that can be specified If you decide to visualize the methods in independent plots (facet_norm = FALSE), then a list of ggplot objects is returned. However, you have the additional option to facet by any other column of the metadata (using the facet_by parameter). Here an example:

```{r, fig.cap = "Single PCA plot per normalization method, colored and faceted by condition, and shaped by batch effect. This plot helps to identify batch effects."}
plot_PCA(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
         color_by = "Group", label_by = "No", shape_by = "Pool", 
         facet_norm = FALSE, facet_by = "Group")
```

Or you can simply plot the PCA of the normalized data next to each other. However, the facet_by argument can then not be used. Reminder, by setting color_by = NULL, it will be first checked if a condition has been set in the SummarizedExperiment during loading the data. 

```{r, fig.cap = "Combined PCA plot of a selection of normalization methods, colored by condition and shaped by batch effect. This plot helps to identify batch effects."}
plot_PCA(se_norm, ain = c("IRS_on_RobNorm", "IRS_on_Median"), 
         color_by = "Group", label_by = "No", shape_by = "Pool", 
         facet_norm = TRUE)
```


## Intragroup Variation

In PRONE, you can evaluate the intragroup variation of the normalized data by using the functions `plot_intragroup_correlation()`, `plot_intragroup_PCV()`, `plot_intragroup_PMAD()`, and `plot_intragroup_PEV()`.

```{r, fig.cap = "Intragroup similarity measured by Pearson correlation for all normalization methods of the SummarizedExperiment object. The correlation between samples within the same group was calculated for all normalization methods and sample groups.."}
plot_intragroup_correlation(se_norm, ain = NULL, condition = NULL, 
                            method = "pearson")
```

You have two options to visualize intragroup PCV, PEV, and PMAD. You can either simply generate boxplots of intragroup variation of each normalization method (diff = FALSE), or you can visualize the reduction of intragroup variation of each normalization method compared to log2 (diff = TRUE).

```{r, fig.cap = "Intragroup variation by calculation of the pooled coefficient of variation (PCV) for all normalization methods of the SummarizedExperiment object. The PCV was calculated for all normalization methods and sample groups."}
plot_intragroup_PCV(se_norm, ain = NULL, condition = NULL, diff = FALSE)
```

```{r, fig.cap = "Intragroup variation by calculation of the pooled estimate of variance (PEV) for all normalization methods of the SummarizedExperiment object. The PEV was calculated for all normalization methods and sample groups."}
plot_intragroup_PEV(se_norm, ain = NULL, condition = NULL, diff = FALSE)
```

```{r, fig.cap = "Intragroup variation by calculation of the pooled median absolute deviation (PMAD) for all normalization methods of the SummarizedExperiment object. The PMAD was calculated for all normalization methods and sample groups."}
plot_intragroup_PMAD(se_norm, ain = NULL, condition = NULL, diff = FALSE)
```

```{r, fig.cap = "Reduction of intragroup variation, here using PCV, for all normalization methods of the SummarizedExperiment object compared to log2."}
plot_intragroup_PCV(se_norm, ain = NULL, condition = NULL, diff = TRUE) 
```

```{r, fig.cap = "Reduction of intragroup variation, here using PEV, for all normalization methods of the SummarizedExperiment object compared to log2."}
plot_intragroup_PEV(se_norm, ain = NULL, condition = NULL, diff = TRUE)
```

```{r, fig.cap = "Reduction of intragroup variation, here using PMAD, for all normalization methods of the SummarizedExperiment object compared to log2."}
plot_intragroup_PMAD(se_norm, ain = NULL, condition = NULL, diff = TRUE)
```

# Subset SummarizedExperiment

After the qualitative and quantitative evaluation, you may have noticed that some normalization techniques are not appropriate for the specific real-world data set. For further analysis, you want to remove them and not evaluate the specific normalization methods furthermore. For this, the `remove_assays_from_SE()` method can be used. 

```{r}
se_no_MAD <- remove_assays_from_SE(se_norm, assays_to_remove = c("Mean"))
```

In contrast, you can also subset the SummarizedExperiment object to only include specific normalization techniques using the `subset_SE_by_norm()`method.

```{r}
se_subset <- subset_SE_by_norm(se_norm, 
                               ain = c("IRS_on_RobNorm", "IRS_on_Median"))
```

# Session Info

```{r}
utils::sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{spike_in_de_res}
\alias{spike_in_de_res}
\title{Example data.table of DE results of a spike-in proteomics data set}
\format{
An object of class \code{data.table} (inherits from \code{data.frame}) with 7500 rows and 10 columns.
}
\source{
Jürgen Cox, Marco Y. Hein, Christian A. Luber, Igor Paron, Nagarjuna Nagaraj, and Matthias Mann.Accurate Proteome-wide Label-free Quantification by Delayed Normalization and Maximal Peptide Ratio Extraction, Termed MaxLFQ. Molecular & Cellular Proteomics 13.9 (Sept. 2014), pp. 2513–2526. <https://doi.org/10.1074/mcp.M113.031591>.
}
\usage{
data(spike_in_de_res)
}
\description{
A \code{data.table} containing the DE results of the spike_in_se data set (limma, logFC > 1, logFC < -1, p.adj < 0.05)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{medianNorm}
\alias{medianNorm}
\title{Median Normalization}
\usage{
medianNorm(se, ain = "raw", aout = "Median", on_raw = TRUE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the median normalized data as assay (on log2 scale)
}
\description{
The intensity of each protein group in a given sample is divided by the median of the
intensities of all protein groups in that sample and then multiplied by the mean of
median of sum of intensities of all protein groups in all samples.
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- medianNorm(tuberculosis_TMT_se, ain = "raw",
                          aout = "Median", on_raw = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterSamples.R
\name{detect_outliers_POMA}
\alias{detect_outliers_POMA}
\title{Outlier detection via POMA R Package}
\usage{
detect_outliers_POMA(
  se,
  ain = "log2",
  condition = NULL,
  method = "euclidean",
  type = "median",
  group = TRUE,
  coeff = 1.5
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{String which data type should be used (default raw)}

\item{condition}{Column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{method}{String specifying the method that should be used to calculate the distance matrix}

\item{type}{String specifying the type of distance calculation to centroid or spatial median}

\item{group}{String specifying if the outlier detection should be performed multi-variate
(with conditions) or on the complete data set}

\item{coeff}{This value corresponds to the classical 1.5 in Q3 + 1.5 * IQR formula to detect outliers. By changing this value, the permissiveness in outlier detection will change.}
}
\value{
list of two ggplot objects and a data.table with outlier samples
}
\description{
Outlier detection via POMA R Package
}
\examples{
data(tuberculosis_TMT_se)
poma_res <- detect_outliers_POMA(tuberculosis_TMT_se, ain="raw",
                                 condition = NULL, method="euclidean",
                                 type="median", group=TRUE, coeff = 1.5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{run_DE}
\alias{run_DE}
\title{Run DE analysis of a selection of normalized data sets}
\usage{
run_DE(
  se,
  comparisons,
  ain = NULL,
  condition = NULL,
  DE_method = "limma",
  covariate = NULL,
  logFC = TRUE,
  logFC_up = 1,
  logFC_down = -1,
  p_adj = TRUE,
  alpha = 0.05,
  B = 100,
  K = 500,
  trend = TRUE,
  robust = TRUE,
  DEqMS_PSMs_column = NULL
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{comparisons}{Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{DE_method}{String specifying which DE method should be applied (limma, ROTS, DEqMS)}

\item{covariate}{String specifying which column to include as covariate into limma}

\item{logFC}{Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)}

\item{logFC_up}{Upper log2 fold change threshold (dividing into up regulated)}

\item{logFC_down}{Lower log2 fold change threshold (dividing into down regulated)}

\item{p_adj}{Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)}

\item{alpha}{Threshold for adjusted p-values or p-values}

\item{B}{Number of bootstrapping for ROTS}

\item{K}{Number of top-ranked features for reproducibility optimization}

\item{trend}{logical, should an intensity-dependent trend be allowed for the prior variance? If FALSE then the prior variance is constant. Alternatively, trend can be a row-wise numeric vector, which will be used as the covariate for the prior variance.}

\item{robust}{logical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?}

\item{DEqMS_PSMs_column}{String specifying which column name to use for DEqMS (default NULL).  Any column of the rowData(se) is accepted.}
}
\value{
Data table of DE results of selected normalized data sets
}
\description{
Run DE analysis of a selection of normalized data sets
}
\examples{
data(tuberculosis_TMT_se)
comparisons <- specify_comparisons(tuberculosis_TMT_se, condition = NULL,
                            sep = NULL, control = NULL)
de_res <- run_DE(tuberculosis_TMT_se, comparisons,
              ain = NULL, condition = NULL, DE_method = "limma",
              logFC = TRUE, logFC_up = 1, logFC_down = -1, p_adj = TRUE,
              alpha = 0.05, B = 100, K = 500, trend = TRUE, robust = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LoadData.R
\name{load_spike_data}
\alias{load_spike_data}
\title{Load spike-in proteomics data into a SummarizedExperiment}
\usage{
load_spike_data(
  data,
  md,
  spike_column,
  spike_value,
  spike_concentration,
  protein_column = "Protein.IDs",
  gene_column = "Gene.Names",
  ref_samples = NULL,
  batch_column = NULL,
  condition_column = NULL,
  label_column = NULL
)
}
\arguments{
\item{data}{tabular data table with rows = proteins and columns = samples (such as proteinGroups.txt of MaxQuant)}

\item{md}{experimental design table (requires a column named "Column" for the column names of the sample intensities in data)}

\item{spike_column}{name of the column specifying which proteins are the spike-ins}

\item{spike_value}{String value specifying the spike-in proteins in the spike-in column}

\item{spike_concentration}{name of the column in md defining the spike-in concentration per sample}

\item{protein_column}{name of the column in data containing the protein IDs}

\item{gene_column}{name of the column in data containing the gene names}

\item{ref_samples}{reference samples if TMT experiment provided (names of samples)}

\item{batch_column}{name of the column in md defining the batches}

\item{condition_column}{name of the column in md defining the condition (can still be changed afterwards)}

\item{label_column}{name of the column in md containing simple sample names (for visualization)}
}
\value{
SummarizedExperiment object
}
\description{
Load spike-in proteomics data into a SummarizedExperiment
}
\examples{
data_path <- readPRONE_example("Ecoli_human_MaxLFQ_protein_intensities.csv")
md_path <- readPRONE_example("Ecoli_human_MaxLFQ_metadata.csv")
data <- read.csv(data_path)
md <- read.csv(md_path)
mixed <- grepl("Homo sapiens.*Escherichia|Escherichia.*Homo sapiens", data$Fasta.headers)
data <- data[!mixed,]
data$Spiked <- rep("HUMAN", nrow(data))
data$Spiked[grepl("ECOLI", data$Fasta.headers)] <- "ECOLI"
se <- load_spike_data(data, md, spike_column = "Spiked", spike_value = "ECOLI", 
        spike_concentration = "Concentration", protein_column = "Protein.IDs", 
        gene_column = "Gene.names", ref_samples = NULL, batch_column = NULL, 
        condition_column = "Condition", label_column = "Label")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{get_shape_value}
\alias{get_shape_value}
\title{Helper function to get correct value for shaping of plots (shape_by parameter)}
\usage{
get_shape_value(se, shape_by)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{shape_by}{String specifying the column to shape the samples (If NULL or "No", no shaping is done.)}
}
\value{
String of column to shape or NULL if no shaping should be done
}
\description{
Helper function to get correct value for shaping of plots (shape_by parameter)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{perform_ROTS}
\alias{perform_ROTS}
\title{Performing ROTS}
\usage{
perform_ROTS(
  data,
  condition,
  comparisons,
  condition_name,
  coldata,
  logFC = TRUE,
  logFC_up = 1,
  logFC_down = -1,
  p_adj = TRUE,
  alpha = 0.05,
  B = 100,
  K = 500
)
}
\arguments{
\item{data}{Data table of intensities (rows = proteins, cols = samples)}

\item{condition}{Vector of experimental design specifying the condition(s) to compare}

\item{comparisons}{Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)}

\item{condition_name}{String of name of condition in colData}

\item{coldata}{colData of the SummarizedExperiment}

\item{logFC}{Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)}

\item{logFC_up}{Upper log2 fold change threshold (dividing into up regulated)}

\item{logFC_down}{Lower log2 fold change threshold (dividing into down regulated)}

\item{p_adj}{Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)}

\item{alpha}{Threshold for adjusted p-values or p-values}

\item{B}{Number of bootstrapping for ROTS}

\item{K}{Number of top-ranked features for reproducibility optimization}
}
\value{
Data table with DE results
}
\description{
Performing ROTS
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{filter_out_complete_NA_proteins}
\alias{filter_out_complete_NA_proteins}
\title{Remove proteins with NAs in all samples}
\usage{
filter_out_complete_NA_proteins(se)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}
}
\value{
filtered SummarizedExperiment object
}
\description{
Remove proteins with NAs in all samples
}
\examples{
data(tuberculosis_TMT_se)
tuberulosis_TMT_se <- filter_out_complete_NA_proteins(tuberculosis_TMT_se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{get_color_value}
\alias{get_color_value}
\title{Helper function to get correct value for coloration of plots (color_by parameter)}
\usage{
get_color_value(se, color_by)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}
}
\value{
String of column to color or NULL if no color should be applied
}
\description{
Helper function to get correct value for coloration of plots (color_by parameter)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{get_normalization_methods}
\alias{get_normalization_methods}
\title{Function to return available normalization methods' identifier names}
\usage{
get_normalization_methods()
}
\value{
Vector of normalization methods
}
\description{
Function to return available normalization methods' identifier names
}
\examples{
get_normalization_methods()
  

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Imputation.R
\name{impute_se}
\alias{impute_se}
\title{Method to impute SummarizedExperiment. 
This method performs a mixed imputation on the proteins. It uses a k-nearest neighbor imputation for proteins with missing values at random (MAR) and imputes missing values by random draws from a left-shifted Gaussian distribution for proteins with missing values not at random (MNAR).}
\usage{
impute_se(se, ain = NULL, condition = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics dataset}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{condition}{name of column of colData(se) representing the conditions of the data}
}
\value{
SummarizedExperiment with imputed intensities
}
\description{
Method to impute SummarizedExperiment. 
This method performs a mixed imputation on the proteins. It uses a k-nearest neighbor imputation for proteins with missing values at random (MAR) and imputes missing values by random draws from a left-shifted Gaussian distribution for proteins with missing values not at random (MNAR).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- remove_samples_manually(tuberculosis_TMT_se,
                          column = "Label", values = c("1.HC_Pool1"))
tuberculosis_TMT_se <- impute_se(tuberculosis_TMT_se, ain = NULL,
                          condition = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubsetSE.R
\name{subset_SE_by_norm}
\alias{subset_SE_by_norm}
\title{Subset SummarizedExperiment object by normalization assays}
\usage{
subset_SE_by_norm(se, ain)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Character vector of assay names to keep in the SummarizedExperiment object}
}
\value{
SummarizedExperiment object with only the selected normalization assays
}
\description{
Subset SummarizedExperiment object by normalization assays
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- subset_SE_by_norm(tuberculosis_TMT_se,
                          ain = c("raw", "log2", "IRS_on_RobNorm"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{plot_NA_heatmap}
\alias{plot_NA_heatmap}
\title{Plot heatmap of the NA pattern}
\usage{
plot_NA_heatmap(
  se,
  color_by = NULL,
  label_by = NULL,
  cluster_samples = TRUE,
  cluster_proteins = TRUE,
  show_row_dend = TRUE,
  show_column_dend = FALSE,
  col_vector = NULL
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)}

\item{cluster_samples}{Boolean. TRUE if samples should be clustered, else FALSE.}

\item{cluster_proteins}{Boolean. TRUE if proteins should be clustered, else FALSE.}

\item{show_row_dend}{Boolean. TRUE if row dendrogram should be shown.}

\item{show_column_dend}{Boolean. TRUE if column dendrogram should be shown.}

\item{col_vector}{Vector of colors for the color bar. If NULL, default colors are used.}
}
\value{
ComplexHeatmap plot (only showing proteins with at least one missing value)
}
\description{
Plot heatmap of the NA pattern
}
\examples{
data(tuberculosis_TMT_se)
plot_NA_heatmap(tuberculosis_TMT_se, color_by = NULL,
                label_by = NULL, cluster_samples = TRUE,
                cluster_proteins = TRUE, show_row_dend = TRUE,
                show_column_dend = FALSE,
                col_vector = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GetOverview.R
\name{plot_upset}
\alias{plot_upset}
\title{Create an UpSet Plot from SummarizedExperiment Data}
\usage{
plot_upset(
  se,
  color_by = NULL,
  label_by = NULL,
  mb.ratio = c(0.7, 0.3),
  only_refs = FALSE
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used.)}

\item{label_by}{String specifying the column in the metadata used to label the samples for the UpSet plot}

\item{mb.ratio}{A numeric vector of length 2, specifying the barplot and matrix area ratios}

\item{only_refs}{Logical, if TRUE, only reference samples (ComRef) are included in the plot}
}
\value{
ggplot object
}
\description{
This function generates an UpSet plot from a given SummarizedExperiment object.
It allows for the visualization of overlaps between sets defined by a specific
column in the metadata. The function supports subsetting to reference samples
and customizable color mapping.
}
\examples{
data(tuberculosis_TMT_se)
plot_upset(tuberculosis_TMT_se, color_by = NULL, label_by = NULL,
           mb.ratio = c(0.7, 0.3), only_refs = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationPlots.R
\name{plot_PCA}
\alias{plot_PCA}
\title{PCA plot of the normalized data}
\usage{
plot_PCA(
  se,
  ain = NULL,
  color_by = NULL,
  label_by = NULL,
  shape_by = NULL,
  facet_norm = TRUE,
  facet_by = NULL,
  ellipse = FALSE,
  ncol = 3
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)}

\item{shape_by}{String specifying the column to shape the samples (If NULL or "No", no shaping of samples is done.)}

\item{facet_norm}{Boolean specifying whether to facet by normalization methods (default TRUE). If FALSE, list of plots of the different normalized data is returned. However, then you can also facet by any column of the metadata.}

\item{facet_by}{String specifying the column to facet the samples (If facet = FALSE, the plot will not be faceted by the normalization methods, but instead a list of plots of each normalization method is returned. Then, the PCA plot
can be faceted by any column of the metadata, for instance by "Batch". If facet_by is NULL or "No", no faceting is performed.)}

\item{ellipse}{Boolean to indicate if ellipses should be drawn}

\item{ncol}{Number of columns in plot (for faceting)}
}
\value{
if facet_norm = TRUE, ggplot object, else list of ggplot objects
}
\description{
PCA plot of the normalized data
}
\examples{
data(tuberculosis_TMT_se)
plot_PCA(tuberculosis_TMT_se, ain = NULL, color_by = NULL, label_by = NULL,
         shape_by = "Pool",
         facet_norm = TRUE, ncol = 3)
plot_PCA(tuberculosis_TMT_se, ain = c("IRS_on_RobNorm"), color_by = "Group",
              label_by = "Label", facet_norm = FALSE, facet_by = "Pool")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{spectraCounteBayes_DEqMS}
\alias{spectraCounteBayes_DEqMS}
\title{Additional function of the DEqMS package}
\usage{
spectraCounteBayes_DEqMS(fit, coef_col)
}
\arguments{
\item{fit}{linear model from function perform_limma}

\item{coef_col}{an integer vector indicating the column(s) of fit$coefficients for which the function is to be performed. if not specified, all coefficients are used.}
}
\value{
list object
}
\description{
Additional function of the DEqMS package
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{tmmNorm}
\alias{tmmNorm}
\title{Weighted Trimmed Mean of M Values (TMM) Normalization of edgeR package.}
\usage{
tmmNorm(se, ain = "raw", aout = "TMM", on_raw = TRUE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the TMM normalized data as assay (on log2 scale)
}
\description{
Raw data should be taken as input (on_raw = TRUE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- tmmNorm(tuberculosis_TMT_se, ain = "raw",
                                  aout = "TMM", on_raw = TRUE)

}
\seealso{
\code{\link[edgeR]{calcNormFactors}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEPlots.R
\name{plot_heatmap_DE}
\alias{plot_heatmap_DE}
\title{Heatmap of DE results}
\usage{
plot_heatmap_DE(
  se,
  de_res,
  ain,
  comparison,
  condition = NULL,
  label_by = NULL,
  pvalue_column = "adj.P.Val",
  col_vector = NULL
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set (including the normalized intensities)}

\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparison}{String of comparison (must be a valid comparison saved in de_res)}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)}

\item{pvalue_column}{column name of p-values in de_res}

\item{col_vector}{Vector of colors to use for the heatmap. If NULL, default colors are used.}
}
\value{
list of ComplexHeatmaps for each method
}
\description{
Heatmap of DE results
}
\examples{
data(tuberculosis_TMT_se)
data(tuberculosis_TMT_de_res)
plot_heatmap_DE(tuberculosis_TMT_se, tuberculosis_TMT_de_res, ain = NULL,
                comparison = "PTB-HC",
                condition = NULL, label_by = NULL,
                pvalue_column = "adj.P.Val", col_vector = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeOverview.R
\name{plot_profiles_spiked}
\alias{plot_profiles_spiked}
\title{Plot profiles of the spike-in and background proteins using the log2 average protein intensities as a function of the different concentrations.}
\usage{
plot_profiles_spiked(se, xlab = "Concentration")
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{xlab}{String for the x-label of the plot}
}
\value{
ggplot object
}
\description{
Plot profiles of the spike-in and background proteins using the log2 average protein intensities as a function of the different concentrations.
}
\examples{
data(spike_in_se)
plot_profiles_spiked(spike_in_se, xlab = "Concentration")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationPlots.R
\name{plot_intragroup_PEV}
\alias{plot_intragroup_PEV}
\title{Plot intragroup pooled estimate of variance (PEV) of the normalized data}
\usage{
plot_intragroup_PEV(se, ain = NULL, condition = NULL, diff = FALSE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{diff}{Boolean indicating whether to visualize the reduction of intragroup variation (PEV) compared to "log" (TRUE) or a normal boxplot of intragroup variation (PEV) for each normalization method (FALSE).}
}
\value{
ggplot object (boxplot)
}
\description{
Plot intragroup pooled estimate of variance (PEV) of the normalized data
}
\examples{
data(tuberculosis_TMT_se)
plot_intragroup_PEV(tuberculosis_TMT_se, ain = NULL,
                            condition = NULL, diff = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{plot_TP_FP_spiked_bar}
\alias{plot_TP_FP_spiked_bar}
\title{Barplot of true and false positives for specific comparisons and normalization methods}
\usage{
plot_TP_FP_spiked_bar(stats, ain = NULL, comparisons = NULL)
}
\arguments{
\item{stats}{data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in stats)}
}
\value{
ggplot object (barplot)
}
\description{
Barplot of true and false positives for specific comparisons and normalization methods
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
plot_TP_FP_spiked_bar(stats, ain = NULL, comparisons = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{normicsNorm}
\alias{normicsNorm}
\title{Normics Normalization (Normics using VSN or using Median)}
\usage{
normicsNorm(
  se,
  ain = "raw",
  aout = "NormicsVSN",
  method = "NormicsVSN",
  on_raw = TRUE,
  reduce_correlation_by = 1,
  NormicsVSN_quantile = 0.8,
  TMT_ratio = FALSE,
  top_x = 50
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{method}{String specifying the method to use (NORMICS or NORMICSmedian)}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}

\item{reduce_correlation_by}{If the data is too big for the computation of the params, increase this parameter by 2,3,4.... The whole data will still be normalized, but the params are calculated on every second row etc.}

\item{NormicsVSN_quantile}{The quantile that is used for the resistant least trimmed sum of squares regression. A value of 0.8 means focusing on the central 80\% of the data, reducing the influence of outliers.}

\item{TMT_ratio}{Indicates if the data involves Tandem Mass Tag (TMT) ratio-based measurements (common in proteomics). If TRUE, the method may handle the data differently.}

\item{top_x}{Number of reference proteins extracted for the calculation of parameters}
}
\value{
SummarizedExperiment containing the NormicsVSN/NormicsMedian normalized data as assay (on log2 scale)
}
\description{
Log2-scaled data should be used as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- normicsNorm(tuberculosis_TMT_se, ain = "raw",
                                aout = "NormicsVSN", method = "NormicsVSN",
                                on_raw = TRUE)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeOverview.R
\name{plot_identified_spiked_proteins}
\alias{plot_identified_spiked_proteins}
\title{Plot number of identified spike-in proteins per sample.}
\usage{
plot_identified_spiked_proteins(se, color_by = NULL, label_by = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)#'}
}
\value{
ggplot object
}
\description{
Plot number of identified spike-in proteins per sample.
}
\examples{
data(spike_in_se)
plot_identified_spiked_proteins(spike_in_se, color_by = NULL,
                                label_by = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterSamples.R
\name{remove_POMA_outliers}
\alias{remove_POMA_outliers}
\title{Remove outliers samples detected by the detect_outliers_POMA function}
\usage{
remove_POMA_outliers(se, poma_res_outliers)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{poma_res_outliers}{Outliers data.table returned by the detect_outliers_POMA function}
}
\value{
filtered SummarizedExperiment object
}
\description{
Remove outliers samples detected by the detect_outliers_POMA function
}
\examples{
data(tuberculosis_TMT_se)
poma_res <- detect_outliers_POMA(tuberculosis_TMT_se)
tuberculosis_TMT_se <- remove_POMA_outliers(tuberculosis_TMT_se, poma_res$outliers)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{rlrMACycNorm}
\alias{rlrMACycNorm}
\title{Cyclic Linear Regression Normalization on MA Transformed Data}
\usage{
rlrMACycNorm(
  se,
  ain = "log2",
  aout = "RlrMACyc",
  on_raw = FALSE,
  iterations = 3
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}

\item{iterations}{Number of cyclic iterations to be performed}
}
\value{
SummarizedExperiment containing the RlrMACyc normalized data as assay (on log2 scale)
}
\description{
No reference, but MA transformation and normalization
of samples is done pairwise between two samples with A = average of two samples and M = difference. The process is iterated through all samples pairs.
Log2 data should be taken as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- rlrMACycNorm(tuberculosis_TMT_se, ain = "log2",
                            aout = "RlrMACyc", on_raw = FALSE, iterations=3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{rlrNorm}
\alias{rlrNorm}
\title{Robust Linear Regression Normalization of NormalyzerDE.}
\usage{
rlrNorm(se, ain = "log2", aout = "Rlr", on_raw = FALSE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the rlr normalized data as assay (on log2 scale)
}
\description{
Uses median values over all samples as reference
sample to which all the other samples in the data are normalized to. Log2 data should be taken as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- rlrNorm(tuberculosis_TMT_se, ain = "log2",
                                            aout = "Rlr", on_raw = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterSamples.R
\name{remove_reference_samples}
\alias{remove_reference_samples}
\title{Remove reference samples of SummarizedExperiment object (reference samples specified during loading)}
\usage{
remove_reference_samples(se)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}
}
\value{
filtered SummarizedExperiment object
}
\description{
Remove reference samples of SummarizedExperiment object (reference samples specified during loading)
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- remove_reference_samples(tuberculosis_TMT_se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{get_overview_DE}
\alias{get_overview_DE}
\title{Get overview table of DE results}
\usage{
get_overview_DE(de_res)
}
\arguments{
\item{de_res}{data table resulting of run_DE}
}
\value{
data table of numbers of DE proteins per comparison and per normalization method
}
\description{
Get overview table of DE results
}
\examples{
data(tuberculosis_TMT_de_res)
get_overview_DE(tuberculosis_TMT_de_res)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GetOverview.R
\name{get_NA_overview}
\alias{get_NA_overview}
\title{Function returning some values on the numbers of NA in the data}
\usage{
get_NA_overview(se, ain = "log2")
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{String which data type should be used (default raw)}
}
\value{
list with total amount of values in the data, amount of NA values, and the percentage of NAs
}
\description{
Function returning some values on the numbers of NA in the data
}
\examples{
data(tuberculosis_TMT_se)
get_NA_overview(tuberculosis_TMT_se, ain="log2")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationPlots.R
\name{plot_boxplots}
\alias{plot_boxplots}
\title{Plot the distributions of the normalized data as boxplots}
\usage{
plot_boxplots(
  se,
  ain = NULL,
  color_by = NULL,
  label_by = NULL,
  facet_norm = TRUE,
  ncol = 3
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)}

\item{facet_norm}{Boolean specifying whether to facet by normalization methods (default TRUE). If FALSE, list of plots of the different normalized data is returned.}

\item{ncol}{Number of columns in plot (for faceting)}
}
\value{
if facet_norm = TRUE, ggplot object, else list of ggplot objects
}
\description{
Plot the distributions of the normalized data as boxplots
}
\examples{
data(tuberculosis_TMT_se)
plot_boxplots(tuberculosis_TMT_se, ain = NULL, color_by = NULL, label_by = NULL,
              facet_norm = TRUE, ncol = 3)
plot_boxplots(tuberculosis_TMT_se, ain = c("log2", "IRS_on_RobNorm"), color_by = "Pool",
              label_by = "Label", facet_norm = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{tuberculosis_TMT_se}
\alias{tuberculosis_TMT_se}
\title{Example SummarizedExperiment of a real-world proteomics data set}
\format{
An object of class \code{SummarizedExperiment} with 301 rows and 20 columns.
}
\source{
Biadglegne et al. Mycobacterium tuberculosis Affects Protein and Lipid Content of Circulating Exosomes in Infected Patients Depending on Tuberculosis Disease State. Biomedicines 10.4 (Mar. 2022), p. 783. doi: 10.3390/ biomedicines10040783.
}
\usage{
data(tuberculosis_TMT_se)
}
\description{
A \code{SummarizedExperiment} containing the raw and log2-scaled data of 301 proteins measured in 20 samples
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{plot_NA_frequency}
\alias{plot_NA_frequency}
\title{Plot protein identification overlap (x = identified in number of Samples, y=number of proteins)}
\usage{
plot_NA_frequency(se)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}
}
\value{
ggplot object
}
\description{
Plot protein identification overlap (x = identified in number of Samples, y=number of proteins)
}
\examples{
data(tuberculosis_TMT_se)
plot_NA_frequency(tuberculosis_TMT_se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{rlrMANorm}
\alias{rlrMANorm}
\title{Linear Regression Normalization on MA Transformed Data}
\usage{
rlrMANorm(se, ain = "log2", aout = "RlrMA", on_raw = FALSE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the RlrMA normalized data as assay (on log2 scale)
}
\description{
Similar to Rlr, but data are MA transformed before normalization,
(A = median sample, M = difference of that sample to A). Log2 data should be taken as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- rlrMANorm(tuberculosis_TMT_se, ain = "log2",
                                  aout = "RlrMA", on_raw = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEPlots.R
\name{plot_volcano_DE}
\alias{plot_volcano_DE}
\title{Volcano plots of DE results}
\usage{
plot_volcano_DE(
  de_res,
  ain = NULL,
  comparisons = NULL,
  facet_norm = TRUE,
  facet_comparison = FALSE
)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}

\item{facet_norm}{Boolean indicating whether to facet by normalization method (TRUE) or not (FALSE)}

\item{facet_comparison}{Boolean indicating whether to facet by comparison (TRUE) or not (FALSE). Only valid if facet_norm = FALSE.}
}
\value{
list of ggplot objects
}
\description{
Volcano plots of DE results
}
\examples{
data(tuberculosis_TMT_de_res)
plot_volcano_DE(tuberculosis_TMT_de_res, ain = NULL,
                comparisons = NULL, facet_norm = TRUE,
                facet_comparison = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{plot_logFC_thresholds_spiked}
\alias{plot_logFC_thresholds_spiked}
\title{Line plot of number of true and false positives when applying different logFC thresholds}
\usage{
plot_logFC_thresholds_spiked(
  se,
  de_res,
  condition,
  ain = NULL,
  comparisons = NULL,
  nrow = 2,
  alpha = 0.05
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{de_res}{data table resulting of run_DE}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in stats)}

\item{nrow}{number of rows for facet wrap}

\item{alpha}{threshold for adjusted p-values}
}
\value{
list of ggplot objects
}
\description{
Line plot of number of true and false positives when applying different logFC thresholds
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
plot_logFC_thresholds_spiked(spike_in_se, spike_in_de_res,
                             condition = "Condition", ain = NULL,
                             comparisons = NULL, nrow = 2, alpha = 0.05)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterSamples.R
\name{plot_tot_int_samples}
\alias{plot_tot_int_samples}
\title{Plot total protein intensity per sample}
\usage{
plot_tot_int_samples(se, ain = "raw", color_by = NULL, label_by = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{String which data type should be used (default raw)}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)}
}
\value{
list of a ggplot object and the dataframe of outliers
}
\description{
Plot total protein intensity per sample
}
\examples{
data(tuberculosis_TMT_se)
plot_tot_int_samples(tuberculosis_TMT_se, ain="raw", color_by = NULL,
                     label_by = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GetOverview.R
\name{plot_condition_overview}
\alias{plot_condition_overview}
\title{Barplot showing the number of samples per condition}
\usage{
plot_condition_overview(se, condition = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}
}
\value{
ggplot object
}
\description{
Barplot showing the number of samples per condition
}
\examples{
data(tuberculosis_TMT_se)
plot_condition_overview(tuberculosis_TMT_se, condition = NULL)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Download.R
\name{export_data}
\alias{export_data}
\title{Export the SummarizedExperiment object, the meta data, and the normalized data.}
\usage{
export_data(se, out_dir, ain = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{out_dir}{Path of output directory}

\item{ain}{Vector of strings which assay should be downloaded (default NULL).
If NULL then all assays of the se object are saved.}
}
\value{
Nothing
}
\description{
Export the SummarizedExperiment object, the meta data, and the normalized data.
}
\examples{
data(tuberculosis_TMT_se)
\dontrun{export_data(tuberculosis_TMT_se, out_dir = "data/",
            ain = c("IRS_on_RobNorm", "IRS_on_Median"))}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{limmaNorm}
\alias{limmaNorm}
\title{limma::removeBatchEffects (limBE)}
\usage{
limmaNorm(se, ain = "log2", aout = "limBE", on_raw = FALSE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the limBE normalized data as assay (on log2 scale)
}
\description{
Log2-scaled data should be used as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- limmaNorm(tuberculosis_TMT_se, ain = "log2",
                                      aout = "limBE", on_raw = FALSE)

}
\seealso{
\code{\link[limma]{removeBatchEffect}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{extract_limma_DE}
\alias{extract_limma_DE}
\title{Extract the DE results from eBayes fit of perform_limma function.}
\usage{
extract_limma_DE(
  fit,
  comparisons,
  logFC = TRUE,
  logFC_up = 1,
  logFC_down = -1,
  p_adj = TRUE,
  alpha = 0.05
)
}
\arguments{
\item{fit}{eBayes object resulting from perform_limma method}

\item{comparisons}{Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)}

\item{logFC}{Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)}

\item{logFC_up}{Upper log2 fold change threshold (dividing into up regulated)}

\item{logFC_down}{Lower log2 fold change threshold (dividing into down regulated)}

\item{p_adj}{Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)}

\item{alpha}{Threshold for adjusted p-values or p-values}
}
\value{
Data table with limma DE results
}
\description{
Extract the DE results from eBayes fit of perform_limma function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{check_plot_DE_parameters}
\alias{check_plot_DE_parameters}
\title{Helper function to check the parameters for plotting the DE results}
\usage{
check_plot_DE_parameters(de_res, ain, comparisons)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{String of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}
}
\value{
list of valid inputs for plotting functions
}
\description{
Helper function to check the parameters for plotting the DE results
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{perform_DEqMS}
\alias{perform_DEqMS}
\title{Perform DEqMS}
\usage{
perform_DEqMS(
  fit,
  se,
  DEqMS_PSMs_column = NULL,
  logFC = TRUE,
  logFC_up = 1,
  logFC_down = -1,
  p_adj = TRUE,
  alpha = 0.05
)
}
\arguments{
\item{fit}{eBayes object resulting from perform_limma method}

\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{DEqMS_PSMs_column}{String specifying which column name to use for DEqMS (default NULL). Any column of the rowData(se) is accepted.}

\item{logFC}{Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)}

\item{logFC_up}{Upper log2 fold change threshold (dividing into up regulated)}

\item{logFC_down}{Lower log2 fold change threshold (dividing into down regulated)}

\item{p_adj}{Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)}

\item{alpha}{Threshold for adjusted p-values or p-values}
}
\value{
data.table of DE results
}
\description{
Perform DEqMS
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEIntersection.R
\name{plot_upset_DE}
\alias{plot_upset_DE}
\title{Upset plots of DE results of the different normalization methods}
\usage{
plot_upset_DE(
  de_res,
  ain = NULL,
  comparisons = NULL,
  min_degree = 2,
  plot_type = "single"
)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}

\item{min_degree}{Minimal degree of an intersection for it to be included}

\item{plot_type}{String indicating whether to plot a single plot per comparison ("single") or stack the number of DE per comparison ("stacked)}
}
\value{
list of plots and intersection tables (split by comparison if plot_type == "single)
}
\description{
Upset plots of DE results of the different normalization methods
}
\examples{
data(tuberculosis_TMT_de_res)
plot_upset_DE(tuberculosis_TMT_de_res,
              ain = c("IRS_on_RobNorm", "IRS_on_Median"),
              comparisons = NULL, min_degree = 2,
              plot_type = "stacked")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{plot_NA_density}
\alias{plot_NA_density}
\title{Plot the intensity distribution of proteins with and without NAs}
\usage{
plot_NA_density(se)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}
}
\value{
ggplot object
}
\description{
Plot the intensity distribution of proteins with and without NAs
}
\examples{
data(tuberculosis_TMT_se)
plot_NA_density(tuberculosis_TMT_se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{globalMedianNorm}
\alias{globalMedianNorm}
\title{Total Intensity Normalization Using the Median for the Calculation of Scaling Factors}
\usage{
globalMedianNorm(se, ain = "raw", aout = "GlobalMedian", on_raw = TRUE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the total intensity normalized data as assay (on log2 scale)
}
\description{
Intensities of each variable in a sample are divided with the sum of intensities
of all variables in the sample and multiplied with the median of sum of intensities
of all variables in all samples. Raw data should be taken as input (on_raw = TRUE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- globalMedianNorm(tuberculosis_TMT_se, ain = "raw",
                              aout = "GlobalMedian", on_raw = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationPlots.R
\name{get_complete_pca_dt}
\alias{get_complete_pca_dt}
\title{Function to get a long data table of all PCA1 and PCA2 values of all kind of normalization}
\usage{
get_complete_pca_dt(se, ain = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{String which assay should be used as input (default NULL)
If NULL then all normalization of the SummarizedExperiment object are plotted next to each other (except raw).}
}
\value{
data table
}
\description{
Function to get a long data table of all PCA1 and PCA2 values of all kind of normalization
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LoadData.R
\name{load_data}
\alias{load_data}
\title{Load real-world proteomics data into a SummarizedExperiment}
\usage{
load_data(
  data,
  md,
  protein_column = "Protein.IDs",
  gene_column = "Gene.Names",
  ref_samples = NULL,
  batch_column = NULL,
  condition_column = NULL,
  label_column = NULL
)
}
\arguments{
\item{data}{tabular data table with rows = proteins and columns = samples (such as proteinGroups.txt of MaxQuant)}

\item{md}{experimental design table (requires a column named "Column" for the column names of the sample intensities in data)}

\item{protein_column}{name of the column in data containing the protein IDs}

\item{gene_column}{name of the column in data containing the gene names}

\item{ref_samples}{reference samples if TMT experiment provided (names of samples)}

\item{batch_column}{name of the column in md defining the batches}

\item{condition_column}{name of the column in md defining the condition (can still be changed afterwards)}

\item{label_column}{name of the column in md containing simple sample names (for visualization)}
}
\value{
SummarizedExperiment object
}
\description{
Load real-world proteomics data into a SummarizedExperiment
}
\examples{
data_path <- readPRONE_example("tuberculosis_protein_intensities.csv")
md_path <- readPRONE_example("tuberculosis_metadata.csv")
data <- read.csv(data_path)
md <- read.csv(md_path)
md$Column <- stringr::str_replace_all(md$Column, " ", ".")
ref_samples <- md[md$Group == "ref",]$Column
se <- load_data(data, md, protein_column = "Protein.IDs",
               gene_column = "Gene.names", ref_samples = ref_samples,
               batch_column = "Pool", condition_column = "Group",
               label_column = "Label")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{get_spiked_stats_DE}
\alias{get_spiked_stats_DE}
\title{Get performance metrics of DE results of spike-in data set.}
\usage{
get_spiked_stats_DE(se, de_res)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{de_res}{data table resulting of run_DE}
}
\value{
data table with multiple performance metrics of the DE results
}
\description{
Get performance metrics of DE results of spike-in data set.
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{plot_ROC_AUC_spiked}
\alias{plot_ROC_AUC_spiked}
\title{Plot ROC curve and barplot of AUC values for each method for a specific comparion or for all comparisons}
\usage{
plot_ROC_AUC_spiked(se, de_res, ain = NULL, comparisons = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in stats)}
}
\value{
list of ggplot objects
}
\description{
Plot ROC curve and barplot of AUC values for each method for a specific comparion or for all comparisons
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
plot_ROC_AUC_spiked(spike_in_se, spike_in_de_res)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationPlots.R
\name{plot_densities}
\alias{plot_densities}
\title{Plot the densities of the normalized data}
\usage{
plot_densities(se, ain = NULL, color_by = NULL, facet_norm = TRUE, ncol = 3)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{facet_norm}{Boolean specifying whether to facet by normalization methods (default TRUE). If FALSE, list of plots of the different normalized data is returned.}

\item{ncol}{Number of columns in plot (for faceting)}
}
\value{
if facet_norm = TRUE, ggplot object, else list of ggplot objects
}
\description{
Plot the densities of the normalized data
}
\examples{
data(tuberculosis_TMT_se)
plot_densities(tuberculosis_TMT_se, ain = NULL, color_by = NULL,
                          facet_norm = TRUE, ncol = 3)
plot_densities(tuberculosis_TMT_se, ain = c("log2", "IRS_on_RobNorm"),
                          color_by = "Label",
              facet_norm = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{check_DE_parameters}
\alias{check_DE_parameters}
\title{Check parameters for DE analysis}
\usage{
check_DE_parameters(
  se,
  ain = NULL,
  condition = NULL,
  comparisons = NULL,
  DE_method = "limma",
  covariate = NULL,
  logFC = TRUE,
  logFC_up = 1,
  logFC_down = -1,
  p_adj = TRUE,
  p_adj_method = "BH",
  alpha = 0.05,
  B = 100,
  K = 500,
  DEqMS_PSMs_column = NULL
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{comparisons}{Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)}

\item{DE_method}{String specifying which DE method should be applied (limma, ROTS, DEqMS)}

\item{covariate}{String specifying which column to include as covariate into limma}

\item{logFC}{Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)}

\item{logFC_up}{Upper log2 fold change threshold (dividing into up regulated)}

\item{logFC_down}{Lower log2 fold change threshold (dividing into down regulated)}

\item{p_adj}{Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)}

\item{p_adj_method}{String specifying the method for adjusted p-values}

\item{alpha}{Threshold for adjusted p-values or p-values}

\item{B}{Number of bootstrapping for ROTS}

\item{K}{Number of top-ranked features for reproducibility optimization}

\item{DEqMS_PSMs_column}{String specifying which column name to use for DEqMS (default NULL)}
}
\value{
list of checked assays and condition column name
}
\description{
Check parameters for DE analysis
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{apply_thresholds}
\alias{apply_thresholds}
\title{Apply other thresholds to DE results}
\usage{
apply_thresholds(
  de_res,
  logFC = TRUE,
  logFC_up = 1,
  logFC_down = -1,
  p_adj = TRUE,
  alpha = 0.05
)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{logFC}{Boolean specifying whether to apply a logFC threshold (TRUE) or not (FALSE)}

\item{logFC_up}{Upper log2 fold change threshold (dividing into up regulated)}

\item{logFC_down}{Lower log2 fold change threshold (dividing into down regulated)}

\item{p_adj}{Boolean specifying whether to apply a threshold on adjusted p-values (TRUE) or on raw p-values (FALSE)}

\item{alpha}{Threshold for adjusted p-values or p-values}
}
\value{
data table updating the Change column with the newly applied thresholds
}
\description{
Apply other thresholds to DE results
}
\examples{
data(tuberculosis_TMT_de_res)
de_res <- apply_thresholds(tuberculosis_TMT_de_res, logFC = FALSE,
                           p_adj = TRUE, alpha = 0.01)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{normalize_se}
\alias{normalize_se}
\title{Normalize SummarizedExperiment object using single normalization methods or specified combinations of normalization methods}
\usage{
normalize_se(
  se,
  methods,
  combination_pattern = "_on_",
  on_raw = NULL,
  gamma.0 = 0.1,
  reduce_correlation_by = 1,
  NormicsVSN_quantile = 0.8,
  top_x = 50,
  VSN_quantile = 0.9
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{methods}{Vector of normalization methods to apply for normalizing the proteomics data of the SummarizedExperiment object (identifier of normalization methods can be retrieved using get_normalization_methods())}

\item{combination_pattern}{String specifying how normalization methods are combined. For instance, methods = c("IRS", "Median_on_IRS"), combination_pattern = "_on_".}

\item{on_raw}{Logical indicating if the normalization should be performed on the raw data or on log2-transformed data. If on_raw = NULL(default), the normalization is performed on the default method specific on_raw setting (suggestion based on publications).}

\item{gamma.0}{Numeric representing the exponent of the weighted density of RobNorm normalization. When the sample size is small, the fitted population of some proteins could be locally trapped such that the variance of those proteins was very small under a large gamma. To avoid this, a small gamma is recommended. When sample size smaller than 40, then set gamma to 0.5 or 0.1.}

\item{reduce_correlation_by}{If the data is too big for the computation of the params, increase this parameter by 2,3,4.... The whole data will still be normalized, but the params are calculated on every second row etc.}

\item{NormicsVSN_quantile}{The quantile that is used for the resistant least trimmed sum of squares regression. A value of 0.8 means focusing on the central 80\% of the data, reducing the influence of outliers.}

\item{top_x}{Number of reference proteins extracted for the calculation of parameters}

\item{VSN_quantile}{Numeric of length 1. The quantile that is used for the resistant least trimmed sum of squares regression (see vsn2 lts.quantile)}
}
\value{
SummarizedExperiment object with normalized data saved as assays
}
\description{
Normalize SummarizedExperiment object using single normalization methods or specified combinations of normalization methods
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- normalize_se(tuberculosis_TMT_se,
           methods = c("IRS_on_GlobalMedian", "IRS_on_Median",
           "limBE_on_NormicsVSN"), on_raw = NULL,
           combination_pattern = "_on_", gamma.0 = 0.1,
           reduce_correlation_by = 1, NormicsVSN_quantile = 0.8, top_x = 50,
           VSN_quantile = 0.9)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{robnormNorm}
\alias{robnormNorm}
\title{RobNorm Normalization}
\usage{
robnormNorm(se, ain = "log2", aout = "RobNorm", on_raw = FALSE, gamma.0 = 0.1)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}

\item{gamma.0}{Numeric representing the exponent of the weighted density. When the sample size
is small, the fitted population of some proteins could be locally trapped such
that the variance of those proteins was very small under a large gamma. To avoid
this, a small gamma is recommended. When sample size smaller than 40, then set
gamma to 0.5 or 0.1.}
}
\value{
SummarizedExperiment containing the RobNorm normalized data as assay (on log2 scale)
}
\description{
Log2-scaled data should be used as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- robnormNorm(tuberculosis_TMT_se, ain = "log2",
                            aout = "RobNorm", on_raw = FALSE, gamma.0 = 0.1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{get_label_value}
\alias{get_label_value}
\title{Helper function to get correct value for sample labeling of plots (label_by parameter)}
\usage{
get_label_value(se, label_by)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{label_by}{String specifying the column to label the samples (If NULL, the labels column of the SummarizedExperiment object is used. If "No", no labeling of samples done.)}
}
\value{
String of column to label or NULL if no label should be applied
}
\description{
Helper function to get correct value for sample labeling of plots (label_by parameter)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterSamples.R
\name{remove_samples_manually}
\alias{remove_samples_manually}
\title{Remove samples with specific value in column manually}
\usage{
remove_samples_manually(se, column, values)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{column}{String specifying the column of the meta data (samples with the specified value in this column will be removed)}

\item{values}{Vector of Strings specifying the value for the removal of samples (samples with this value in the specified column will be removed)}
}
\value{
filtered SummarizedExperiment object
}
\description{
Remove samples with specific value in column manually
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- remove_samples_manually(tuberculosis_TMT_se,
                                column = "Label", values = c("1.HC_Pool1"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Enrichment.R
\name{plot_intersection_enrichment}
\alias{plot_intersection_enrichment}
\title{Functional enrichment analysis for analyzing the DE results of different normalization methods and biologically interpreting the results}
\usage{
plot_intersection_enrichment(
  se,
  de_res,
  comparison,
  ain = NULL,
  id_column = "Gene.Names",
  organism = "hsapiens",
  source = "KEGG",
  signif_thr = 0.05
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{de_res}{data table resulting of run_DE}

\item{comparison}{String of comparison (must be a valid comparison saved in de_res)}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{id_column}{String specifying the column of the rowData of the SummarizedExperiment object which includes the gene names}

\item{organism}{Organism name (gprofiler parameter)}

\item{source}{Data source to use (gprofiler parameter, example: KEGG)}

\item{signif_thr}{Significance threshold}
}
\value{
list of ggplot objects
}
\description{
Functional enrichment analysis for analyzing the DE results of different normalization methods and biologically interpreting the results
}
\examples{
data(tuberculosis_TMT_se)
data(tuberculosis_TMT_de_res)
plot_intersection_enrichment(tuberculosis_TMT_se, tuberculosis_TMT_de_res,
                ain = c("IRS_on_Median", "IRS_on_RobNorm", "RobNorm"),
                comparison = "Rx-TBL", id_column = "Gene.Names",
                organism = "hsapiens", source = "GO:BP", signif_thr = 0.05)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GetOverview.R
\name{plot_heatmap}
\alias{plot_heatmap}
\title{Plot a heatmap of the sample intensities with optional column annotations for a selection of normalization methods}
\usage{
plot_heatmap(
  se,
  ain = NULL,
  color_by = c("Group", "Pool"),
  label_by = NULL,
  only_refs = FALSE
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}

\item{color_by}{Vector of strings specifying the columns to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bars added.)}

\item{label_by}{String specifying the column in the metadata used to label the samples for the UpSet plot}

\item{only_refs}{Logical, if TRUE, only reference samples (ComRef) are included in the plot}
}
\value{
list of ggplot objects
}
\description{
Plot a heatmap of the sample intensities with optional column annotations for a selection of normalization methods
}
\examples{
data(tuberculosis_TMT_se)
plot_heatmap(tuberculosis_TMT_se, ain = c("log2"), color_by = NULL,
             label_by = NULL, only_refs = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEIntersection.R
\name{extract_consensus_DE_candidates}
\alias{extract_consensus_DE_candidates}
\title{Extract consensus DE candidates}
\usage{
extract_consensus_DE_candidates(
  de_res,
  ain = NULL,
  comparisons = NULL,
  norm_thr = 0.8,
  per_comparison = FALSE
)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}

\item{norm_thr}{Threshold for the number of normalization methods that must agree on a DE candidate}

\item{per_comparison}{Logical indicating if the consensus should be calculated per comparison}
}
\value{
data table with consensus DE candidates
}
\description{
Extract consensus DE candidates
}
\examples{
data(tuberculosis_TMT_de_res)
extract_consensus_DE_candidates(tuberculosis_TMT_de_res, ain = NULL,
                  comparisons = NULL, norm_thr = 0.8, per_comparison = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{tuberculosis_TMT_de_res}
\alias{tuberculosis_TMT_de_res}
\title{Example data.table of DE results of a real-world proteomics data set}
\format{
An object of class \code{data.table} (inherits from \code{data.frame}) with 9030 rows and 9 columns.
}
\source{
Biadglegne et al. Mycobacterium tuberculosis Affects Protein and Lipid Content of Circulating Exosomes in Infected Patients Depending on Tuberculosis Disease State. Biomedicines 10.4 (Mar. 2022), p. 783. doi: 10.3390/ biomedicines10040783.
}
\usage{
data(tuberculosis_TMT_de_res)
}
\description{
A \code{data.table} containing the DE results of the tuberculosis_TMT_se data set (limma, logFC > 1, logFC < -1, p.adj < 0.05)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEIntersection.R
\name{plot_jaccard_heatmap}
\alias{plot_jaccard_heatmap}
\title{Jaccard similarity heatmap of DE proteins of the different normalization methods}
\usage{
plot_jaccard_heatmap(
  de_res,
  ain = NULL,
  comparisons = NULL,
  plot_type = "single"
)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}

\item{plot_type}{String indicating whether to plot a single plot per comparison ("single"), facet by comparison ("facet_comp"), or include all comparisons in a single plot ("all")}
}
\value{
ggplot object (list of objects if plot_type == "single)
}
\description{
Jaccard similarity heatmap of DE proteins of the different normalization methods
}
\examples{
data(tuberculosis_TMT_de_res)
plot_jaccard_heatmap(tuberculosis_TMT_de_res, ain = NULL,
                    comparisons = NULL, plot_type = "all")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubsetSE.R
\name{remove_assays_from_SE}
\alias{remove_assays_from_SE}
\title{Remove normalization assays from a SummarizedExperiment object}
\usage{
remove_assays_from_SE(se, assays_to_remove)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{assays_to_remove}{Character vector of assay names to remove from the SummarizedExperiment object}
}
\value{
SummarizedExperiment object with the normalization assays removed
}
\description{
Remove normalization assays from a SummarizedExperiment object
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- remove_assays_from_SE(tuberculosis_TMT_se,
                                 assays_to_remove = c("IRS_on_RobNorm"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{plot_stats_spiked_heatmap}
\alias{plot_stats_spiked_heatmap}
\title{Heatmap of performance metrics for spike-in data sets}
\usage{
plot_stats_spiked_heatmap(
  stats,
  ain = NULL,
  comparisons = NULL,
  metrics = c("Accuracy", "Precision", "F1Score")
)
}
\arguments{
\item{stats}{data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in stats)}

\item{metrics}{vector of Strings specifying the metrics (must be colnames of stats)}
}
\value{
ggplot object
}
\description{
Heatmap of performance metrics for spike-in data sets
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
plot_stats_spiked_heatmap(stats, ain = NULL, comparisons = NULL,
                          metrics = c("F1Score", "Accuracy"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RobNorm.R
\name{RobNorm}
\alias{RobNorm}
\title{Original RobNorm Function}
\usage{
RobNorm(X.0, gamma.0 = 0.5, tol = 10^(-4), step = 200)
}
\arguments{
\item{X.0}{The expression matrix in log scale.}

\item{gamma.0}{The density exponent parameter gamma, in practice, taking gamma.0 = 0.5 or 1.}

\item{tol}{The tolerance for interations (default: 10^(-4)).}

\item{step}{The step limit (default: 50).}
}
\value{
Normalized expression data
}
\description{
To robustly normalize expression data (Author: Meng Wang, https://github.com/mwgrassgreen/RobNorm).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{get_condition_value}
\alias{get_condition_value}
\title{Helper function to check the condition value}
\usage{
get_condition_value(se, condition)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}
}
\value{
String of column for condition
}
\description{
Helper function to check the condition value
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{filter_out_NA_proteins_by_threshold}
\alias{filter_out_NA_proteins_by_threshold}
\title{Filter proteins based on their NA pattern using a specific threshold}
\usage{
filter_out_NA_proteins_by_threshold(se, thr = 0.8)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{thr}{Threshold for the minimum fraction of valid values allowed for any protein}
}
\value{
filtered SummarizedExperiment object
}
\description{
Filter proteins based on their NA pattern using a specific threshold
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- filter_out_NA_proteins_by_threshold(tuberculosis_TMT_se,
                                                       thr = 0.8)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{plot_pvalues_spiked}
\alias{plot_pvalues_spiked}
\title{Boxplot of p-values of spike-in and background proteins for specific normalization methods and comparisons. The ground truth (calculated based on the concentrations of the spike-ins) is shown as a horizontal line.}
\usage{
plot_pvalues_spiked(se, de_res, ain = NULL, comparisons = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in stats)}
}
\value{
ggplot object
}
\description{
Boxplot of p-values of spike-in and background proteins for specific normalization methods and comparisons. The ground truth (calculated based on the concentrations of the spike-ins) is shown as a horizontal line.
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
plot_pvalues_spiked(spike_in_se, spike_in_de_res, ain = NULL,
                    comparisons = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{check_DEqMS_parameter}
\alias{check_DEqMS_parameter}
\title{Helper function to check whether the DEqMS_PSMs_column is in the SummarizedExperiment object}
\usage{
check_DEqMS_parameter(se, DEqMS_PSMs_column)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{DEqMS_PSMs_column}{String specifying which column name to use for DEqMS (default NULL)}
}
\value{
None
}
\description{
Helper function to check whether the DEqMS_PSMs_column is in the SummarizedExperiment object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEPlots.R
\name{plot_overview_DE_bar}
\alias{plot_overview_DE_bar}
\title{Overview plots of DE results}
\usage{
plot_overview_DE_bar(
  de_res,
  ain = NULL,
  comparisons = NULL,
  plot_type = "single"
)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}

\item{plot_type}{String indicating whether to plot a single plot per comparison ("single"), facet by comparison ("facet_comp"), stack the number of DE per comparison ("stacked"), or stack the number of DE per comparison but facet by up- and down-regulated ("facet_regulation")}
}
\value{
list of ggplot objects or single object if plot_type = facet or stacked
}
\description{
Overview plots of DE results
}
\examples{
data(tuberculosis_TMT_de_res)
plot_overview_DE_bar(tuberculosis_TMT_de_res, ain = NULL, comparisons = NULL,
                     plot_type = "facet_regulation")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{specify_comparisons}
\alias{specify_comparisons}
\title{Create vector of comparisons for DE analysis (either by single condition (sep = NULL) or by combined condition)}
\usage{
specify_comparisons(se, condition = NULL, sep = NULL, control = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{condition}{Column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}

\item{sep}{Separator that separates both groups in the condition vector (NULL if condition composed only of single group)}

\item{control}{String of control samples (how the control condition is named) (NULL if no control sample)}
}
\value{
Vector of comparisons for DE analysis
}
\description{
Create vector of comparisons for DE analysis (either by single condition (sep = NULL) or by combined condition)
}
\examples{
data(tuberculosis_TMT_se)
comparisons <- specify_comparisons(tuberculosis_TMT_se, condition = NULL,
                            sep = NULL, control = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{filter_out_proteins_by_ID}
\alias{filter_out_proteins_by_ID}
\title{Remove proteins by their ID}
\usage{
filter_out_proteins_by_ID(se, protein_ids)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{protein_ids}{Vector of protein IDs that should be kept}
}
\value{
filtered SummarizedExperiment object
}
\description{
Remove proteins by their ID
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- filter_out_proteins_by_ID(tuberculosis_TMT_se,
                                protein_ids = c("P0A8V2", "P0A8V2"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{readPRONE_example}
\alias{readPRONE_example}
\title{Helper function to read example data}
\usage{
readPRONE_example(path = NULL)
}
\arguments{
\item{path}{NULL to get all example data set files, otherwise specify the file name}
}
\value{
If path=NULL a character vector with the file names, otherwise the path to the specific file
}
\description{
Helper function to read example data
}
\examples{
readPRONE_example()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeOverview.R
\name{plot_histogram_spiked}
\alias{plot_histogram_spiked}
\title{Plot histogram of the spike-in and background protein intensities per condition.}
\usage{
plot_histogram_spiked(se, condition = NULL)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{condition}{column name of condition (if NULL, condition saved in SummarizedExperiment will be taken)}
}
\value{
ggplot object
}
\description{
Plot histogram of the spike-in and background protein intensities per condition.
}
\examples{
data(spike_in_se)
plot_histogram_spiked(spike_in_se, condition = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FilterProteins.R
\name{get_proteins_by_value}
\alias{get_proteins_by_value}
\title{Get proteins by value in specific column}
\usage{
get_proteins_by_value(se, column_name = "Reverse", values = c("+"))
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{column_name}{name of column of which proteins with a specific value should be identified}

\item{values}{value of the column defining the proteins that should be identified}
}
\value{
vector of protein IDs
}
\description{
Get proteins by value in specific column
}
\examples{
data(tuberculosis_TMT_se)
proteins <- get_proteins_by_value(tuberculosis_TMT_se,
                      column_name = "Potential.contaminant", values = c("+"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{check_input_assays}
\alias{check_input_assays}
\title{Helper function to check whether all given assays are in SummarizedExperiment object}
\usage{
check_input_assays(se, ain)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{ain}{Vector of strings which assay should be used as input (default NULL).
If NULL then all normalization of the se object are plotted next to each other.}
}
\value{
NULL if no methods in SummarizedExperiment object, else all available methods ready for visualization
}
\description{
Helper function to check whether all given assays are in SummarizedExperiment object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEAnalysis.R
\name{perform_limma}
\alias{perform_limma}
\title{Fitting a linear model using limma}
\usage{
perform_limma(
  data,
  condition_vector,
  comparisons,
  covariate = NULL,
  trend = TRUE,
  robust = TRUE
)
}
\arguments{
\item{data}{Data table of intensities (rows = proteins, cols = samples)}

\item{condition_vector}{Vector of experimental design specifying the condition(s) to compare}

\item{comparisons}{Vector of comparisons that are performed in the DE analysis (from specify_comparisons method)}

\item{covariate}{String specifying which column to include as covariate into limma}

\item{trend}{logical, should an intensity-dependent trend be allowed for the prior variance? If FALSE then the prior variance is constant. Alternatively, trend can be a row-wise numeric vector, which will be used as the covariate for the prior variance.}

\item{robust}{logical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?}
}
\value{
eBayes object
}
\description{
Fitting a linear model using limma
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{eigenMSNorm}
\alias{eigenMSNorm}
\title{EigenMS Normalization}
\usage{
eigenMSNorm(se, ain = "log2", aout = "EigenMS", on_raw = FALSE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}
}
\value{
SummarizedExperiment containing the EigenMS normalized data as assay (on log2 scale)
}
\description{
EigenMS fits an analysis of variance model to estimate the effects of the experimental factors on the data using the
knowledge about the experimental design, and then applies singular value decomposition to identify systematic trends 
contributing to significant variation not explained by the experimental factors Log2-scaled data should be used as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- eigenMSNorm(tuberculosis_TMT_se, ain = "log2",
                                    aout = "EigenMS", on_raw = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DEPlots.R
\name{plot_overview_DE_tile}
\alias{plot_overview_DE_tile}
\title{Overview heatmap plot of DE results}
\usage{
plot_overview_DE_tile(de_res, ain = NULL, comparisons = NULL)
}
\arguments{
\item{de_res}{data table resulting of run_DE}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in de_res)}
}
\value{
ggplot object
}
\description{
Overview heatmap plot of DE results
}
\examples{
data(tuberculosis_TMT_de_res)
plot_overview_DE_tile(tuberculosis_TMT_de_res, ain = NULL,
                      comparisons = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{tib_to_DF}
\alias{tib_to_DF}
\title{Helper function to transform a tibble to a data table}
\usage{
tib_to_DF(expr_data, column_names, row_names)
}
\arguments{
\item{expr_data}{Tibble data frame containing the expression data}

\item{column_names}{Column names of the expression data}

\item{row_names}{Row names of the expression data}
}
\value{
Data table containing the expression data
}
\description{
Helper function to transform a tibble to a data table
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{medianAbsDevNorm}
\alias{medianAbsDevNorm}
\title{Median Absolute Deviation Normalization}
\usage{
medianAbsDevNorm(se, ain = "log2", aout = "MAD", on_raw = FALSE)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scale data}
}
\value{
SummarizedExperiment containing the MAD normalized data as assay (on log2 scale)
}
\description{
Substracts the median and divides the data by the median absolute deviation (MAD). Log2-scaled data should be used as input (on_raw = FALSE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- medianAbsDevNorm(tuberculosis_TMT_se, ain = "log2",
                                              aout = "MAD", on_raw = FALSE)

}
\seealso{
\code{\link[NormalyzerDE]{performSMADNormalization}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpikeDEPlots.R
\name{plot_TP_FP_spiked_scatter}
\alias{plot_TP_FP_spiked_scatter}
\title{Scatterplot of true positives and false positives (median with errorbars as Q1, and Q3) for all comparisons}
\usage{
plot_TP_FP_spiked_scatter(stats, ain = NULL, comparisons = NULL)
}
\arguments{
\item{stats}{data table with multiple metrics of the DE results (resulting of get_spiked_stats_DE)}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in stats)}

\item{comparisons}{Vector of comparisons (must be valid comparisons saved in stats)}
}
\value{
ggplot object
}
\description{
Scatterplot of true positives and false positives (median with errorbars as Q1, and Q3) for all comparisons
}
\examples{
data(spike_in_se)
data(spike_in_de_res)
stats <- get_spiked_stats_DE(spike_in_se, spike_in_de_res)
plot_TP_FP_spiked_scatter(stats, ain = NULL, comparisons = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{spike_in_se}
\alias{spike_in_se}
\title{Example SummarizedExperiment of a spike-in proteomics data set}
\format{
An object of class \code{SummarizedExperiment} with 1500 rows and 6 columns.
}
\source{
Jürgen Cox, Marco Y. Hein, Christian A. Luber, Igor Paron, Nagarjuna Nagaraj, and Matthias Mann.Accurate Proteome-wide Label-free Quantification by Delayed Normalization and Maximal Peptide Ratio Extraction, Termed MaxLFQ. Molecular & Cellular Proteomics 13.9 (Sept. 2014), pp. 2513–2526. <https://doi.org/10.1074/mcp.M113.031591>.
}
\usage{
data(spike_in_se)
}
\description{
A \code{SummarizedExperiment} containing the raw and log2-scaled data of 301 proteins measured in 20 samples. Due to size restriction, we only included the relevant columns of the original proteinGroups.txt of MaxQuant.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GetOverview.R
\name{plot_markers_boxplots}
\alias{plot_markers_boxplots}
\title{Boxplots of intensities of specific markers}
\usage{
plot_markers_boxplots(
  se,
  markers,
  ain = NULL,
  id_column = "Protein.IDs",
  color_by = NULL,
  shape_by = NULL,
  facet_norm = TRUE,
  facet_marker = FALSE
)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomics data set}

\item{markers}{Vector of the IDs of the markers to plot}

\item{ain}{Vector of strings of normalization methods to visualize (must be valid normalization methods saved in de_res)}

\item{id_column}{String specifying the column of the rowData of the SummarizedExperiment object which includes the IDs of the markers}

\item{color_by}{String specifying the column to color the samples (If NULL, the condition column of the SummarizedExperiment object is used. If "No", no color bar added.)}

\item{shape_by}{String specifying the column to shape the samples (If NULL or "No", no shaping of samples is done.)}

\item{facet_norm}{Boolean indicating whether to facet by normalization method (TRUE) or not (FALSE)}

\item{facet_marker}{Boolean indicating whether to facet by comparison (TRUE) or not (FALSE). Only valid if facet_norm = FALSE.}
}
\value{
ggplot object
}
\description{
Boxplots of intensities of specific markers
}
\examples{
data(tuberculosis_TMT_se)
plot_markers_boxplots(tuberculosis_TMT_se, markers = c("Q7Z7F0", "Q13790"),
                     ain = c("log2"), id_column = "Protein.IDs",
                     color_by = NULL,
                     shape_by = "Pool",
                     facet_norm = FALSE,
                     facet_marker = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NormalizationMethods.R
\name{vsnNorm}
\alias{vsnNorm}
\title{Variance Stabilization Normalization of limma package.}
\usage{
vsnNorm(se, ain = "raw", aout = "VSN", on_raw = TRUE, VSN_quantile = 0.9)
}
\arguments{
\item{se}{SummarizedExperiment containing all necessary information of the proteomic dataset}

\item{ain}{String which assay should be used as input}

\item{aout}{String which assay should be used to save normalized data}

\item{on_raw}{Boolean specifying whether normalization should be performed on raw or log2-scaled data}

\item{VSN_quantile}{Numeric of length 1. The quantile that is used for the resistant least trimmed sum of squares regression (see vsn2 lts.quantile)}
}
\value{
SummarizedExperiment containing the vsn normalized data as assay (on log2-scale)
}
\description{
Raw data should be taken as input (on_raw = TRUE).
}
\examples{
data(tuberculosis_TMT_se)
tuberculosis_TMT_se <- vsnNorm(tuberculosis_TMT_se, ain = "raw",
                            aout = "VSN", on_raw = TRUE, VSN_quantile = 0.9)

}
\seealso{
\code{\link[limma]{normalizeVSN}()}
}
